freeslot("tol_smash", "tol_smashcoop")

G_AddGametype({
    name = "Smash",
    identifier = "smash",
    typeoflevel = TOL_SMASH,
    rules = GTR_LIVES|GTR_DEATHMATCHSTARTS|GTR_HURTMESSAGES|GTR_SPAWNENEMIES,
    rankingtype = GT_MATCH,
	intermissiontype = int_match,
	defaultpointlimit = 0,
	defaulttimelimit = 7,
    headerleftcolor = 37,
    headerrightcolor = 51,
    description = 'Attack opposing players with your moves to deal damage! The higher your percent, the more you will be flung away!'
})

G_AddGametype({
    name = "Team Smash",
    identifier = "teamsmash",
    typeoflevel = TOL_SMASH,
    rules = GTR_LIVES|GTR_DEATHMATCHSTARTS|GTR_HURTMESSAGES|GTR_SPAWNENEMIES,
    rankingtype = GT_MATCH,
	intermissiontype = int_match,
	defaultpointlimit = 0,
	defaulttimelimit = 7,
    headerleftcolor = 37,
    headerrightcolor = 131,
    description = 'Stick together to attack your enemies and blow them off the stage!'
})

G_AddGametype({
    name = "Stamina",
    identifier = "stamina",
    typeoflevel = TOL_SMASH,
    rules = GTR_LIVES|GTR_DEATHMATCHSTARTS|GTR_HURTMESSAGES|GTR_SPAWNENEMIES,
    rankingtype = GT_MATCH,
	intermissiontype = int_match,
	defaultpointlimit = 0,
	defaulttimelimit = 7,
    headerleftcolor = 102,
    headerrightcolor = 37,
    description = 'Each hit will take a chunk of HP off the opponent! Throw them off the stage or deplete their HP to win!'
})

G_AddGametype({
    name = "Team Stamina",
    identifier = "teamstamina",
    typeoflevel = TOL_SMASH,
    rules = GTR_LIVES|GTR_DEATHMATCHSTARTS|GTR_HURTMESSAGES|GTR_SPAWNENEMIES,
    rankingtype = GT_MATCH,
	intermissiontype = int_match,
	defaultpointlimit = 0,
	defaulttimelimit = 7,
    headerleftcolor = 102,
    headerrightcolor = 131,
    description = 'Stick together with your allies to steal the opposing team of their HP!'
})

G_AddGametype({
    name = "Team Adventure",
    identifier = "adventure",
    typeoflevel = TOL_SMASHCOOP,
    rules = GTR_LIVES|GTR_DEATHMATCHSTARTS|GTR_HURTMESSAGES|GTR_SPAWNENEMIES,
    rankingtype = GT_MATCH,
	intermissiontype = int_match,
	defaultpointlimit = 0,
	defaulttimelimit = 7,
    headerleftcolor = 102,
    headerrightcolor = 131,
    description = "Cooperate with the entire server to take down your foes!"
})

local s = SRB2Smash

// This is a gamemode that uses percentage.
s.usesPercent = function()
	if gametype == GT_SMASH or gametype == GT_TEAMSMASH
		return true
	end

	return false
end

// This is a gamemode that uses stamina
s.usesStamina = function()
	if gametype == GT_STAMINA or gametype == GT_TEAMSTAMINA
		return true
	end

	return false
end

// FFA gamemode
s.isFFA = function()
	if gametype == GT_SMASH or gametype == GT_STAMINA
		return true
	end
	
	return false
end

// team gamemode
s.isTeam = function()
	if gametype == GT_TEAMSMASH or gametype == GT_TEAMSTAMINA
		return true
	end
	
	return false
end

// adventure gamemode
s.isAdventure = function()
	if gametype == GT_ADVENTURE
		return true
	end
	
	return false
end

// In a Smash Bros Gamemode
s.isSmash = function()
	if gametype == GT_SMASH or gametype == GT_TEAMSMASH or gametype == GT_STAMINA or gametype == GT_TEAMSTAMINA
		return true
	end

	return false
end