local s = SRB2Smash

s.chars["baseModCharWithNoDefs"] = {
	-- General Stats
	["speed"] = 5,
	["weight"] = 5,
	["hud"] = "SONIC",
	["winbg"] = {0, -80, "SKY2"},

	-- Attacks
	["jab1"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 30*sin(p.mo.angle), 0, 15*FRACUNIT,
				20*FRACUNIT, 3, 1, FRACUNIT/5, FRACUNIT/3, false, sfx_punch1, "punch")
				
				hitbox.fuse = 5
			elseif timer == 10
				return true
			end
			
			p.mo.state = S_PLAY_STND
			p.drawangle = p.mo.angle+ANGLE_45
		end
	},

	["jab2"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 30*sin(p.mo.angle), 0, 15*FRACUNIT,
				32*FRACUNIT, 3, 1, FRACUNIT/5, FRACUNIT/3, nil, sfx_punch1, "punch")
				
				hitbox.fuse = 5
			elseif timer == 10
				return true
			end
			
			p.mo.state = S_PLAY_STND
			p.drawangle = p.mo.angle-ANGLE_45
		end,
	},

	["jab3"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 30*sin(p.mo.angle), 0, 15*FRACUNIT,
				p.mo.height, 5, 2, 7*FRACUNIT, 5*FRACUNIT, nil, sfx_punch1, "punch")
				
				hitbox.fuse = 5
			elseif timer == 15
				p.mo.state = S_PLAY_STND
				return true
			end
			
			p.mo.state = S_PLAY_NIGHTS_DRILL
		end,
	},
	
	["dash"] = {
		nomove = true,
		superarmor = true,
		anim = function(p, timer)
			if timer < 15
				P_InstaThrust(p.mo, p.mo.angle, 19*FRACUNIT)
				
				p.mo.state = S_PLAY_ROLL
				local orb = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SMASH_DUMMY)
				orb.fuse = 2
				orb.sprite = SPR_FIRS
				orb.frame = FF_FULLBRIGHT|S
				orb.angle = p.mo.angle

				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius, p.mo.height,
				2, 3, p.speed, 2*FRACUNIT, false, sfx_fire1, "fire")
				hitbox.hitcool = 1
				hitbox.hitlag = 4
				hitbox.fuse = 2
			else
				local hitbox = s.drawHitBox(p, p.mo.radius, 0, 0, p.mo.radius*2,
				p.mo.height, 2, 3, 10*FRACUNIT, 4*FRACUNIT, true, sfx_fire3, "fire-sweet")
				hitbox.hitcool = 1
				hitbox.hitlag = 4
				hitbox.fuse = 2

				p.mo.hitcool = 4
				p.mo.state = S_PLAY_RUN
				if timer >= 19 then return true end
			end
		end
	},

	["uptilt"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius,
				p.mo.height + 10*FRACUNIT, 4, 2, P_RandomRange(-3, 3)*FRACUNIT, 10*FRACUNIT, true,
				sfx_punch2, "punch")
				hitbox.fuse = 8
				
				local sweet = s.drawHitBox(p, 0, 0, 0, 10*FRACUNIT, p.mo.height + 10*FRACUNIT,
				8, 3, P_RandomRange(-1, 1)*FRACUNIT, 12*FRACUNIT, true, sfx_punch2, "sweet")
				sweet.fuse = 5
				P_SetObjectMomZ(p.mo, 3*FRACUNIT)
			elseif timer == 16
				p.mo.state = S_PLAY_STND
				return true
			end
			
			if P_IsObjectOnGround(p.mo)
				p.mo.state = S_PLAY_CROUCH
			else
				p.mo.state = S_PLAY_SPRING
				p.drawangle = timer*ANGLE_45
			end
		end,
	},
	
	["neutralair"] = {
		nogroundreset = true,
		anim = function(p, timer)
			p.mo.state = S_PLAY_ROLL

			if timer == 2
				local hitbox = s.drawHitBox(p, 0, 0, -p.mo.height/2, (p.mo.radius*5)/2,
				(p.mo.height*3)/2, 5, 2, nil, nil, true, sfx_kick1, "punch")
				hitbox.fuse = 8
			end
			
			if timer < 14
				if not p.mo.instaShield
					p.mo.instaShield = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_INSTASHIELD)				
					S_StartSound(p.mo, sfx_s3k42)
				else
					if p.mo.instaShield.valid
						P_TeleportMove(p.mo.instaShield, p.mo.x, p.mo.y, p.mo.z)
					else
						p.mo.instaShield = nil
					end
				end
			end

			if timer >= 25
				if P_IsObjectOnGround(p.mo)
					p.mo.state = S_PLAY_STND
				else
					p.mo.state = S_PLAY_FALL
				end
				
				return true
			end				
		end
	},

	["upair"] = {
		anim = function(p, timer)
			if timer == 1
				p.mo.state = S_PLAY_SONIC_UPAIR
				local hitbox = s.drawHitBox(p, 0, 0, p.mo.height-(5*FRACUNIT),
				p.mo.radius*2, 25*FRACUNIT, 5, 2, P_RandomRange(-1, 1)*FRACUNIT,
				12*FRACUNIT, true, sfx_punch2, "punch")
				hitbox.fuse = 6
			elseif timer == 13
				p.mo.state = S_PLAY_FALL
			elseif timer == 16
				return true
			end
		end,
	},
	
	["downair"] = {
		anim = function(p, timer)
			if timer == 1
				P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z-26*FRACUNIT, MT_SUPERSPARK)
			end

			if timer < 10
				p.mo.frame = A
				p.mo.state = S_PLAY_RIDE
				p.mo.sprite2 = SPR2_RIDE
			elseif timer == 10
				p.mo.momz = $/2
				p.mo.state = S_PLAY_FALL

				local hitbox = s.drawHitBox(p, 0, 0, -25*FRACUNIT, p.mo.radius,
				25*FRACUNIT, 6, 2, P_RandomRange(-10, 10)*FRACUNIT, -1, true,
				sfx_kick2, "punch")
				hitbox.fuse = 8

				local spike = s.drawHitBox(p, 0, 0, -33*FRACUNIT, p.mo.radius-20*FRACUNIT,
				12*FRACUNIT, 9, 3, 0, -25*FRACUNIT, true, sfx_kick3, "spike")
				spike.fuse = 5
			elseif timer == 20
				p.mo.state = S_PLAY_JUMP
				return true
			end
		end,
	},
	
	["sideair"] = {
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 20*cos(p.mo.angle), 20*sin(p.mo.angle),
				0, 20*FRACUNIT, p.mo.height, 7, 2, 10*FRACUNIT, 2*FRACUNIT, true, sfx_kick2, "punch")
				hitbox.fuse = 8
			elseif timer == 16
				p.mo.state = S_PLAY_FALL
				return true
			end

			if timer < 10 then p.mo.state = S_PLAY_NIGHTS_DRILL end
		end,
	},

	["neutralspecial"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer <= 30
				p.mo.state = S_PLAY_SPINDASH
				p.drawangle = timer*ANGLE_45
			end

			if timer == 30
				local tornado = s.fireMissile(p.mo, MT_SONICTORNADO, 4)
				if tornado and tornado.valid
					tornado.user = p.mo
					tornado.fuse = 35
				end
			end
			
			if timer >= 50
				p.mo.state = S_PLAY_STND
				return true
			end
		end,
		desc = {
			name = "Neutral Special",
			txt = "Fire a tornado with your... idk. This needs time to charge up and to finish, so it is advised you do NOT use this offstage!"
		}
	},

	["upspecial"] = {
		nomove = true,
		nogroundreset = true,
		noreuse = true,
		anim = function(p, timer)
			if timer == 1
				for i = 1, 36
					local dust = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SPINDUST)
					P_InstaThrust(dust, i*10*ANG1, 20*FRACUNIT)
				end				
				
				local hitbox = s.drawHitBox(p, 20*cos(p.mo.angle), 
				20*sin(p.mo.angle), -10*FRACUNIT, p.mo.radius, p.mo.height+20*FRACUNIT, 
				8, 3, p.speed, p.mo.momz, true, sfx_punch2, "punch")
				hitbox.fuse = 9
			end

			if timer <= 14
				P_InstaThrust(p.mo, p.mo.angle, 12*FRACUNIT)
				P_SetObjectMomZ(p.mo, 20*FRACUNIT)
				P_SpawnGhostMobj(p.mo)
				p.mo.state = S_PLAY_ROLL
			elseif timer > 14 and timer <= 15
				p.mo.momx = ($/6)*5
				p.mo.momy = ($/6)*5
				p.mo.momz = ($/6)*5
				p.mo.state = S_PLAY_ROLL
			elseif timer > 15
				p.mo.state = S_PLAY_FALL
				return true
			end
		end,
		priorityCheck = function(mo)
			if mo.state == S_PLAY_ROLL then return 2 end
			return 0
		end
	},

	["downspecial"] = {
		nogroundreset = true,
		anim = function(p, timer)
			if timer < 40
				p.mo.state = S_PLAY_SPINDASH
				P_SpawnGhostMobj(p.mo)

				p.mo.friction = FRACUNIT
				p.powers[pw_nocontrol] = 40-timer
				
				if not S_SoundPlaying(p.mo, sfx_spndsh) then S_StartSound(p.mo, sfx_spndsh) end
			elseif timer >= 40
				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius, p.mo.height,
				6, 2, 10*FRACUNIT, 5*FRACUNIT, true, sfx_kick3, "punch")
				hitbox.fuse = 2

				if P_IsObjectOnGround(p.mo)
					P_Thrust(p.mo, p.mo.angle, FRACUNIT+(FRACUNIT/2))
					if p.mo.momx > 25*FRACUNIT then p.mo.momx = 25*FRACUNIT end
					if p.mo.momy > 25*FRACUNIT then p.mo.momy = 25*FRACUNIT end
				else
					p.powers[pw_nocontrol] = 1
				end

				p.mo.state = S_PLAY_ROLL
				P_SpawnGhostMobj(p.mo)
			end

			if timer == 40 
				P_TeleportMove(p.mo, p.mo.x, p.mo.y, p.mo.z+FRACUNIT)
				P_InstaThrust(p.mo, p.mo.angle, 25*FRACUNIT)
				S_StartSound(p.mo, sfx_zoom)
			end

			if (timer < 40) or (timer > 80 and timer < 90)
				p.mo.momx = ($/10)*9
				p.mo.momy = ($/10)*9
			elseif timer >= 90
				P_SetObjectMomZ(p.mo, FRACUNIT)
				p.mo.state = S_PLAY_FALL

				p.mo.friction = 29*FRACUNIT/32
				return true
			end
		end
	},
	
	["sidespecial"] = {
		nomove = true,
		noreuse = true,
		anim = function(p, timer)
			if timer == 1 and P_IsObjectOnGround(p.mo) then P_DoJump(p) end
			p.mo.upspecialed = true

			if timer < 6
				p.mo.state = S_PLAY_FALL
			elseif timer >= 6 and timer <= 15
				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius,
				p.mo.height, 6, 4, p.speed, 0, true, sfx_kick3, "punch")
				hitbox.hitcool = 1
				hitbox.fuse = 2

				p.mo.state = S_PLAY_ROLL
				P_SpawnGhostMobj(p.mo)
			elseif timer > 15 then return true end

			if timer == 6
				P_InstaThrust(p.mo, p.mo.angle, 28*FRACUNIT)
				p.mo.momz = $/2

				S_StartSound(p.mo, sfx_thok)
			end
		end
	},
	
	["blast"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer < 25
				p.mo.momz = FRACUNIT/4*P_MobjFlip(p.mo)
				p.mo.state = S_PLAY_FALL
			elseif timer == 25
				p.mo.state = S_PLAY_SUPER_TRANS1

				local hitbox = s.drawHitBox(p, 0, 0, -p.mo.height, p.mo.radius*4,
				p.mo.height*3, 17, 3, nil, nil, true, sfx_pstop, "punch")
				hitbox.blast = 2
				hitbox.fuse = 20
				hitbox.destscale = FRACUNIT+(2*FRACUNIT/3)
				hitbox.hitMod = 200

				local shield = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
				shield.color = p.mo.color
				shield.scale = 3*FRACUNIT
				shield.destscale = 14*FRACUNIT
				shield.tics = -1
				shield.fuse = 35

				S_StartSound(p.mo, sfx_cybdth)
			elseif timer >= 50
				p.mo.state = S_PLAY_STND
				return true
			end
		end
	},
	
	["finalsmash"] = {
		superarmor = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer == 1
				p.mo.flags = $|MF_NOGRAVITY
				p.mo.state = S_PLAY_SUPER_TRANS1
				
				p.mo.emeralds = {}
				p.mo.emeraldang = 0
				for i = 1, 7
					local em = P_SpawnMobj(p.mo.y, p.mo.x, p.mo.z, MT_THOK)
					em.sprite = SPR_CEMG
					em.frame = FF_FULLBRIGHT|i
					em.flags = MF_NOGRAVITY|MF_FLOAT|MF_SCENERY
					em.scale = $*3/2
					em.dist = 1024
					em.fuse = 80
					em.tics = 80
					
					p.mo.emeralds[i] = em
				end
			end

			if timer > 10
				p.mo.color = SKINCOLOR_SUPERGOLD1 + abs(((leveltime >> 1) % 9) - 4)
			end
			
			if timer > 1 and timer < 60
				local ang = p.mo.emeraldang
				for k,v in ipairs(p.mo.emeralds)
					if v and v.valid
						local x = p.mo.x + v.dist*cos(ang)
						local y = p.mo.y + v.dist*sin(ang)
						local z = p.mo.z + 32*cos(leveltime*ANG1*2 + (360/7)*ANG1*i)

						P_TeleportMove(v, x, y, z)
						ang = $+(360/7)*ANG1
						
						v.dist = max(64, $-24)
					end
				end

				p.mo.emeraldang = $+ANG30
			elseif timer >= 60 and timer < 90
				local ang = p.mo.emeraldang
				for k,v in ipairs(p.mo.emeralds)
					if v and v.valid
						local x = p.mo.x + v.dist*cos(ang)
						local y = p.mo.y + v.dist*sin(ang)
						local z = p.mo.z + 32*cos(leveltime*ANG1*2 + (360/7)*ANG1*i)

						P_TeleportMove(v, x, y, z)
						ang = $+(360/7)*ANG1
						
						v.dist = max(1, $-8)
					end
				end

				p.mo.emeraldang = $+ANG20
			elseif timer == 90
				for i = 1, 7
					if p.mo.emeralds[i] and p.mo.emeralds[i].valid
						P_RemoveMobj(p.mo.emeralds[i])
						table.remove(p.mo.emeralds, i)
					end
				end
			end

			if timer > 20
				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius,
				p.mo.height, 15, 4, nil, nil, true, sfx_magic3, "punch")
				hitbox.hitcool = 2
				hitbox.fuse = 2

				if p.mo and p.mo.button
					p.mo.state = S_PLAY_NIGHTS_DRILL
					P_SpawnGhostMobj(p.mo)

					if p.mo.button.up >= 1 then p.mo.momz = $+FRACUNIT end
					if p.mo.button.down >= 1 then p.mo.momz = $-FRACUNIT end

					if twodlevel
						if p.mo.button.left >= 1 then p.mo.momx = $-FRACUNIT end
						if p.mo.button.right >= 1 then p.mo.momx = $+FRACUNIT end
					end
				end
			end

			if timer >= 525
				p.rings = 0
				p.powers[pw_super] = 0
				p.mo.color = p.skincolor
				p.mo.emeralds = nil
				p.mo.emeraldang = nil
				
				return true
			end
		end,
	}
}