local s = SRB2Smash

// If no character definitions exist for the character...
addHook("PostThinkFrame", function()
	if not s.isSmash() then return end
	if not server then return end

	for skin in skins.iterate
		if not s.chars[skin.name]
			s.chars[skin.name] = s.chars["baseModCharWithNoDefs"]
			print(skin.realname.." has no defined character definitions! The base has been slapped onto "..skin.realname..".")
		end
	end
end)

/*
	Some Functions that will hopefully make modding easier.
	- idk what will be here yet.
*/

// FUNCTION: Copy a move from an existing character
s.copyMoveFrom = function(skin, skinFrom, moveType)
	s.chars[skin][moveType] = s.chars[skinFrom][moveType]
	print("Added "..skinForm.."'s "..moveType.." to "..skin.."'s moveset!")
end

// RETURN: The missile fired
s.fireMissile = function(mo, type, priority)
	local missile = P_SPMAngle(mo, type, mo.angle)

	if missile and missile.valid
		missile.priority = priority
		missile.target = mo
		missile.user = mo
		
		if mo.scale > FRACUNIT then missile.scale = FixedMul($, mo.scale) end
		return missile
	else
		return nil
	end
end

// RETURN: The closest player mobj
s.closestMobj = function(mobj, ignore)
	local closestMo = {}
	for p in players.iterate
		if not p.mo or not p.mo.valid then continue end
		if p.smashSpectate or p.mo.tempSpectate then continue end
		if ignore and ignore.valid and p.mo == ignore then continue end
		if p.mo == mobj then continue end

--		if P_CheckSight(mobj, p.mo)
			table.insert(closestMo, {p.mo, P_AproxDistance(P_AproxDistance(mobj.x - p.mo.x, mobj.y - p.mo.y), mobj.z - p.mo.z)})
--		end
	end

	if not #closestMo then return nil end

	table.sort(closestMo, function(a, b) return a[2] < b[2] end)

	local tmo = closestMo[1]
	if tmo and tmo[2] and tmo[2] <= 512*FRACUNIT
		return tmo[1]
	end
	
	return nil
end

// FUNCTION: Damage a player without the use of a hitbox
s.damageAndKnockback = function(mo, inf, ang, x, y, dmg, kbmod, hitsound, hiteff)
	if not mo or not mo.valid then return false end
	if not inf or not inf.valid then return false end
	if mo.atkwait then return false end
	if mo.attacktype == "finalsmash" then return false end
	if mo.flingWait then return false end
	if mo.dodge then return false end
	if mo.doneParry then return false end
	if mo.hitcool then return false end

	if mo.parry and mo.parry > 25 and inf.attacktype ~= "finalsmash"
		mo.hitcool = 35
		return
	end

	s.addDamage(mo, inf, dmg)

	P_StartQuake(FRACUNIT, 10, {mo.x, mo.y, mo.z}, 200*FRACUNIT)
	S_StartSound(mo, hitsound or sfx_pstop)
	mo.hitEffect = {hiteff, 70}

	if not s.curAttack(mo).superarmor
		mo.hitstun = (mo.percent/4)+10
		if kbmod and mo.percent >= (120-s.invWeight(mo.skin)) then mo.launch = true end

		mo.flingWait = {
			time = 8,
			angle = ang,
			thrust = 0,
			momz = 0,
			attacker = inf or nil,
		}

		if kbmod
			if x and y
				mo.flingWait.thrust = x+(mo.percent/6)*(FRACUNIT/7)
				mo.flingWait.momz = y+(mo.percent/5)*(FRACUNIT/3)
			else
				mo.flingWait.momz = (mo.percent/5)*(FRACUNIT/4)
				mo.flingWait.thrust = (10+s.invWeight(mo.skin)+(mo.percent/6))*(FRACUNIT/4)
			end
		else
			mo.flingWait.thrust = x
			mo.flingWait.momz = y
		end

		if mo.launch and kbmod
			mo.flingWait.thrust = $*3
			mo.flingWait.momz = ($*5)/2

			-- just die like oh my g
			if mo.percent >= 220 then mo.flingWait.thrust = $*3 end
		end

		-- Meteor Smash sound
		if mo.flingWait.momz <= -5*FRACUNIT then S_StartSound(mo, sfx_meteor) end

		-- check for last player
		if cv_stocks.value and mo.player
			local aliveCount = 0
			for player in players.iterate
				if player.lives > 0 and not player.smashSpectate
					aliveCount = $+1
				end
			end

			local p = mo.player
			if aliveCount <= 2 and p.lives <= 1 and mo.launch and (mo.flingWait.thrust >= 35*FRACUNIT or mo.flingWait.momz >= 20*FRACUNIT or mo.flingWait.momz <= -30*FRACUNIT)
				s.finalHit(mo)
			end
		end
	else
		mo.atkstop = 15
	end

	mo.hitcool = 5
end