local s = SRB2Smash
if not s.chars then s.chars = {} end

// States
freeslot("S_PLAY_AMY_STILT1", "S_PLAY_AMY_STILT2", "S_PLAY_AMY_STILT3", 
"S_PLAY_AMY_STILT4", "S_PLAY_AMY_STILT5",

"S_PLAY_AMY_FAIR1", "S_PLAY_AMY_FAIR2", "S_PLAY_AMY_FAIR3", "S_PLAY_AMY_FAIR4",

"SPR_HMR1", "SPR_HMR2")

states[S_PLAY_AMY_STILT1] = {SPR_HMR1, A, 6, nil, 1, 1, S_PLAY_AMY_STILT2}
states[S_PLAY_AMY_STILT2] = {SPR_HMR1, B, 2, nil, 1, 1, S_PLAY_AMY_STILT3}
states[S_PLAY_AMY_STILT3] = {SPR_HMR1, C, 2, nil, 1, 1, S_PLAY_AMY_STILT4}
states[S_PLAY_AMY_STILT4] = {SPR_HMR1, D, 3, nil, 1, 1, S_PLAY_AMY_STILT5}
states[S_PLAY_AMY_STILT5] = {SPR_HMR1, E, 7, nil, 1, 1, S_PLAY_STND}

states[S_PLAY_AMY_FAIR1] = {SPR_HMR2, A, 5, nil, 1, 1, S_PLAY_AMY_FAIR2}
states[S_PLAY_AMY_FAIR2] = {SPR_HMR2, B, 2, nil, 1, 1, S_PLAY_AMY_FAIR3}
states[S_PLAY_AMY_FAIR3] = {SPR_HMR2, C, 2, nil, 1, 1, S_PLAY_AMY_FAIR4}
states[S_PLAY_AMY_FAIR4] = {SPR_HMR2, D, 4, nil, 1, 1, S_PLAY_FALL}

// Mobjs
freeslot("MT_HEARTTYPHOON", "S_TYPHOON", "S_TYPHOON_REMAIN", "MT_SMASH_HEART", "S_SMASHLHRT",
"MT_AMYFS_OBJ", "S_AMYFS_OBJC", "S_AMYFS_OBJ1", "S_AMYFS_OBJ2", "S_AMYFS_OBJ3", "S_AMYFS_OBJ4", "S_AMYFS_OBJ5")

mobjinfo[MT_HEARTTYPHOON] = {
    spawnstate = S_TYPHOON,
    radius = 63*FRACUNIT,
    height = 33*FRACUNIT,
	speed = 12*FRACUNIT,
    flags = MF_NOGRAVITY
}

states[S_TYPHOON] = {SPR_NULL, A, 9, nil, 0, 0, S_TYPHOON_REMAIN}
states[S_TYPHOON_REMAIN] = {SPR_NULL, A, 28, A_addMissile, 0, 0, S_NULL}

mobjinfo[MT_SMASH_HEART] = {
    spawnstate = S_SMASHLHRT,
	deathstate = S_COINSPARKLE1,
    radius = 30*FRACUNIT,
    height = 30*FRACUNIT,
    flags = MF_MISSILE
}

states[S_SMASHLHRT] = {SPR_LHRT, A, 140, nil, 0, 0, S_NULL}

local function A_ChooseObj(mo)
	local s = _G["S_AMYFS_OBJ"..P_RandomRange(1, 5)]
	mo.state = s
	return s
end

mobjinfo[MT_AMYFS_OBJ] = {
    spawnstate = S_AMYFS_OBJC,
	deathstate = S_COINSPARKLE1,
    radius = 32*FRACUNIT,
    height = 32*FRACUNIT,
    flags = MF_BOUNCE|MF_MISSILE|MF_GRENADEBOUNCE|MF_RUNSPAWNFUNC
}

states[S_AMYFS_OBJC] = {SPR_NULL, A, -1, A_ChooseObj, 0, 0, S_AMYFS_OBJC}

states[S_AMYFS_OBJ1] = {SPR_RING, A, 105, nil, 0, 0, S_NULL}
states[S_AMYFS_OBJ2] = {SPR_BRKN, A, 105, nil, 0, 0, S_NULL}
states[S_AMYFS_OBJ3] = {SPR_UNID, B, 105, nil, 0, 0, S_NULL}
states[S_AMYFS_OBJ4] = {SPR_BARR, A, 105, nil, 0, 0, S_NULL}
states[S_AMYFS_OBJ5] = {SPR_SPRY, A, 105, nil, 0, 0, S_NULL}

// MobjThinker
addHook("MobjThinker", function(mo)
	if mo.state == S_TYPHOON_REMAIN then mo.momx, mo.momy, mo.momz = 0, 0, 0 end

	for i = -1, 1
		local ang = (leveltime%9)*ANG20
		local x, y, z = mo.x + (60*cos(ang))*i, mo.y + (60*sin(ang))*i, mo.z
		local hrt = P_SpawnMobj(x, y, z, MT_SMASH_DUMMY)
		if hrt and hrt.valid
			hrt.sprite = SPR_LHRT
			hrt.fuse = 2
			P_SpawnGhostMobj(hrt)
		end
	end
end, MT_HEARTTYPHOON)

addHook("MobjThinker", function(mo)
	if not P_IsObjectOnGround(mo)
		mo.rollangle = $+ANG10
	end
end, MT_AMYFS_OBJ)

// Defs
s.chars["amy"] = {
	-- General Stats
	["speed"] = 4,
	["weight"] = 3,
	["hud"] = "ROSYY",
	["win"] = "AMYWIN",
	["winbg"] = {0, -110, "SKY17"},
	
	-- Attacks
	["jab1"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 30*sin(p.mo.angle), 0, 15*FRACUNIT,
				20*FRACUNIT, 3, 1, FRACUNIT/5, FRACUNIT/3, nil, sfx_punch1, "punch")
				
				hitbox.fuse = 5
			elseif timer == 10
				return true
			end
			
			p.mo.state = S_PLAY_STND
			p.drawangle = p.mo.angle+ANGLE_45
		end,
		desc = {
			name = "Jab",
			txt = "Basic 3-hit jab that deals 11 total damage. Spam the spin button to jab, and finish with a hammer hit!"
		}
	},

	["jab2"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 30*sin(p.mo.angle), 0, 15*FRACUNIT,
				32*FRACUNIT, 3, 1, FRACUNIT/5, FRACUNIT/3, nil, sfx_punch1, "punch")
				
				hitbox.fuse = 5
			elseif timer == 10
				return true
			end
			
			p.mo.state = S_PLAY_STND
			p.drawangle = p.mo.angle-ANGLE_45
		end,
	},

	["jab3"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 30*sin(p.mo.angle), 0, 15*FRACUNIT,
				p.mo.height, 5, 2, 7*FRACUNIT, 5*FRACUNIT, true, sfx_kick2, "punch")
				
				hitbox.fuse = 5
			elseif timer == 15
				p.mo.state = S_PLAY_STND
				return true
			end
			
			p.mo.state = S_PLAY_MELEE
		end,
	},

	["dash"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if not p.mo.hitboxshit or not p.mo.hitboxshit.valid
				p.mo.hitboxshit = s.drawHitBox(p, 0, 0, 0, p.mo.radius+20*FRACUNIT,
				p.mo.height, 2, 3, 5*FRACUNIT, 5*FRACUNIT, false, sfx_punch2, "punch")
				p.mo.hitboxshit.fuse = 2
				p.mo.hitboxshit.hitcool = 5
				p.mo.hitboxshit.hitlag = 1
			end

			if p.speed < 10*FRACUNIT
				P_InstaThrust(p.mo, p.mo.angle, 19*FRACUNIT)
			end

			P_SpawnGhostMobj(p.mo)

			p.mo.state = S_PLAY_MELEE_LANDING
			p.drawangle = timer*ANGLE_45

			if not S_SoundPlaying(p.mo, sfx_s3k47) then S_StartSound(p.mo, sfx_s3k47) end

			if timer >= 30
				p.mo.state = S_PLAY_RUN

				if p.mo.hitboxshit and p.mo.hitboxshit.valid
					P_RemoveMobj(p.mo.hitboxshit)
					p.mo.hitboxshit = nil
				end

				return true
			end
		end
	},

	["sidetilt"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1 then p.mo.state = S_PLAY_AMY_STILT1 end

			if timer == 7
				local hitbox = s.drawHitBox(p, ((p.mo.radius*2)/FRACUNIT)*cos(p.mo.angle), 
				(p.mo.radius/FRACUNIT)*sin(p.mo.angle), 0, (p.mo.radius*3)-(10*FRACUNIT), 
				p.mo.height, 4, 2, 13*FRACUNIT, FRACUNIT, true, sfx_punch2, "punch")
				hitbox.fuse = 7
				
				local hitbox = s.drawHitBox(p, 10*cos(p.mo.angle), 10*sin(p.mo.angle), 0,
				20*FRACUNIT, p.mo.height, 9, 3, 13*FRACUNIT, FRACUNIT, true, sfx_punch2, "sweet")
				hitbox.fuse = 7
			end

			if timer == 20 or p.mo.state == S_PLAY_STND
				p.mo.state = S_PLAY_STND
				return true
			end
		end,
	},

	["uptilt"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				p.mo.state = S_PLAY_MELEE
				p.mo.sprite2 = SPR2_MLEE
				p.mo.frame = B

				P_InstaThrust(p.mo, 0, 0)

				local hitbox = s.drawHitBox(p, 7*FRACUNIT, 0, p.mo.height, p.mo.radius*3, 32*FRACUNIT, 6, 2, 1, 10*FRACUNIT, true, sfx_punch2, "punch")
				
				hitbox.fuse = 10
				P_SetObjectMomZ(p.mo, 5*FRACUNIT)
			elseif timer == 18
				p.mo.state = S_PLAY_STND
				return true
			end
		end,
	},
	
	["neutralair"] = {
		anim = function(p, timer)
			if timer == 4
				local hitbox = s.drawHitBox(p, 0, 0, -p.mo.height/2, p.mo.radius*2,
				(p.mo.height*3)/2, 5, 2, nil, nil, true, sfx_punch2, "punch")
				hitbox.fuse = 7
			end

			if timer <= 6 then p.mo.state = S_PLAY_TWINSPIN end
			if timer == 10 then p.mo.state = S_PLAY_FALL end
			if timer >= 13 then return true end				
		end
	},
	
	["upair"] = {
		anim = function(p, timer)
			if timer == 1
				p.mo.momz = $/2

				local hitbox = s.drawHitBox(p, 0, 0, p.mo.height, p.mo.radius,
				20*FRACUNIT, 5, 2, P_RandomRange(-2, 2)*FRACUNIT, 13*FRACUNIT, true,
				sfx_s3k49, "punch")
				hitbox.fuse = 4
			elseif timer == 10 or P_IsObjectOnGround(p.mo)
				p.mo.state = S_PLAY_FALL
				return true
			end

			p.mo.state = S_PLAY_MELEE
			p.mo.sprite2 = SPR2_MLEE
			p.mo.frame = B
			
			p.drawangle = timer*ANGLE_22h
		end,
	},

	["downair"] = {
		anim = function(p, timer)
			if timer == 1 
				P_SpawnMobj(p.mo.x + 20*cos(p.mo.angle), p.mo.y + 20*sin(p.mo.angle), p.mo.z-26*FRACUNIT, MT_SUPERSPARK)
			end

			local x = ((p.mo.radius+15*FRACUNIT)/FRACUNIT)
			if timer < 6
				p.mo.state = S_PLAY_ROLL
			elseif timer == 6
				p.mo.state = S_PLAY_MELEE

				local hitbox = s.drawHitBox(p, x*cos(p.mo.angle), 0, 0,
				p.mo.radius+10*FRACUNIT, 25*FRACUNIT+p.mo.height, 6, 2, 
				13*FRACUNIT, 5*FRACUNIT, true, sfx_kick2, "punch")
				hitbox.fuse = 5
			elseif timer == 10
				local spike = s.drawHitBox(p, x*cos(p.mo.angle), 0, -35*FRACUNIT,
				p.mo.radius, 14*FRACUNIT, 9, 3, 10*FRACUNIT, -15*FRACUNIT, true, sfx_kick3,
				"spike")
				spike.fuse = 8
			end

			if timer >= 14 
				p.mo.state = S_PLAY_FALL
				return true
			end
		end
	},
	
	["sideair"] = {
		anim = function(p, timer)
			if timer == 1
				p.mo.startAng = p.mo.angle
				p.mo.state = S_PLAY_AMY_FAIR1
			end

			if p.mo.startAng then p.drawangle = p.mo.startAng end

			if timer == 5
				local hitbox = s.drawHitBox(p, 20*cos(p.drawangle), 20*sin(p.drawangle),
				0, 20*FRACUNIT, p.mo.height, 8, 2, 9*FRACUNIT, FRACUNIT, true, sfx_kick2, "punch")
				hitbox.fuse = 8
			end

			if p.mo.state == S_PLAY_FALL or timer > 18
				return true
			end
		end,
	},

	["neutralspecial"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			p.mo.state = S_PLAY_MELEE_LANDING
			if timer < 2
				if p.mo.tornado and p.mo.tornado.valid 
					p.mo.state = S_PLAY_STND
					return true
				end

				p.drawangle = timer*ANG10
				local ghoss = P_SpawnGhostMobj(p.mo)
				ghoss.destscale = 2*FRACUNIT
			elseif timer < 4
				p.drawangle = timer*ANG20
				local ghoss = P_SpawnGhostMobj(p.mo)
				ghoss.destscale = 2*FRACUNIT
			elseif timer <= 6
				p.drawangle = timer*ANGLE_45
				local ghoss = P_SpawnGhostMobj(p.mo)
				ghoss.destscale = 2*FRACUNIT
			else
				p.drawangle = timer*(ANGLE_45+ANGLE_22h)
				local ghoss = P_SpawnGhostMobj(p.mo)
				ghoss.destscale = 2*FRACUNIT
			end

			if timer == 7
				p.mo.tornado = s.fireMissile(p.mo, MT_HEARTTYPHOON, 2)
				
				if p.mo.tornado and p.mo.tornado.valid
					P_TeleportMove(p.mo.tornado, p.mo.x, p.mo.y, p.mo.z + 10*FRACUNIT)
				end
			end

			if not S_SoundPlaying(p.mo, sfx_s3k47) then S_StartSound(p.mo, sfx_s3k47) end
			if timer >= 12 then return true end
		end,
		desc = {
			name = "Neutral Special",
			txt = "Fire a typhoon of hearts! This needs time to charge up and to finish, so it is advised you do NOT use this offstage!"
		}
	},

	["upspecial"] = {
		noreuse = true,
		anim = function(p, timer)
			if timer == 1
				for i = 1, 36
					local dust = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SPINDUST)
					P_InstaThrust(dust, i*10*ANG1, 20*FRACUNIT)
				end
			end

			p.mo.momx = ($/8)*7
			p.mo.momy = ($/8)*7

			if not p.mo.hitboxshit or not p.mo.hitboxshit.valid
				p.mo.hitboxshit = s.drawHitBox(p, 0, 0, 0, 2*p.mo.radius,
				p.mo.height, 1, 3, -1, p.mo.momz, false, sfx_kick1, "punch")

				p.mo.hitboxshit.fuse = 2
				p.mo.hitboxshit.hitcool = 3
				p.mo.hitboxshit.hitlag = 3
				p.mo.hitboxshit.hitstun = 20
			end

			P_SetObjectMomZ(p.mo, FRACUNIT, true)
			P_SpawnGhostMobj(p.mo)
			
			if p.mo.momz < 0 then p.mo.momz = $+3*FRACUNIT end

			p.mo.state = S_PLAY_MELEE_LANDING
			p.drawangle = timer*ANGLE_45

			if not S_SoundPlaying(p.mo, sfx_s3k47) then S_StartSound(p.mo, sfx_s3k47) end

			if timer >= 58 or p.mo.momz > 18*FRACUNIT
				p.mo.state = S_PLAY_MELEE

				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius*3,
				(p.mo.height*5)/2, 5, 2, 1, 10*FRACUNIT, true, sfx_kick2, "punch")
				hitbox.fuse = 4

				if p.mo.hitboxshit and p.mo.hitboxshit.valid
					P_RemoveMobj(p.mo.hitboxshit)
					p.mo.hitboxshit = nil
				end

				return true
			end
		end
	},
	
	["sidespecial"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1 then p.mo.state = S_PLAY_MELEE end
			
			if timer == 8
				S_StartSound(p.mo, sfx_pstop)
				p.mo.state = S_PLAY_MELEE_LANDING

				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 0, 0, p.mo.radius*4,
				15*FRACUNIT+p.mo.height, 11, 2, 10*FRACUNIT, 5*FRACUNIT, true,
				sfx_kick3, "punch")
				hitbox.fuse = 8

				local hitbox = s.drawHitBox(p, 15*cos(p.mo.angle), 0, 0, p.mo.radius,
				p.mo.height/2, 15, 3, 4*FRACUNIT, -4*FRACUNIT, true, sfx_kick3, "sweet")
				hitbox.fuse = 8

				for i = 1, 7
					local heart = s.fireMissile(p.mo, MT_SMASH_HEART, 2)

					if heart and heart.valid
						P_TeleportMove(heart, heart.x, heart.y, heart.z + FRACUNIT)

						heart.momz = P_RandomRange(2, 10)*FRACUNIT--*P_MobjFlip(p.mo)
						P_InstaThrust(heart, p.mo.angle, P_RandomRange(5, 10)*FRACUNIT)
			
						heart.flags = $ & ~MF_NOGRAVITY
					end
				end
			end

			if timer >= 35
				p.mo.state = S_PLAY_STND
				return true
			end
		end
	},

	["downspecial"] = {
		nomove = true,
		noringbuff = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer < 24
				local chrge = P_SpawnGhostMobj(p.mo)
				chrge.destscale = 30*FRACUNIT

				p.mo.state = S_PLAY_MELEE
				p.mo.sprite2 = SPR2_MLEE
				p.mo.frame = B
				if not S_SoundPlaying(p.mo, sfx_s3k7e) then S_StartSound(p.mo, sfx_s3k7e) end

				if not (leveltime%10)
					local dust = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SPINDUST)
					dust.destscale = 3*FRACUNIT

					local orb = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
					orb.sprite = SPR_WITS
					orb.scalespeed = FRACUNIT/69 -- nice
					orb.destscale = 2*FRACUNIT
					orb.color = SKINCOLOR_WHITE
					orb.fuse = 35
					orb.tics = 35

					orb = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
					orb.sprite = SPR_WITS
					orb.scale = FRACUNIT/2
					orb.scalespeed = FRACUNIT/69 -- nice
					orb.destscale = FRACUNIT+(FRACUNIT/2)
					orb.color = SKINCOLOR_WHITE
					orb.fuse = 35
					orb.tics = 35
				end
			elseif timer <= 40
				p.mo.state = S_PLAY_MELEE_LANDING

				if timer == 25
					S_StartSound(p.mo, sfx_pstop)

					local hitbox = s.drawHitBox(p, ((p.mo.radius*2)/FRACUNIT)*cos(p.mo.angle), 
					(p.mo.radius/FRACUNIT)*sin(p.mo.angle), 0, p.mo.radius*3, 
					p.mo.height, 19, 2, 4*FRACUNIT, 16*FRACUNIT, true,
					sfx_punch3, "punch")
					hitbox.hitlag = 18
					hitbox.fuse = 10

					for i = 1, 16
						local b = P_SpawnMobj(hitbox.x, hitbox.y, hitbox.z, MT_SPINDUST)
						b.momx = P_RandomRange(-8, 8)*FRACUNIT
						b.momy = P_RandomRange(-8, 8)*FRACUNIT
						b.momz = P_RandomRange(-8, 8)*FRACUNIT
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT*3
						b.destscale = FRACUNIT/12
					end
				end
			end

			if timer == 25 then S_StartSound(p.mo, sfx_zoom) end
			
			if timer >= 42 
				p.mo.state = S_PLAY_STND
				return true
			end
		end,
	},
	
	["upblast"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer <= 7
				p.mo.state = S_PLAY_ROLL
			elseif timer == 14
				local hitbox = s.drawHitBox(p, 7*FRACUNIT, 0, 0, p.mo.radius*3,
				p.mo.height, 15, 2, 0, 10*FRACUNIT, true, sfx_kick2, "punch")
				hitbox.fuse = 10
			end

			if timer == 8
				p.mo.state = S_PLAY_MELEE
				P_SetObjectMomZ(p.mo, 5*FRACUNIT)
			elseif timer >= 22
				p.mo.state = S_PLAY_STND
				return true
			end
		end
	},

	["downblast"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer <= 6
				p.mo.state = S_PLAY_ROLL
			elseif timer == 7
				p.mo.state = S_PLAY_MELEE

				local hitbox = s.drawHitBox(p, 35*cos(p.mo.angle), 0, 0,
				p.mo.radius+10*FRACUNIT, 25*FRACUNIT+p.mo.height, 14, 3, 
				13*FRACUNIT, 5*FRACUNIT, true, sfx_kick2, "punch")
				hitbox.fuse = 5
			end

			if timer >= 21
				p.mo.state = S_PLAY_FALL
				return true
			end
		end
	},

	["blast"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)			
			if timer == 1 then p.mo.state = S_PLAY_AMY_STILT1 end

			if timer == 11
				local hitbox = s.drawHitBox(p, 40*cos(p.mo.angle), 40*sin(p.mo.angle),
				0, p.mo.radius*2, p.mo.height, 13, 3, 13*FRACUNIT, FRACUNIT, true,
				sfx_punch2, "punch")
				hitbox.fuse = 7
				
				local hitbox = s.drawHitBox(p, 10*cos(p.mo.angle), 10*sin(p.mo.angle), 0,
				10*FRACUNIT, p.mo.height, 17, 3, 13*FRACUNIT, FRACUNIT, true, sfx_punch2, "sweet")
				hitbox.fuse = 7
			end

			if timer >= 25 or p.mo.state == S_PLAY_STND
				p.mo.state = S_PLAY_STND
				return true
			end
		end
	},
	
	["finalsmash"] = {
		nomove = true,
		noringbuff = true,
		superarmor = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer <= 50
				for player in players.iterate
					s.removeMovement(player)

					if player and player.mo.valid and player ~= p
						player.mo.momx = ($/5)*4
						player.mo.momy = ($/5)*4
						player.mo.momz = ($/5)*4
					end
				end
			end

			if timer == 1
				p.mo.flags = $|MF_NOGRAVITY
				p.mo.state = S_PLAY_SUPER_TRANS1
				
				p.mo.emeralds = {}
				p.mo.emeraldang = 0
				for i = 1, 7
					local em = P_SpawnMobj(p.mo.y, p.mo.x, p.mo.z, MT_THOK)
					em.sprite = SPR_CEMG
					em.frame = FF_FULLBRIGHT|i
					em.flags = MF_NOGRAVITY|MF_FLOAT|MF_SCENERY
					em.scale = $*3/2
					em.dist = 1024
					em.fuse = 80
					em.tics = 80
					
					p.mo.emeralds[i] = em
				end
			end

			if timer > 10
				p.mo.color = SKINCOLOR_SUPERRUST1 + abs(((leveltime >> 1) % 9) - 4)
			end
			
			if timer > 1 and timer < 60
				local ang = p.mo.emeraldang
				for k,v in ipairs(p.mo.emeralds)
					if v and v.valid
						local x = p.mo.x + v.dist*cos(ang)
						local y = p.mo.y + v.dist*sin(ang)
						local z = p.mo.z + 32*cos(leveltime*ANG1*2 + (360/7)*ANG1*i)

						P_TeleportMove(v, x, y, z)
						ang = $+(360/7)*ANG1
						
						v.dist = max(64, $-24)
					end
				end

				p.mo.emeraldang = $+ANG30
			elseif timer >= 60 and timer < 90
				local ang = p.mo.emeraldang
				for k,v in ipairs(p.mo.emeralds)
					if v and v.valid
						local x = p.mo.x + v.dist*cos(ang)
						local y = p.mo.y + v.dist*sin(ang)
						local z = p.mo.z + 32*cos(leveltime*ANG1*2 + (360/7)*ANG1*i)

						P_TeleportMove(v, x, y, z)
						ang = $+(360/7)*ANG1
						
						v.dist = max(1, $-8)
					end
				end

				p.mo.emeraldang = $+ANG20
			elseif timer == 90
				for i = 1, 7
					if p.mo.emeralds[i] and p.mo.emeralds[i].valid
						P_RemoveMobj(p.mo.emeralds[i])
						table.remove(p.mo.emeralds, i)
					end
				end
			end

			if timer == 30
				p.mo.state = S_PLAY_AMY_STILT1

				local hitbox = s.drawHitBox(p, (p.mo.radius*4/FRACUNIT)*cos(p.mo.angle), 
				(p.mo.radius*4/FRACUNIT)*sin(p.mo.angle), 0, p.mo.radius*6, 
				p.mo.height*2, 10, 3, 1, 1, false, sfx_kick3, "punch")
				hitbox.fuse = 10
			end

			if timer == 35
				if p.mo.owies
					p.mo.owieStuff = {
						x = p.mo.x,
						y = p.mo.y,
						z = p.mo.z,
						atkx = p.mo.x + 50*cos(p.mo.angle),
						atky = p.mo.y + 50*sin(p.mo.angle),
						atkz = p.mo.z + 10*FRACUNIT
					}
				else
					p.mo.state = S_PLAY_STND
					p.rings = 0
					p.powers[pw_super] = 0
					p.mo.color = p.skincolor
					p.mo.emeralds = nil
					p.mo.emeraldang = nil
					p.mo.owies = nil
					p.mo.owieStuff = nil
					return true
				end
			end
			
			if p.mo.owies
				if timer >= 40 and timer <= 188
					if not (timer%80)
						local funnyeStates = {S_PLAY_TWINSPIN, S_PLAY_AMY_FAIR1, S_PLAY_AMY_STILT1}
						p.mo.state = funnyeStates[P_RandomRange(1, #funnyeStates)]
					end

					for i = 1, 3
						local smoke = P_SpawnMobj(p.mo.owieStuff.atkx, p.mo.owieStuff.atky, p.mo.owieStuff.atkz, MT_SPINDUST)
						smoke.scale = 4*FRACUNIT
						smoke.destscale = 1
						smoke.momx = P_RandomRange(-20, 20)*FRACUNIT
						smoke.momy = P_RandomRange(-20, 20)*FRACUNIT
						smoke.momz = P_RandomRange(-20, 20)*FRACUNIT
					end
					
					if not (leveltime%6)
						local heart = P_SpawnMobj(p.mo.owieStuff.atkx, p.mo.owieStuff.atky, p.mo.owieStuff.atkz, MT_LHRT)
						heart.flags = MF_NOCLIP|MF_NOGRAVITY
						heart.destscale = 1
						heart.momx = P_RandomRange(-15, 15)*FRACUNIT
						heart.momy = P_RandomRange(-15, 15)*FRACUNIT
						heart.momz = P_RandomRange(-15, 15)*FRACUNIT
						heart.fuse = 10
					end
					
					if not S_SoundPlaying(p.mo, sfx_s3k8b) then S_StartSound(p.mo, sfx_s3k8b) end

					if not (leveltime%2)
						for k,v in ipairs(p.mo.owies)
							if v and v.valid
								if s.usesPercent()
									v.percent = $+1
								elseif s.usesStamina()
									v.stamina = $-1
									if v.stamina < 1 then v.stamina = 1 end
								end
							else
								table.remove(p.mo.owies, k)
							end
						end
					end
				end

				if timer >= 40 and timer <= 210
					local coords = {p.mo.owieStuff.atkx, p.mo.owieStuff.atky, p.mo.owieStuff.atkz}

					if not p.mo.targCoords then p.mo.targCoords = coords end

					for k,v in ipairs(p.mo.owies)
						if v and v.valid
							v.hitcool = 10
							if not v.targCoords then v.targCoords = coords end

							if P_RandomChance(FRACUNIT/30) and not v.coordsReset and timer < 180
								v.targCoords[1] = $+P_RandomRange(-200, 200)*FRACUNIT
								v.targCoords[3] = $+P_RandomRange(-200, 200)*FRACUNIT
								v.coordsReset = 20
							end

							local dist = P_AproxDistance(P_AproxDistance(v.targCoords[1] - v.x, v.targCoords[2] - v.y), v.targCoords[3], v.z)
							v.momx = (FixedMul(FixedDiv(v.targCoords[1] - v.x, dist), 32<<FRACBITS))*2
							v.momz = (FixedMul(FixedDiv(v.targCoords[3] - v.z, dist), 32<<FRACBITS))*2
							v.state = S_PLAY_DEAD

							if v.coordsReset
								v.coordsReset = $-1
								if v.coordsReset <= 0
									v.coordsReset = nil
									v.targCoords = nil
								end
							end
						end
					end

					if not p.mo.targCoords then p.mo.targCoords = coords end

					if P_RandomChance(FRACUNIT/30) and not p.mo.coordsReset and timer < 180
						p.mo.targCoords[1] = $+P_RandomRange(-200, 200)*FRACUNIT
						p.mo.targCoords[3] = $+P_RandomRange(-200, 200)*FRACUNIT
						p.mo.coordsReset = 20
					end
					
					local dist = P_AproxDistance(P_AproxDistance(p.mo.targCoords[1] - p.mo.x, p.mo.targCoords[2] - p.mo.y), p.mo.targCoords[3], p.mo.z)
					p.mo.momx = (FixedMul(FixedDiv(p.mo.targCoords[1] - p.mo.x, dist), 32<<FRACBITS))*2
					p.mo.momz = (FixedMul(FixedDiv(p.mo.targCoords[3] - p.mo.z, dist), 32<<FRACBITS))*2
					p.mo.state = S_PLAY_TWINSPIN
							
					if p.mo.coordsReset
						p.mo.coordsReset = $-1
						if p.mo.coordsReset <= 0
							p.mo.coordsReset = nil
							p.mo.targCoords = nil
						end
					end
					
					if not (timer%9)
						local obj = s.fireMissile(p.mo, MT_AMYFS_OBJ, 4)
						if obj and obj.valid
							obj.color = p.mo.color
							obj.momx = P_RandomRange(-20, 20)*FRACUNIT
							if not twodlevel then obj.momy = P_RandomRange(-20, 20)*FRACUNIT end
							obj.momz = P_RandomRange(1, 20)*FRACUNIT
						end
					end
				end
				
				if timer == 215
					p.mo.state = S_PLAY_SUPER_TRANS1

					local hitbox = s.drawHitBox(p, 0, 0, -p.mo.height, p.mo.radius*4,
					p.mo.height*3, 10, 3, nil, nil, true, sfx_magic4, "punch")
					hitbox.blast = 2
					hitbox.fuse = 20
					hitbox.scale = FRACUNIT+(2*FRACUNIT/3)
				end
				
				if timer >= 220
					p.mo.state = S_PLAY_FALL
					p.rings = 0
					p.powers[pw_super] = 0
					p.mo.color = p.skincolor
					p.mo.emeralds = nil
					p.mo.emeraldang = nil
					p.mo.owies = nil
					p.mo.owieStuff = nil
					return true
				end
			end
		end,
		hitFunc = function(mo, targ)
			if mo and mo.valid and mo.atktimer <= 50
				if not mo.owies then mo.owies = {} end
				mo.owies[#mo.owies+1] = targ
			end
		end,
	}
}