local s = SRB2Smash
if not s.chars then s.chars = {} end

// Mobjs
/*
freeslot("MT_SMOKEBOMB", "S_SMOKEBOMB", "S_SMOKEBOMB_DISPERSE")
mobjinfo[MT_SMOKEBOMB] = {
    spawnstate = S_SMOKEBOMB,
	deathstate = S_SMOKEBOMB_DISPERSE,
	deathsound = sfx_pop,
    radius = 10*FRACUNIT,
    height = 10*FRACUNIT,
	speed = 7*FRACUNIT,
	flags = MF_BOUNCE|MF_MISSILE|MF_GRENADEBOUNCE
}

states[S_SMOKEBOMB] = {SPR_MNPL, FF_FULLBRIGHT|A, -1, nil, 0, 0, S_SMOKEBOMB_DISPERSE}
states[S_SMOKEBOMB_DISPERSE] = {SPR_MNPL, FF_FULLBRIGHT|A, 75, nil, 0, 0, S_NULL}

addHook("MobjThinker", function(mo)
	if P_IsObjectOnGround(mo) and mo.state == S_SMOKEBOMB
		mo.state = S_SMOKEBOMB_DISPERSE
		S_StartSound(mo, sfx_pop)
	end

	if mo.state == S_SMOKEBOMB_DISPERSE and mo.tics <= 35
		mo.radius = 100*FRACUNIT
		mo.height = 75*FRACUNIT

		for i = 1, 3
			local smoke = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SMOKE)
			smoke.color = SKINCOLOR_WHITE
			smoke.colorized = true
			smoke.destscale = 20*FRACUNIT
			smoke.scale = 5*FRACUNIT
			smoke.fuse = 8*TICRATE

			smoke.momx = P_RandomRange(-10, 10)*FRACUNIT
			smoke.momy = P_RandomRange(-10, 10)*FRACUNIT
			smoke.momz = P_RandomRange(-10, 10)*FRACUNIT
		end
	end
end, MT_SMOKEBOMB)
*/

freeslot("MT_GROUNDCORK")
mobjinfo[MT_GROUNDCORK] = {
    spawnstate = S_CORK,
	deathstate = S_SMOKE1,
	deathsound = sfx_pop,
    radius = 10*FRACUNIT,
    height = 10*FRACUNIT,
	speed = 40*FRACUNIT,
	flags = MF_MISSILE
}

// States
freeslot("S_PLAY_FANG_TOSS", "S_PLAY_FANG_LAUGH1", "S_PLAY_FANG_LAUGH2", "SPR2_TOSS", "SPR2_LAFF")
states[S_PLAY_FANG_TOSS] = {SPR_PLAY, SPR2_TOSS, 35, nil, 0, 0, S_PLAY_STND}
states[S_PLAY_FANG_LAUGH1] = {SPR_PLAY, SPR2_LAFF|A, 5, nil, 0, 0, S_PLAY_FANG_LAUGH2}
states[S_PLAY_FANG_LAUGH2] = {SPR_PLAY, SPR2_LAFF|A, 5, nil, 0, 0, S_PLAY_FANG_LAUGH1}

// Character Defs
s.chars["fang"] = {
	-- General Stats
	["speed"] = 4,
	["weight"] = 6,
	["hud"] = "FANGG",
	["win"] = "FANGWIN",
	["winbg"] = {0, -230, "SKY127"},

	-- Attacks
	["jab1"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 30*sin(p.mo.angle), 0, 15*FRACUNIT,
				20*FRACUNIT, 3, 1, FRACUNIT/5, FRACUNIT/3, nil, sfx_punch1, "punch")
				
				hitbox.fuse = 5
			elseif timer == 10
				return true
			end
			
			p.mo.state = S_PLAY_STND
			p.drawangle = p.mo.angle+ANGLE_45
		end,
	},

	["jab2"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 30*sin(p.mo.angle), 0, 15*FRACUNIT,
				32*FRACUNIT, 3, 1, FRACUNIT/5, FRACUNIT/3, nil, sfx_punch1, "punch")
				
				hitbox.fuse = 5
			elseif timer == 10
				return true
			end
			
			p.mo.state = S_PLAY_STND
			p.drawangle = p.mo.angle-ANGLE_45
		end,
	},

	["jab3"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 30*sin(p.mo.angle), 0, 15*FRACUNIT,
				p.mo.height, 5, 2, 7*FRACUNIT, 5*FRACUNIT, true, sfx_kick2, "punch")
				
				hitbox.fuse = 5
			elseif timer == 15
				p.mo.state = S_PLAY_STND
				return true
			end
			
			p.mo.state = S_PLAY_FIRE
		end,
	},

	["dash"] = {
		nomove = true,
		superarmor = true,
		anim = function(p, timer)
			if timer < 15
				P_InstaThrust(p.mo, p.mo.angle, 19*FRACUNIT)
				
				p.mo.state = S_PLAY_ROLL

				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius, p.mo.height,
				2, 3, 8*FRACUNIT, 3*FRACUNIT, false, sfx_kick3, "punch")
				hitbox.hitcool = 5
				hitbox.hitlag = 1
				hitbox.fuse = 2
			else
				p.mo.state = S_PLAY_RUN
				if timer >= 19 then return true end
			end
		end
	},

	["sidetilt"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 13*cos(p.mo.angle), 13*sin(p.mo.angle),
				0, 20*FRACUNIT, p.mo.height, 10, 2, 2*FRACUNIT, 8*FRACUNIT, false,
				sfx_kick2, "punch")
				hitbox.fuse = 8
			elseif timer >= 18
				p.mo.state = S_PLAY_FALL
				return true
			end
			
			p.mo.state = S_PLAY_RUN
			p.drawangle = timer*ANG30
		end,
	},

	["uptilt"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius,
				p.mo.height + 10*FRACUNIT, 5, 2, P_RandomRange(-3, 3)*FRACUNIT, 10*FRACUNIT, true,
				sfx_punch2, "punch")
				
				hitbox.fuse = 8
				P_SetObjectMomZ(p.mo, 3*FRACUNIT)
			elseif timer == 16
				p.mo.state = S_PLAY_STND
				return true
			end
			
			if P_IsObjectOnGround(p.mo)
				p.mo.state = S_PLAY_CROUCH
			else
				p.mo.state = S_PLAY_SPRING
				p.drawangle = timer*ANGLE_45
			end
		end,
	},

	["neutralair"] = {
		anim = function(p, timer)
			if timer < 5 then
				p.mo.state = S_PLAY_ROLL
			elseif timer == 6 then
				p.mo.state = S_PLAY_ROLL
				local thok = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
				thok.state = S_BOMB_EXPLD

				local hitbox = s.drawHitBox(p, 0, 0, -p.mo.height/2, p.mo.radius*2,
				(p.mo.height*3)/2, 5, 2, nil, nil, true, sfx_fire2, "fire", EFF_BURN)
				hitbox.fuse = 7
			end

			if timer >= 13 then
				if P_IsObjectOnGround(p.mo)
					p.mo.state = S_PLAY_STND
				else
					p.mo.state = S_PLAY_FALL
				end

				return true
			end				
		end
	},
	
	["upair"] = {
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 0, 0, p.mo.height, p.mo.radius,
				20*FRACUNIT, 4, 2, P_RandomRange(-2, 2)*FRACUNIT, 5*FRACUNIT, true,
				sfx_punch2, "punch")

				hitbox.fuse = 4
			elseif timer == 10 or P_IsObjectOnGround(p.mo)
				p.mo.state = S_PLAY_FALL
				return true
			end
			
			p.mo.state = S_PLAY_SPRING
			p.drawangle = timer*ANGLE_45
		end,
	},

	["downair"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1 then P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z-26*FRACUNIT, MT_SUPERSPARK) end

			if timer == 5
				p.mo.momz = $/2
				local hitbox = s.drawHitBox(p, 0, 0, -25*FRACUNIT, p.mo.radius,
				25*FRACUNIT, 6, 2, P_RandomRange(-10, 10)*FRACUNIT, 0, true,
				sfx_kick2, "punch")
				hitbox.fuse = 8

				local spike = s.drawHitBox(p, 0, 0, -33*FRACUNIT, p.mo.radius-20*FRACUNIT,
				12*FRACUNIT, 9, 3, 0, -12*FRACUNIT, true, sfx_kick3, "spike")
				spike.fuse = 5
			elseif timer == 15 or P_IsObjectOnGround(p.mo)
				p.mo.state = S_PLAY_FALL
				return true
			end

			if timer < 10
				p.mo.state = S_PLAY_SPRING
			elseif timer >= 10 and timer < 15
				p.mo.state = S_PLAY_BOUNCE
			end
		end,
	},

	["sideair"] = {
		anim = function(p, timer)
			if timer < 5
				p.mo.state = S_PLAY_ROLL
			elseif timer >= 5 and timer < 11
				p.mo.state = S_PLAY_NIGHTS_DRILL
				p.drawangle = timer*ANGLE_45

				local hitbox = s.drawHitBox(p, 40*cos(p.mo.angle), 40*sin(p.mo.angle),
				0, 40*FRACUNIT, p.mo.height, 6, 2, 10*FRACUNIT, 1, true, 
				sfx_punch3, "punch")
				hitbox.fuse = 2
			elseif timer == 11 or P_IsObjectOnGround(p.mo)
				p.mo.state = S_PLAY_FALL
				return true
			end
		end,
	},

	["neutralspecial"] = {
--		nomove = true,
		nojump = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer < 3
				p.mo.momx = ($/6)*5
				p.mo.momy = ($/6)*5
				p.mo.state = S_PLAY_ROLL
			end

			if (timer == 7)
				p.mo.state = S_PLAY_FIRE
				
				local cork
				if P_IsObjectOnGround(p.mo)
					cork = s.fireMissile(p.mo, MT_GROUNDCORK, 2)
					p.mo.groundCork = true
				else
					cork = s.fireMissile(p.mo, MT_CORK, 2)
					p.mo.groundCork = nil
				end

				if cork and cork.valid
					if cork.type == MT_GROUNDCORK then cork.scale = 2*FRACUNIT end

					cork.momx = $/3
					cork.momy = $/3
					cork.momz = 4*cork.scale*P_MobjFlip(p.mo)
					cork.flags = $ & ~MF_NOGRAVITY
				end
			end

			if (timer >= 20 and not p.mo.groundCork)
			or (timer >= 35 and p.mo.groundCork)
				p.mo.state = S_PLAY_STND
				return true 
			end
		end,
	},

	["sidespecial"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer <= 5
				p.mo.momx = ($/6)*5
				p.mo.momy = ($/6)*5
			end

			if timer == 5
				p.mo.state = S_PLAY_FANG_TOSS
				local bomb = s.fireMissile(p.mo, MT_FBOMB, 2)

				if bomb and bomb.valid
					bomb.color = p.skincolor
					bomb.colorized = true

					bomb.momx = 2*($/5)
					bomb.momy = 2*($/5)
					bomb.momz = 4*FRACUNIT*P_MobjFlip(bomb)
				end
			elseif timer >= 20
				p.mo.state = S_PLAY_FALL
				return true
			end
		end,
	},

	["upspecial"] = {
		nomove = true,
		noreuse = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer == 6
				if s.usesPercent()
					p.mo.percent = $+5
				else
					p.mo.stamina = $-5
					if p.mo.stamina <= 0 then s.killMobj(p.mo) end
				end

				local hitbox = s.drawHitBox(p, 0, 0, -p.mo.height, p.mo.radius*5,
				p.mo.height, 11, 2, 1, 5*FRACUNIT, true, sfx_fire3, "fire", EFF_BURN)
				hitbox.hitlag = 10
				hitbox.fuse = 4
				
				local sweet = s.drawHitBox(p, 0, 0, -p.mo.height/2, p.mo.radius/2,
				p.mo.height/2, 15, 3, 1, -7*FRACUNIT, true, sfx_fire3, "fire",
				EFF_BURN)
				sweet.hitlag = 10
				sweet.fuse = 4

				local x, y, z = p.mo.x - 100*cos(p.mo.angle), p.mo.y - 100*sin(p.mo.angle), p.mo.z + 10*FRACUNIT
				local thok = P_SpawnMobj(x, y, z, MT_THOK)
				thok.state = S_BOMB_EXPLD

				x, y = p.mo.x + 100*cos(p.mo.angle), p.mo.y + 100*sin(p.mo.angle)
				thok = P_SpawnMobj(x, y, z, MT_THOK)
				thok.state = S_BOMB_EXPLD

				x, y, z = p.mo.x, p.mo.y, p.mo.z - 40*FRACUNIT
				thok = P_SpawnMobj(x, y, z, MT_THOK)
				thok.state = S_BOMB_EXPLD

				S_StartSound(p.mo, sfx_bkpoof)
			end

			if timer < 6
				p.mo.state = S_PLAY_FANG_TOSS
				p.mo.momx = ($/10)*9
				p.mo.momy = ($/10)*9
				p.mo.momz = ($/10)*9
			elseif timer >= 6 and timer <= 18
				p.mo.state = S_PLAY_PAIN
				P_InstaThrust(p.mo, 0, 0)
				P_SetObjectMomZ(p.mo, 18*FRACUNIT)
			elseif timer >= 18
				p.mo.state = S_PLAY_ROLL
				return true
			end
		end,
	},

	["downspecial"] = {
		nomove = true,
		noreuse = true,
		superarmor = true,
		nogroundreset = true,
		anim = function(p, timer)
			if not p.mo.spinning
				p.mo.momz = $-3*FRACUNIT

				p.mo.state = S_PLAY_BOUNCE
				P_SpawnGhostMobj(p.mo)

				local spike = s.drawHitBox(p, 0, 0, -p.mo.height/2, 2*p.mo.radius,
				p.mo.height, 11, 2, 6*FRACUNIT, -10*FRACUNIT, true, sfx_sword2,
				"spike")
				spike.fuse = 3

				if P_IsObjectOnGround(p.mo)
					S_StartSound(p.mo, sfx_boingf)
					P_SetObjectMomZ(p.mo, 17*FRACUNIT)
					p.mo.state = S_PLAY_ROLL

					p.mo.spinning = 20
				end
			end

			if p.mo.spinning
				p.mo.spinning = $-1

				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius, p.mo.height,
				7, 2, 5*FRACUNIT, 5*FRACUNIT, true, sfx_kick2, "punch")
				hitbox.fuse = 2

				if p.mo.spinning <= 0 
					p.mo.state = S_PLAY_FALL

					p.mo.spinning = nil
					return true
				end
			end
			
			if p.mo.endAtk
				p.mo.endAtk = nil
				return true
			end
		end,
		hitFunc = function(mo, targ)
			S_StartSound(mo, sfx_mspogo)
			mo.doublejumped = nil

			P_SetObjectMomZ(mo, 18*FRACUNIT)
			mo.state = S_PLAY_ROLL
			
			mo.endAtk = true
		end,
	},

	["upblast"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer == 4 or timer == 9 or timer == 14
				p.mo.state = S_PLAY_FANG_TOSS

				if timer == 14
					local hitbox = s.drawHitBox(p, 0, 0, p.mo.height, p.mo.radius*3,
					p.mo.height*3, 7, 3, 1, 14*FRACUNIT, true, sfx_fire3, "fire-sweet", 
					EFF_BURNABSORB)
					hitbox.hitlag = 13
					hitbox.fuse = 6

					local thok = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + (p.mo.height+20*FRACUNIT), MT_THOK)
					thok.state = S_BOMB_EXPLD
				else
					local x, y, z = P_RandomRange(-40, 40)*FRACUNIT, P_RandomRange(-40, 40)*FRACUNIT, P_RandomRange(1, 20)*FRACUNIT
					local hitbox = s.drawHitBox(p, x, y, z-(p.mo.height*2), p.mo.radius*2, p.mo.height*3, 4,
					3, FRACUNIT, FRACUNIT, false, sfx_fire2, "fire")
					hitbox.hitlag = 8
					hitbox.fuse = 3

					local thok = P_SpawnMobj(p.mo.x+x, p.mo.y+y, p.mo.z+p.mo.height+z, MT_THOK)
					thok.state = S_BOMB_EXPLD
				end
			end
			
			if timer >= 35
				p.mo.state = S_PLAY_STND
				return true
			end
		end
	},

	["downblast"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer == 5
				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 30*sin(p.mo.angle),
				0, 20*FRACUNIT, p.mo.height, 14, 2, 14*FRACUNIT, FRACUNIT, true, 
				sfx_kick2, "punch")
				hitbox.fuse = 8
			elseif timer >= 28
				p.mo.state = S_PLAY_FALL
				return true
			end
			
			if timer <= 16
				p.mo.state = S_PLAY_RUN
				p.drawangle = timer*ANG30
			else
				p.mo.state = S_PLAY_EDGE
			end
		end
	},

	["blast"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)			
			if timer == 1 
				p.mo.state = S_PLAY_FIRE
				p.mo.blastShots = {} 
			end
			
			for i = 1, 5
				if timer == (i*5)
					local x, y, z = p.mo.x + P_RandomRange(0, 75)*cos(p.mo.angle), p.mo.y + P_RandomRange(0, 75)*sin(p.mo.angle), p.mo.z + (P_RandomRange(0, 33)*FRACUNIT)
					local aim = P_SpawnMobj(x, y, z, MT_THOK)
					aim.color = p.skincolor
					aim.colorized = true
					aim.scale = FRACUNIT/2
					aim.sprite = SPR_TARG
					aim.tics = 35
					aim.fuse = 35
					
					p.mo.blastShots[i] = aim
				end
				
				if timer == 3 + (i*5)
					p.mo.state = S_PLAY_STND
					p.mo.state = S_PLAY_FIRE
					local aim = (p.mo.blastShots[i] and p.mo.blastShots[i].valid) and p.mo.blastShots[i] or p.mo

					if i == 5
						local hitbox = s.drawHitBox(p, 75*cos(p.mo.angle), 
						75*sin(p.mo.angle), 0, p.mo.radius*3, p.mo.height, 8, 3,
						10*FRACUNIT, 2*FRACUNIT, true, sfx_kick2, "sweet", EFF_BURNABSORB)
						hitbox.hitlag = 12
						hitbox.fuse = 4
					else
						local hitbox = s.drawHitBox(p, 75*cos(p.mo.angle), 
						75*sin(p.mo.angle), 0, p.mo.radius*3, p.mo.height, 2, 2,
						FRACUNIT, FRACUNIT, false, sfx_kick1, "punch")
						hitbox.hitcool = 3
						hitbox.hitlag = 3
						hitbox.fuse = 2
					end
					
					P_RemoveMobj(aim)
				end
			end

			if timer >= 50
				p.mo.state = S_PLAY_STND
				return true
			end
		end
	},
	
	["finalsmash"] = {
		noringbuff = true,
		superarmor = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer == 1
				p.mo.emeralds = {}
				p.mo.emeraldang = 0
				for i = 1, 7
					local em = P_SpawnMobj(p.mo.y, p.mo.x, p.mo.z, MT_THOK)
					em.sprite = SPR_CEMG
					em.frame = FF_FULLBRIGHT|i
					em.flags = MF_NOGRAVITY|MF_FLOAT|MF_SCENERY
					em.scale = $*3/2
					em.dist = 1024
					em.fuse = 80
					em.tics = 80
					
					p.mo.emeralds[i] = em
				end
			end

			if timer > 10
				p.mo.color = SKINCOLOR_SUPERPURPLE1 + abs(((leveltime >> 1) % 9) - 4)
			end
			
			if timer > 1 and timer < 60
				local ang = p.mo.emeraldang
				for k,v in ipairs(p.mo.emeralds)
					if v and v.valid
						local x = p.mo.x + v.dist*cos(ang)
						local y = p.mo.y + v.dist*sin(ang)
						local z = p.mo.z + 32*cos(leveltime*ANG1*2 + (360/7)*ANG1*i)

						P_TeleportMove(v, x, y, z)
						ang = $+(360/7)*ANG1
						
						v.dist = max(64, $-24)
					end
				end

				p.mo.emeraldang = $+ANG30
			elseif timer >= 60 and timer < 90
				local ang = p.mo.emeraldang
				for k,v in ipairs(p.mo.emeralds)
					if v and v.valid
						local x = p.mo.x + v.dist*cos(ang)
						local y = p.mo.y + v.dist*sin(ang)
						local z = p.mo.z + 32*cos(leveltime*ANG1*2 + (360/7)*ANG1*i)

						P_TeleportMove(v, x, y, z)
						ang = $+(360/7)*ANG1
						
						v.dist = max(1, $-8)
					end
				end

				p.mo.emeraldang = $+ANG20
			elseif timer == 90
				for i = 1, 7
					if p.mo.emeralds[i] and p.mo.emeralds[i].valid
						P_RemoveMobj(p.mo.emeralds[i])
						table.remove(p.mo.emeralds, i)
					end
				end
			end

			if timer > 20
				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius,
				p.mo.height, 9, 3, nil, nil, true, sfx_magic3, "punch")
				hitbox.hitcool = 2
				hitbox.fuse = 2

				if not (leveltime%6)
					if twodlevel
						local bomb = s.fireMissile(p.mo, MT_FBOMB, 4)
						if bomb and bomb.valid
							local x = p.mo.x + P_RandomRange(-3000, 3000)*FRACUNIT
							P_TeleportMove(bomb, x, p.mo.y, p.mo.ceilingz-100*FRACUNIT)
		
							bomb.scale = 2*P_RandomRange(FRACUNIT/2, FRACUNIT)
						end
					else
						local bomb = s.fireMissile(p.mo, MT_FBOMB, 4)
						if bomb and bomb.valid
							local x = p.mo.x + P_RandomRange(-2000, 2000)*FRACUNIT
							local y = p.mo.y + P_RandomRange(-2000, 2000)*FRACUNIT
							P_TeleportMove(bomb, x, y, p.mo.ceilingz-100*FRACUNIT)
		
							bomb.scale = 2*P_RandomRange(FRACUNIT/2, FRACUNIT)
						end
					end
				end
			else
				p.mo.momx, p.mo.momy, p.mo.momz = 0, 0, 0
			end
			
			if timer >= 350
				p.rings = 0
				p.powers[pw_super] = 0
				p.mo.color = p.skincolor
				p.mo.emeralds = nil
				p.mo.emeraldang = nil
				
				return true
			end
		end,
	}
}