local s = SRB2Smash
if not s.chars then s.chars = {} end

// States
freeslot("S_PLAY_KNUCKLES_STILT1", "S_PLAY_KNUCKLES_STILT2", "S_PLAY_KNUCKLES_STILT3",
"S_PLAY_KNUCKLES_STILT4",

"SPR_PNCH")

states[S_PLAY_KNUCKLES_STILT1] = {SPR_PNCH, A, 6, nil, 1, 1, S_PLAY_KNUCKLES_STILT2}
states[S_PLAY_KNUCKLES_STILT2] = {SPR_PNCH, B, 3, nil, 1, 1, S_PLAY_KNUCKLES_STILT3}
states[S_PLAY_KNUCKLES_STILT3] = {SPR_PNCH, C, 2, nil, 1, 1, S_PLAY_KNUCKLES_STILT4}
states[S_PLAY_KNUCKLES_STILT4] = {SPR_PNCH, D, 10, nil, 1, 1, S_PLAY_STND}

mobjinfo[MT_FALLINGROCK].seesound = sfx_s3k49

s.chars["knuckles"] = {
	-- General Stats
	["speed"] = 4,
	["weight"] = 8,
	["hud"] = "KNUCK",
	["win"] = "KNUXWIN",
	["winbg"] = {0, -350, "SKY40"},
	
	-- Attacks
	["jab1"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 30*sin(p.mo.angle), 0, 15*FRACUNIT,
				20*FRACUNIT, 2, 1, FRACUNIT/5, FRACUNIT/3, nil, sfx_punch1, "punch")
				
				hitbox.fuse = 5
			elseif timer == 10
				return true
			end
			
			p.mo.state = S_PLAY_STND
			p.drawangle = p.mo.angle+ANGLE_45
		end,
		desc = {
			name = "Jab",
			txt = "Basic 3-hit jab that deals 12 total damage. Spam the spin button to jab, and finish with a deadly punch!"
		}
	},

	["jab2"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 30*sin(p.mo.angle), 0, 15*FRACUNIT,
				32*FRACUNIT, 4, 1, FRACUNIT/5, FRACUNIT/3, nil, sfx_punch1, "punch")
				
				hitbox.fuse = 5
			elseif timer == 10
				return true
			end
			
			p.mo.state = S_PLAY_STND
			p.drawangle = p.mo.angle-ANGLE_45
		end,
	},

	["jab3"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				p.mo.state = S_PLAY_KNUCKLES_STILT1
				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 30*sin(p.mo.angle), 0, 15*FRACUNIT,
				p.mo.height, 6, 2, 7*FRACUNIT, 5*FRACUNIT, true, sfx_punch2, "punch")
				
				hitbox.fuse = 5
			elseif timer == 15
				p.mo.state = S_PLAY_STND
				return true
			end
		end,
	},

	["dash"] = {
		nomove = true,
		superarmor = true,
		anim = function(p, timer)
			if timer < 15
				P_InstaThrust(p.mo, p.mo.angle, 19*FRACUNIT)
				
				p.mo.state = S_PLAY_GLIDE
				P_SpawnGhostMobj(p.mo)

				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius, p.mo.height,
				3, 3, 10*FRACUNIT, FRACUNIT, false, sfx_punch3, "punch")
				hitbox.hitcool = 5
				hitbox.hitlag = 1
				hitbox.fuse = 2
			else
				p.mo.state = S_PLAY_RUN
				if timer >= 19 then return true end
			end
		end
	},

	["uptilt"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius,
				p.mo.height + 13*FRACUNIT, 8, 2, P_RandomRange(-3, 3)*FRACUNIT,
				10*FRACUNIT, true, sfx_punch2, "punch")
				
				hitbox.fuse = 8
				P_SetObjectMomZ(p.mo, 3*FRACUNIT)
			elseif timer == 16
				p.mo.state = S_PLAY_STND
				return true
			end

			if P_IsObjectOnGround(p.mo)
				p.mo.state = S_PLAY_CROUCH
			else
				p.mo.state = S_PLAY_SPRING
				p.drawangle = timer*ANGLE_45
			end
		end,
	},

	["sidetilt"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				p.mo.state = S_PLAY_KNUCKLES_STILT1
			end

			if timer == 7
				local hitbox = s.drawHitBox(p, ((p.mo.radius*2)/FRACUNIT)*cos(p.mo.angle), 
				(p.mo.radius/FRACUNIT)*sin(p.mo.angle), 0, p.mo.radius*3, 
				p.mo.height, 12, 2, 13*FRACUNIT, 2*FRACUNIT, nil, sfx_punch3, "punch")
				hitbox.hitlag = 17
				hitbox.fuse = 7
				
				P_Thrust(p.mo, p.mo.angle, 8*FRACUNIT)
			end

			if timer >= 21 or p.mo.state == S_PLAY_STND
				p.mo.state = S_PLAY_STND
				return true
			end
		end,
	},

	["neutralair"] = {
		anim = function(p, timer)
			if timer == 4
				local hitbox = s.drawHitBox(p, 0, 0, -p.mo.height/2, p.mo.radius*2,
				(p.mo.height*3)/2, 8, 2, P_RandomRange(-10, 10)*FRACUNIT, 1, true,
				sfx_kick3, "punch")
				hitbox.fuse = 6
			end

			if timer < 10
				p.mo.state = S_PLAY_FALL
				p.drawangle = ANGLE_90
			elseif timer == 10
				p.mo.state = S_PLAY_ROLL
				p.drawangle = p.mo.angle
			end

			if timer >= 13 then return true end				
		end
	},
	
	["upair"] = {
		anim = function(p, timer)
			if timer < 3
				p.mo.state = S_PLAY_CROUCH
			elseif timer >= 3 and timer < 10
				p.mo.state = S_PLAY_SPRING

				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius,
				p.mo.height + 10*FRACUNIT, 10, 2, P_RandomRange(-3, 3)*FRACUNIT, 10*FRACUNIT, true,
				sfx_punch2, "punch")
				hitbox.hitlag = 7
				hitbox.fuse = 8
				
				local sweet = s.drawHitBox(p, 0, 0, 0, 10*FRACUNIT, p.mo.height + 10*FRACUNIT,
				15, 3, P_RandomRange(-1, 1)*FRACUNIT, 15*FRACUNIT, true, sfx_punch3, "sweet")
				sweet.hitlag = 7
				sweet.fuse = 5
			else
				p.mo.state = S_PLAY_FALL
				if timer >= 15 then return true end
			end
		end,
	},

	["downair"] = {
		anim = function(p, timer)
			if timer == 1 
				P_SpawnMobj(p.mo.x + 20*cos(p.mo.angle), p.mo.y + 20*sin(p.mo.angle), p.mo.z-26*FRACUNIT, MT_SUPERSPARK)
			end
	
			if timer < 8
				p.mo.state = S_PLAY_ROLL
			elseif timer == 8
				p.mo.state = S_PLAY_GLIDE

				local x = ((p.mo.radius+15*FRACUNIT)/FRACUNIT)
				local hitbox = s.drawHitBox(p, x*cos(p.mo.angle), 0, 0,
				p.mo.radius+15*FRACUNIT, 25*FRACUNIT+p.mo.height, 6, 2, 
				13*FRACUNIT, 5*FRACUNIT, true, sfx_kick2, "punch")
				hitbox.hitlag = 15
				hitbox.fuse = 8

				x = ((p.mo.radius)/FRACUNIT)
				local spike = s.drawHitBox(p, x*cos(p.mo.angle), 0, -35*FRACUNIT,
				p.mo.radius, 14*FRACUNIT, 9, 3, 10*FRACUNIT, -15*FRACUNIT, true, sfx_kick3,
				"spike")
				spike.hitlag = 20
				spike.fuse = 5
			end

			if timer >= 14 then return true end
		end
	},
	
	["sideair"] = {
		anim = function(p, timer)
			if timer < 5
				p.mo.state = S_PLAY_ROLL
			elseif timer >= 5 and timer < 11
				p.mo.state = S_PLAY_NIGHTS_DRILL

				local hitbox = s.drawHitBox(p, 20*cos(p.mo.angle), 20*sin(p.mo.angle),
				0, p.mo.radius, p.mo.height, 8, 2, 10*FRACUNIT, 5*FRACUNIT, true, 
				sfx_punch3, "punch")
				hitbox.fuse = 2
			elseif timer == 11 or P_IsObjectOnGround(p.mo)
				p.mo.state = S_PLAY_FALL
				return true
			end
		end,
	},

	["neutralspecial"] = {
		nomove = true,
		superarmor = true,
		noringbuff = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer < 24
				p.mo.state = S_PLAY_KNUCKLES_STILT1
				if not S_SoundPlaying(p.mo, sfx_s3k7e) then S_StartSound(p.mo, sfx_s3k7e) end
	
				if not (leveltime%10)
					local dust = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SPINDUST)
					dust.destscale = 3*FRACUNIT

					local orb = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
					orb.sprite = SPR_WITS
					orb.scalespeed = FRACUNIT/69 -- nice
					orb.destscale = 2*FRACUNIT
					orb.color = SKINCOLOR_WHITE
					orb.fuse = 35
					orb.tics = 35

					orb = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
					orb.sprite = SPR_WITS
					orb.scale = FRACUNIT/2
					orb.scalespeed = FRACUNIT/69 -- nice
					orb.destscale = FRACUNIT+(FRACUNIT/2)
					orb.color = SKINCOLOR_GREY
					orb.fuse = 35
					orb.tics = 35
				end
			elseif timer <= 40
				p.mo.state = S_PLAY_KNUCKLES_STILT2
				P_SpawnGhostMobj(p.mo)
				
				if timer == 25
					S_StartSound(p.mo, sfx_pstop)
					
					local hitbox = s.drawHitBox(p, ((p.mo.radius*2)/FRACUNIT)*cos(p.mo.angle), 
					(p.mo.radius/FRACUNIT)*sin(p.mo.angle), 0, p.mo.radius*3, 
					p.mo.height, 28, 3, 12*FRACUNIT, 9*FRACUNIT, true,
					sfx_punch3, "stun")
					hitbox.hitlag = 25
					hitbox.fuse = 10

					for i = 1, 16
						local b = P_SpawnMobj(hitbox.x, hitbox.y, hitbox.z, MT_SPINDUST)
						b.momx = P_RandomRange(-8, 8)*FRACUNIT
						b.momy = P_RandomRange(-8, 8)*FRACUNIT
						b.momz = P_RandomRange(-8, 8)*FRACUNIT
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT*3
						b.destscale = FRACUNIT/12
					end
				end
			end

			if timer == 25 then S_StartSound(p.mo, sfx_zoom) end
			if timer >= 42 then return true end
		end,
	},

	["sidespecial"] = {
		nomove = true,
		noreuse = true,
		superarmor = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer == 1
				p.mo.groundedAttack = P_IsObjectOnGround(p.mo)
			else
				if p.mo.groundedAttack
					if timer == 3
						p.mo.slideAttack = nil
						p.mo.atkEnd = nil

						p.mo.state = S_PLAY_ROLL
						p.mo.landAttack = true
						P_SetObjectMomZ(p.mo, 4*FRACUNIT, true)
					end

					if (timer > 5) and p.mo.landAttack and P_IsObjectOnGround(p.mo)
					and not p.mo.slideAttack and not p.mo.atkEnd
						p.mo.slideAttack = true
						p.mo.landAttack = nil
					end

					if p.mo.slideAttack
						p.mo.friction = FRACUNIT
						p.mo.slideVictim = $ or nil
						p.mo.state = S_PLAY_GLIDE
						P_SpawnGhostMobj(p.mo)

						P_InstaThrust(p.mo, p.mo.angle, 26*FRACUNIT)
						if p.mo.slideVictim
							local mo = p.mo.slideVictim
							if mo and mo.valid
								P_TryMove(mo, p.mo.x + 50*cos(p.mo.angle), p.mo.y + 50*sin(p.mo.angle))
								P_TeleportMove(mo, mo.x, mo.y, p.mo.z + 10*FRACUNIT)

								if not (leveltime%2)
									if s.usesPercent()
										mo.percent = $+1
									else
										mo.stamina = $-1
										if mo.stamina <= 0 then s.killMobj(mo, p.mo) end
									end
								end

								mo.hitcool = 5
								mo.hitstun = 5

								mo.state = S_PLAY_PAIN
								mo.attacker = p.mo

								mo.angle = R_PointToAngle2(mo.x, mo.y, p.mo.x, p.mo.y)
							end
						else
							if not p.mo.slideTime then p.mo.slideTime = 35 end
							p.mo.slideTime = $-1

							local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius,
							p.mo.height, 5, 2, nil, nil, nil, sfx_kick1, "punch")
							hitbox.fuse = 2
						end
						
						if not S_SoundPlaying(p.mo, sfx_s3k7e) then S_StartSound(p.mo, sfx_s3k7e) end
			
						if not (leveltime%10)
							local dust = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SPINDUST)
							dust.destscale = 3*FRACUNIT
						end
						
						if not P_IsObjectOnGround(p.mo)
						or p.powers[pw_pushing]
						or timer > 350
						or p.mo.slideTime <= 1
						or not P_CheckPosition(p.mo, p.mo.x + 30*cos(p.mo.angle), p.mo.y + 30*sin(p.mo.angle), p.mo.z)
							if p.mo.slideVictim and p.mo.slideVictim.valid
								p.mo.slideVictim.hitcool = 0

								local hitbox = s.drawHitBox(p, p.mo.radius, 0, 0,
								p.mo.radius*3, p.mo.height+10*FRACUNIT, 4, 2,
								10*FRACUNIT, 3*FRACUNIT, true, sfx_kick2, "punch")
								hitbox.fuse = 2

								p.mo.slideAttack = nil
								p.mo.atkEnd = 35

								P_TeleportMove(p.mo, p.mo.x - 35*cos(p.mo.angle), p.mo.y - 35*sin(p.mo.angle), p.mo.z)

								P_InstaThrust(p.mo, 0, 0)	
								P_SetObjectMomZ(p.mo, 7*FRACUNIT)
								p.mo.state = S_PLAY_SPRING

								p.mo.slideVictim = nil
								p.mo.slideTime = nil
							else
								p.mo.groundedAttack = nil
								p.mo.slideAttack = nil
								p.mo.landAttack = nil
								p.mo.atkEnd = nil
								p.mo.slideVictim = nil
								p.mo.state = S_PLAY_ROLL
								p.pflags = $|PF_SPINNING
								return true
							end
						end
					end

					if p.mo.atkEnd
						p.mo.atkEnd = $-1
						
						if p.mo.atkEnd <= 0
							p.mo.groundedAttack = nil
							p.mo.slideAttack = nil
							p.mo.landAttack = nil
							p.mo.atkEnd = nil
							p.mo.slideVictim = nil
							p.mo.friction = 29*FRACUNIT/32
							return true
						end
					end
				else
					if timer >= 3 and not p.mo.collided and not p.mo.atkEnd
						p.mo.state = S_PLAY_GLIDE
						P_Thrust(p.mo, p.mo.angle, FRACUNIT)
						if p.mo.momx > 20*FRACUNIT then p.mo.momx = 20*FRACUNIT end
						if p.mo.momx < -20*FRACUNIT then p.mo.momx = -20*FRACUNIT end
						if p.mo.momy > 20*FRACUNIT then p.mo.momy = 20*FRACUNIT end
						if p.mo.momy < -20*FRACUNIT then p.mo.momy = -20*FRACUNIT end
						if p.mo.momz < -3*FRACUNIT then p.mo.momz = -3*FRACUNIT end
						
						local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius,
						p.mo.height, 10, 2, 8*FRACUNIT, 3*FRACUNIT, true,
						sfx_punch3, "punch")
						hitbox.fuse = 2

						if p.powers[pw_pushing] then p.mo.collided = 10 end

						if timer > 40
							p.mo.collided = nil
							p.mo.atkEnd = nil
							p.mo.state = S_PLAY_FALL
							return true
						end
					end
					
					if p.mo.collided
						p.mo.momx = 0
						p.mo.momy = 0
						p.mo.momz = 0
						p.mo.state = S_PLAY_CLING
						
						p.mo.collided = $-1
						if p.mo.collided <= 0
							p.mo.collided = nil
							p.mo.atkEnd = 10
							
							P_SetObjectMomZ(p.mo, 10*FRACUNIT)
							p.mo.noReuse["sidespecial"] = true
						end
					end
					
					if p.mo.atkEnd
						p.mo.state = S_PLAY_SPRING
						p.mo.atkEnd = $-1
						
						if p.mo.atkEnd <= 0
							p.mo.state = S_PLAY_ROLL
							p.mo.atkEnd = nil
							return true
						end
					end
				end
			end
		end,
		hitFunc = function(mo, targ)
			if mo.groundedAttack
				mo.slideVictim = targ
			end
		end,
		strikeFunc = function(mo, inf)
			mo.friction = 29*FRACUNIT/32
			mo.slideAttack = nil
			mo.landAttack = nil
			mo.atkEnd = nil
			mo.slideVictims = nil
			mo.collided = nil
			mo.atkEnd = nil
		end
	},
	
	["downspecial"] = {
		nomove = true,
		superarmor = true,
		nogroundreset = true,
		repelprojectiles = true,
		anim = function(p, timer)
			if timer == 1 then P_SetObjectMomZ(p.mo, 3*FRACUNIT, true) end

			if timer == 2
				p.mo.state = S_PLAY_CROUCH
				p.mo.glideland = nil
			elseif timer == 4
				p.mo.state = S_PLAY_SPRING
			end

			if p.mo.glideland
				p.mo.state = S_PLAY_CROUCH
				p.mo.glideland = $-1
				if p.mo.glideland <= 0
					p.mo.glideland = nil
					return true
				end

				return
			end

			if timer > 10 and not p.mo.glideland
				p.mo.momz = $-3*FRACUNIT*P_MobjFlip(p.mo)
				
				p.mo.state = S_PLAY_FALL
				P_SpawnGhostMobj(p.mo)

				local spike = s.drawHitBox(p, 0, 0, -34*FRACUNIT, p.mo.radius,
				10*FRACUNIT, 2, 2, p.speed, p.mo.momz, true, sfx_kick3, "spike")
				spike.fuse = 3
				spike.hitcool = 2
				
				if P_IsObjectOnGround(p.mo)
					P_StartQuake(30*FRACUNIT, 5, {p.mo.x, p.mo.y, p.mo.z}, 200*FRACUNIT)
					p.mo.glideland = 5
					p.mo.rollangle = 0

					for i = 1, 36
						local dust = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SPINDUST)
						P_Thrust(dust, i*10*ANG1, 20*FRACUNIT)
						P_SetObjectMomZ(dust, 5*FRACUNIT)
					end

					for i = 1, 3
						for k = 1, 4+i
							local x = p.mo.x + i*40*cos(p.mo.angle)
							local y = p.mo.y + i*40*sin(p.mo.angle)
							local z = p.mo.z
							local rocc = P_SpawnMobj(x, y, z, MT_THOK)
							rocc.flags = $ & ~MF_NOGRAVITY
							rocc.state = S_ROCKCRUMBLEA
							rocc.fuse = TICRATE

							P_SetObjectMomZ(rocc, k*FRACUNIT)
						end

						if i == 1
							local hitbox = s.drawHitBox(p, i*40*cos(p.mo.angle),
							i*40*sin(p.mo.angle), 0, p.mo.radius, 20*FRACUNIT, 12,
							3, FRACUNIT, 10*FRACUNIT, false, sfx_kick3, "punch")
							
							hitbox.fuse = 13
						elseif i == 2
							local hitbox = s.drawHitBox(p, i*40*cos(p.mo.angle),
							i*40*sin(p.mo.angle), 0, p.mo.radius, 40*FRACUNIT, 8,
							3, 3*FRACUNIT, 15*FRACUNIT, false, sfx_kick3, "punch")

							hitbox.fuse = 10
						elseif i == 3
							local hitbox = s.drawHitBox(p, i*40*cos(p.mo.angle),
							i*40*sin(p.mo.angle), 0, p.mo.radius, p.mo.height, 5,
							2, 6*FRACUNIT, 20*FRACUNIT, false, sfx_kick3, "punch")

							hitbox.fuse = 7
						end
					end

					S_StartSound(p.mo, sfx_pstop)
				end
			end
		end,
		priorityCheck = function(mo)
			if mo.momz <= 0 then return 2 end
			return 0
		end
	},		

	["upspecial"] = {
		nomove = true,
		superarmor = true,
		anim = function(p, timer)
			if not p.mo.grabbedFoe
				if timer <= 5
					p.mo.state = S_PLAY_GLIDE
					p.mo.momz = 0

					P_InstaThrust(p.mo, p.mo.angle, 2*FRACUNIT)
				elseif timer <= 18
					p.mo.state = S_PLAY_SPRING
					P_SetObjectMomZ(p.mo, 2*FRACUNIT, true)
					P_SpawnGhostMobj(p.mo)

					local hitbox = s.drawHitBox(p, (p.mo.radius/FRACUNIT)*cos(p.mo.angle),
					0, 0, 2*p.mo.radius, p.mo.height, 3, 3, 3*FRACUNIT, 10*FRACUNIT,
					false, sfx_punch1, "punch")
					hitbox.hitlag = 2
					hitbox.hitstun = 35

					hitbox.fuse = 2
				else
					p.mo.state = S_PLAY_FALL
					if timer >= 17
						p.mo.noReuse["upspecial"] = true
						return true
					end
				end
			else
				if not p.mo.endTimer then p.mo.endTimer = 20 end

				p.mo.state = S_PLAY_GLIDE
				local p2 = p.mo.grabbedFoe
				
				p.mo.momx = 0
				p.mo.momy = 0
				p.mo.momz = 0

				s.removeMovement(p2)
				P_TeleportMove(p2.mo, p.mo.x, p.mo.y, p.mo.z - 20*FRACUNIT)
				
				p.mo.endTimer = $-1
				if p.mo.endTimer <= 0
					local thok = P_SpawnMobj(p2.mo.x, p2.mo.y, p2.mo.z, MT_THOK)
					thok.state = S_BOMB_EXPLD

					local hitbox = s.drawHitBox(p, 0, 0, -20*FRACUNIT, p2.mo.radius,
					p2.mo.height, 10, 3, 10*FRACUNIT, 4*FRACUNIT, true, sfx_punch3,
					"fire")

					P_SetObjectMomZ(p.mo, 4*FRACUNIT, false)
					P_Thrust(p.mo, p.mo.angle, -10*FRACUNIT)
					p.mo.state = S_PLAY_ROLL
					
					p.mo.endTimer = nil
					p.mo.grabbedFoe = nil
					return true
				end
			end
		end,
		hitFunc = function(mo, targ)
			if targ and targ.valid and targ.player
				mo.grabbedFoe = targ.player
			end
		end,
		strikeFunc = function(mo, inf)
			mo.grabbedFoe = nil
			mo.endTimer = nil
		end
	},
	
	["upblast"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer <= 15
				p.mo.state = S_PLAY_CROUCH
			else
				p.mo.state = S_PLAY_SPRING
			end

			if timer == 17
				local hitbox = s.drawHitBox(p, 0, 0, p.mo.height, p.mo.radius*2,
				13*FRACUNIT, 20, 3, 4*FRACUNIT, 10*FRACUNIT, true, sfx_punch3, "punch")
				hitbox.hitlag = 15
				hitbox.hitcool = 1
				hitbox.fuse = 2
			end

			if timer >= 33
				p.mo.state = S_PLAY_STND
				return true
			end
		end
	},

	["downblast"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer == 11 then S_StartSound(p.mo, sfx_pstop) end
			if timer <= 10 then p.mo.state = S_PLAY_SPRING else p.mo.state = S_PLAY_CROUCH end

			if timer == 12
				local hitbox = s.drawHitBox(p, p.mo.radius, 0, 0, (p.mo.radius*3)/2,
				p.mo.height, 14, 3, 2*FRACUNIT, 10*FRACUNIT, true, sfx_punch3, "punch")
				hitbox.hitlag = 15
				hitbox.fuse = 2

				local hitbox2 = s.drawHitBox(p, -p.mo.radius, 0, 0, (p.mo.radius*3)/2,
				p.mo.height, 14, 3, -2*FRACUNIT, 10*FRACUNIT, true, sfx_punch3, "punch")
				hitbox2.hitlag = 15
				hitbox2.fuse = 2

				for i = -1, 1
					local rocc = P_SpawnMobj(p.mo.x+(p.mo.radius*i), p.mo.y, p.mo.z, MT_THOK)
					rocc.flags = $ & ~MF_NOGRAVITY
					rocc.state = S_ROCKCRUMBLEA
					rocc.fuse = TICRATE
				end
			end

			if timer >= 25
				p.mo.state = S_PLAY_STND
				return true
			end
		end
	},

	["blast"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer == 1 then p.mo.state = S_PLAY_KNUCKLES_STILT1 end

			if timer == 10
				local hitbox = s.drawHitBox(p, ((p.mo.radius*2)/FRACUNIT)*cos(p.mo.angle), (p.mo.radius/FRACUNIT)*sin(p.mo.angle), 0, p.mo.radius*2, (p.mo.height*3)/2, 15, 3, 14*FRACUNIT, 5*FRACUNIT, true, sfx_punch3, "sweet")
				hitbox.hitlag = 20
				hitbox.fuse = 7

				P_Thrust(p.mo, p.mo.angle, 6*FRACUNIT)
			end

			if timer >= 21 or p.mo.state == S_PLAY_STND
				p.mo.state = S_PLAY_STND
				return true
			end
		end
	},

	["finalsmash"] = {
		nomove = true,
		noringbuff = true,
		superarmor = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer == 1
				p.mo.flags = $|MF_NOGRAVITY
				p.mo.state = S_PLAY_SUPER_TRANS1

				p.mo.emeralds = {}
				p.mo.emeraldang = 0
				for i = 1, 7
					local em = P_SpawnMobj(p.mo.y, p.mo.x, p.mo.z, MT_THOK)
					em.sprite = SPR_CEMG
					em.frame = FF_FULLBRIGHT|i
					em.flags = MF_NOGRAVITY|MF_FLOAT|MF_SCENERY
					em.scale = $*3/2
					em.dist = 1024
					em.fuse = 80
					em.tics = 80
					
					p.mo.emeralds[i] = em
				end
			end

			if timer > 10
				p.mo.color = SKINCOLOR_SUPERRED1 + abs(((leveltime >> 1) % 9) - 4)
			end
			
			if timer > 1 and timer < 60
				local ang = p.mo.emeraldang
				for k,v in ipairs(p.mo.emeralds)
					if v and v.valid
						local x = p.mo.x + v.dist*cos(ang)
						local y = p.mo.y + v.dist*sin(ang)
						local z = p.mo.z + 32*cos(leveltime*ANG1*2 + (360/7)*ANG1*i)

						P_TeleportMove(v, x, y, z)
						ang = $+(360/7)*ANG1
						
						v.dist = max(64, $-24)
					end
				end

				p.mo.emeraldang = $+ANG30
			elseif timer >= 60 and timer < 90
				local ang = p.mo.emeraldang
				for k,v in ipairs(p.mo.emeralds)
					if v and v.valid
						local x = p.mo.x + v.dist*cos(ang)
						local y = p.mo.y + v.dist*sin(ang)
						local z = p.mo.z + 32*cos(leveltime*ANG1*2 + (360/7)*ANG1*i)

						P_TeleportMove(v, x, y, z)
						ang = $+(360/7)*ANG1
						
						v.dist = max(1, $-8)
					end
				end

				p.mo.emeraldang = $+ANG20
			elseif timer == 90
				for i = 1, 7
					if p.mo.emeralds[i] and p.mo.emeralds[i].valid
						P_RemoveMobj(p.mo.emeralds[i])
						table.remove(p.mo.emeralds, i)
					end
				end
			end

			if timer > 20
				p.mo.momx = 0
				p.mo.momy = 0
				p.mo.momz = 0
				p.mo.state = S_PLAY_SUPER_TRANS6

				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius,
				p.mo.height, 25, 3, nil, nil, true, sfx_magic3, "punch")
				hitbox.hitcool = 3
				hitbox.fuse = 2

				if twodlevel
					local x = p.mo.x + P_RandomRange(-2769, 2769)*FRACUNIT -- nice
					local rock = s.fireMissile(p.mo, MT_FALLINGROCK, 3)
					
					if rock and rock.valid
						P_TeleportMove(rock, x, p.mo.y, p.mo.ceilingz-100*FRACUNIT)
						
						rock.scale = 5*P_RandomRange(FRACUNIT/2, FRACUNIT)
						rock.fuse = 3*TICRATE
	
						rock.flags = $|MF_NOCLIPHEIGHT
					end
				else
					local x = p.mo.x + P_RandomRange(-3000, 3000)*FRACUNIT
					local y = p.mo.y + P_RandomRange(-3000, 3000)*FRACUNIT
					local rock = s.fireMissile(p.mo, MT_FALLINGROCK, 3)

					if rock and rock.valid
						P_TeleportMove(rock, x, y, p.mo.ceilingz-100*FRACUNIT)

						rock.scale = 5*P_RandomRange(FRACUNIT/2, FRACUNIT)
						rock.fuse = 3*TICRATE
	
						rock.flags = $|MF_NOCLIPHEIGHT
					end
				end
			end
			
			if timer >= 350
				p.rings = 0
				p.powers[pw_super] = 0
				p.mo.color = p.skincolor
				p.mo.emeralds = nil
				p.mo.emeraldang = nil
				
				return true
			end
		end,
	},

	// Thinkers
	["thinker"] = function(mo)
		if mo.attacktype ~= "sidespecial" then mo.slideVictim = nil end
	end,
}