local s = SRB2Smash
if not s.chars then s.chars = {} end

// mobjs
freeslot("MT_METALFS", "S_METALORB")

mobjinfo[MT_METALFS] = {
    spawnstate = S_METALORB,
    radius = 64*FRACUNIT,
    height = 64*FRACUNIT,
	speed = 30*FRACUNIT,
	flags = MF_NOGRAVITY|MF_MISSILE|MF_NOCLIPHEIGHT
}

states[S_METALORB] = {SPR_ENRG, FF_FULLBRIGHT|FF_TRANS20|A, 5*TICRATE, nil, 0, 0, S_NULL}

// states
freeslot("S_PLAY_METAL_NAIR")
states[S_PLAY_METAL_NAIR] = {SPR_PLAY, SPR2_TRNS, 35, nil, 4, 4, S_PLAY_FALL}

s.chars["metalsonic"] = {
	-- General Stats
	["speed"] = 8,
	["weight"] = 9,
	["hud"] = "METAL",
	["win"] = "METALWIN",
	["winbg"] = {-20, 0, "SKY56"},

	-- Attacks
	["jab1"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 30*sin(p.mo.angle), 0, 15*FRACUNIT,
				20*FRACUNIT, 3, 1, FRACUNIT/5, FRACUNIT/3, nil, sfx_punch1, "punch")
				
				hitbox.fuse = 5
			elseif timer == 10
				return true
			end
			
			p.mo.state = S_PLAY_STND
			p.drawangle = p.mo.angle+ANGLE_45
		end,
	},

	["jab2"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 30*sin(p.mo.angle), 0, 15*FRACUNIT,
				32*FRACUNIT, 3, 1, FRACUNIT/5, FRACUNIT/3, nil, sfx_punch1, "punch")
				
				hitbox.fuse = 5
			elseif timer == 10
				return true
			end
			
			p.mo.state = S_PLAY_STND
			p.drawangle = p.mo.angle-ANGLE_45
		end,
	},

	["jab3"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 30*sin(p.mo.angle), 0, 15*FRACUNIT,
				p.mo.height, 5, 2, 7*FRACUNIT, 5*FRACUNIT, true, sfx_elec2, "punch")

				hitbox.fuse = 5
			elseif timer == 15
				p.mo.state = S_PLAY_STND
				return true
			end
			
			p.mo.state = S_PLAY_SPRING
		end,
	},

	["dash"] = {
		nomove = true,
		superarmor = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer < 30
				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius, p.mo.height,
				2, 3, 9*FRACUNIT, 2*FRACUNIT, false, sfx_punch2, "punch")
				hitbox.fuse = 2
				hitbox.hitlag = 1
				hitbox.hitcool = 5
				
				p.mo.momz = 0
				P_InstaThrust(p.mo, p.mo.angle, 19*FRACUNIT)
				P_SpawnGhostMobj(p.mo)
				
				p.mo.state = S_PLAY_NIGHTS_DRILL
			end
			
			if timer == 30 
				p.mo.state = S_PLAY_RUN
				return true
			end
		end,
	},

	["uptilt"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius,
				p.mo.height + 10*FRACUNIT, 5, 2, P_RandomRange(-3, 3)*FRACUNIT, 10*FRACUNIT, true,
				sfx_punch2, "punch")
				
				hitbox.fuse = 8
				P_SetObjectMomZ(p.mo, 3*FRACUNIT)
			elseif timer == 16
				p.mo.state = S_PLAY_STND
				return true
			end
			
			if P_IsObjectOnGround(p.mo)
				p.mo.state = S_PLAY_CROUCH
			else
				p.mo.state = S_PLAY_SPRING
				p.drawangle = timer*ANGLE_45
			end
		end,
	},

	["sidetilt"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1	
				P_Thrust(p.mo, p.mo.angle, 5*FRACUNIT)

				local hitbox = s.drawHitBox(p, 20*cos(p.mo.angle), 20*sin(p.mo.angle),
				10*FRACUNIT, 20*FRACUNIT, 10*FRACUNIT, 8, 2, 9*FRACUNIT, 4*FRACUNIT,
				true, sfx_sword2, "slash")
				
				hitbox.fuse = 5
			elseif timer == 15
				return true
			end
			
			p.mo.state = S_PLAY_DASH
			p.mo.drawangle = p.mo.angle + ANGLE_45
		end,
	},

	["neutralair"] = {
		nomove = true,
		anim = function(p, timer)
			if timer >= 3 and timer < 13
				p.mo.state = S_PLAY_METAL_NAIR

				local zapthing = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z-31*FRACUNIT, MT_THOK)
				zapthing.sprite = SPR_ENRG
				zapthing.frame = FF_FULLBRIGHT|FF_TRANS20|A
				zapthing.fuse = 2
			end

			if timer > 2 and timer < 10
				local hitbox = s.drawHitBox(p, 0, 0, -p.mo.height/2, p.mo.radius*3,
				p.mo.height*2, 1, 2, p.speed, p.mo.momz, false, sfx_elec1, "elec")
				hitbox.angle = p.mo.angle
				hitbox.hitcool = 2
				hitbox.hitlag = 2
				hitbox.fuse = 2
			elseif timer >= 10 and timer <= 14
				local hitbox = s.drawHitBox(p, 0, 0, -p.mo.height/2, p.mo.radius*3,
				p.mo.height*2, 6, 3, 6*FRACUNIT, 5*FRACUNIT, true, sfx_elec2, "elec")
				hitbox.hitcool = 10
				hitbox.hitlag = 10
				hitbox.fuse = 2
			end

			if timer == 7 then S_StartSound(p.mo, sfx_cdfm34) end

			if timer >= 24
				p.mo.state = S_PLAY_FALL
				return true
			end				
		end
	},
	
	["upair"] = {
		anim = function(p, timer)
			if timer == 1
				p.mo.momz = $/2

				local hitbox = s.drawHitBox(p, 0, 0, p.mo.height, p.mo.radius,
				25*FRACUNIT, 8, 2, P_RandomRange(-5, 5)*FRACUNIT, 13*FRACUNIT, true,
				sfx_punch2, "punch")
				
				hitbox.fuse = 4
			elseif timer == 10 or P_IsObjectOnGround(p.mo)
				p.mo.state = S_PLAY_FALL
				return true
			end
			
			p.mo.state = S_PLAY_SPRING
			p.drawangle = timer*ANGLE_45
		end,
	},
	
	["downair"] = {
		anim = function(p, timer)
			if timer == 1
				P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z-26*FRACUNIT, MT_SUPERSPARK)
			end

			if timer < 5
				p.mo.frame = A
				p.mo.state = S_PLAY_RIDE
				p.mo.sprite2 = SPR2_RIDE
			elseif timer == 5
				local hitbox = s.drawHitBox(p, 0, 0, -25*FRACUNIT, p.mo.radius,
				25*FRACUNIT, 7, 2, 4*FRACUNIT, FRACUNIT, true, sfx_kick2, "punch")
				hitbox.fuse = 8

				local spike = s.drawHitBox(p, 0, 0, -33*FRACUNIT, p.mo.radius-20*FRACUNIT,
				15*FRACUNIT, 10, 3, 4*FRACUNIT, -20*FRACUNIT, true, sfx_kick3, "spike")
				spike.fuse = 5
			elseif timer == 15 or P_IsObjectOnGround(p.mo)
				p.mo.state = S_PLAY_JUMP
				return true
			end
			
			if timer >= 10 and timer < 15
				p.mo.state = S_PLAY_FALL
				p.drawangle = timer*ANGLE_45

				if not S_SoundPlaying(p.mo, sfx_s3k47)
					S_StartSound(p.mo, sfx_s3k47)
				end
			end
		end,
	},
	
	["sideair"] = {
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 20*cos(p.mo.angle), 20*sin(p.mo.angle),
				0, 20*FRACUNIT, p.mo.height, 5, 2, 10*FRACUNIT, 1, true, sfx_kick2, "punch")
				hitbox.fuse = 8
			elseif timer >= 13
				p.mo.state = S_PLAY_FALL
				return true
			end

			if timer < 10 then p.mo.state = S_PLAY_DASH end
		end,
	},
	
	["neutralspecial"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if p.mo.chargeBall and (timer <= 3 and p.mo.chargeBall >= 175)
				p.mo.shootBall = 35
			end
			
			if p.mo.shootBall
				p.mo.shootBall = $-1

				if p.mo.shootBall > 20
					p.mo.state = S_PLAY_CROUCH
				else
					p.mo.state = S_PLAY_SPRING
				end

				if p.mo.shootBall == 20
					local useScale = (FRACUNIT/4) + ((p.mo.chargeBall*FRACUNIT)/175)
					local energy = s.fireMissile(p.mo, MT_ENERGYBALL, 3)

					if energy and energy.valid
						energy.color = p.mo.color
						energy.colorized = true
						energy.scale = useScale
						energy.fuse = 8*TICRATE
					end
				end

				if p.mo.shootBall <= 0
					p.mo.state = S_PLAY_STND
					p.mo.chargeBall = 0
					p.mo.shootBall = nil
					return true
				end
			else
				p.mo.state = S_PLAY_CROUCH
				p.mo.chargeBall = $ and $+1 or 1

				if p.mo.button.left > 0
					s.dodgeRoll(p.mo, "left")
					return true
				elseif p.mo.button.right > 0
					s.dodgeRoll(p.mo, "right")
					return true
				elseif p.mo.button.spin
					p.mo.state = S_PLAY_STND
					return true
				end

				if (p.specialBtn == "fire" and p.mo.button.attack == 1) or (p.specialBtn == "custom1" and p.mo.button.custom1 == 1)
					p.mo.shootBall = 35
				end

				local gatherBall = P_SpawnMobj(p.mo.x + P_RandomRange(-300, 300)*FRACUNIT, p.mo.y + P_RandomRange(-300, 300)*FRACUNIT, p.mo.z + P_RandomRange(0, 300)*FRACUNIT, MT_MSGATHER)
				gatherBall.target = p.mo
				gatherBall.tracer = p.mo

				if p.mo.chargeBall >= 175
					p.mo.state = S_PLAY_STND
					p.mo.shootBall = nil
					return true
				end
			end
		end,
	},
	
	["sidespecial"] = {
		nomove = true,
		noreuse = true,
		superarmor = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer <= 5
				p.mo.state = S_PLAY_FALL

				p.mo.momx = ($/5)*4
				p.mo.momy = ($/5)*4
				p.mo.momz = 2*FRACUNIT*P_MobjFlip(p.mo)
				P_Thrust(p.mo, p.mo.angle, -FRACUNIT)
			end

			if timer > 5 and timer < 18
				p.mo.momz = 0
				if timer < 13 then P_Thrust(p.mo, p.mo.angle, 4*FRACUNIT) end
				P_SpawnGhostMobj(p.mo)

				p.mo.state = S_PLAY_DASH

				local x, y = -10*cos(p.mo.angle), -10*sin(p.mo.angle)
				local hitbox = s.drawHitBox(p, x, y, 0, p.mo.radius + (20*FRACUNIT),
				p.mo.height, 5, 3, FRACUNIT, 15*FRACUNIT, false, sfx_sword2, "slash")
				hitbox.hitstun = 10
				hitbox.hitlag = 2
				hitbox.fuse = 2
			end

			if timer > 18 and timer <= 35
				p.mo.state = S_PLAY_DASH
				p.mo.momx = ($/4)*3
				p.mo.momy = ($/4)*3
				p.mo.momz = 0
			end
			
			if timer >= 35
				p.mo.state = S_PLAY_FALL
				return true
			end
		end,
	},
	
	["upspecial"] = {
		nomove = true,
		noreuse = true,
		superarmor = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer == 1 then S_StartSound(p.mo, sfx_s3k5c) end
			if timer == 20 then S_StartSound(p.mo, sfx_buzz1) end

			if timer < 10
				local zapthing = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z-31*FRACUNIT, MT_THOK)
				zapthing.sprite = SPR_ENRG
				zapthing.frame = FF_FULLBRIGHT|FF_TRANS20|A
				zapthing.fuse = 2

				p.mo.momx = ($/6)*5
				p.mo.momy = ($/6)*5
				p.mo.momz = ($/6)*5
				p.mo.state = S_PLAY_FALL

				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius*2,
				p.mo.height, 1, 3, 1, 2*FRACUNIT, false, sfx_elec1, "punch")
				hitbox.hitcool = 3
				hitbox.hitlag = 1
				hitbox.fuse = 2
			end
			
			if timer > 10 and timer <= 25
				p.mo.state = S_PLAY_SPRING
				P_SetObjectMomZ(p.mo, 22*FRACUNIT)
				P_SpawnGhostMobj(p.mo)

				if timer <= 21
					local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius*2, p.mo.height, 1, 2, 1, 22*FRACUNIT, false, sfx_elec2, "punch")
					hitbox.hitcool = 2
					hitbox.hitlag = 3
					hitbox.fuse = 2
				else
					local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius*2, p.mo.height, 4, 3, 1, 10*FRACUNIT, true, sfx_elec2, "punch")
					hitbox.hitcool = 5
					hitbox.hitlag = 10
					hitbox.fuse = 2
				end

				local zapthing = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z-31*FRACUNIT, MT_THOK)
				zapthing.sprite = SPR_ENRG
				zapthing.scale = FRACUNIT/2
				zapthing.destscale = 3*FRACUNIT
				zapthing.tics = 15
			end
			
			if timer >= 28
				p.mo.momx = ($/6)*5
				p.mo.momy = ($/6)*5
				p.mo.momz = ($/6)*5
				p.mo.state = S_PLAY_ROLL
				return true
			end
		end
	},
	
	["downspecial"] = {
		nomove = true,
		noreuse = true,
		superarmor = true,
		nogroundreset = true,
		repelprojectiles = true,
		anim = function(p, timer)
			if not p.mo.shieldHp then return true end
			if p.mo.shieldHp <= 0 then return true end

			p.mo.state = S_PLAY_FALL
			p.mo.momx = ($/5)*4
			p.mo.momy = ($/5)*4

			if timer == 1
				S_StartSound(p.mo, sfx_cdfm34)
				
				p.mo.blackShield = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_FORCE_ORB)
				p.mo.blackShield.color = SKINCOLOR_BLACK
				p.mo.blackShield.colorized = true
				p.mo.blackShield.fuse = 22
				
				if p.mo.shieldHp == 2
					p.mo.blackShield.frame = FF_TRANS30|A
				elseif p.mo.shieldHp == 1
					p.mo.blackShield.frame = FF_TRANS70|A
				end
			elseif timer <= 13
				local hitbox = s.drawHitBox(p, 0, 0, -2*FRACUNIT, p.mo.radius+15*FRACUNIT, p.mo.height+5*FRACUNIT,
				2, 2, 9*FRACUNIT, 2*FRACUNIT, false, sfx_elec1, "punch")
				hitbox.hitlag = 2
				hitbox.hitcool = 2
				hitbox.fuse = 2
				
				if p.mo.blackShield and p.mo.blackShield.valid
					P_TeleportMove(p.mo.blackShield, p.mo.x, p.mo.y, p.mo.z)
				
					if not (leveltime%3)
						local ghost = P_SpawnGhostMobj(p.mo.blackShield)
						ghost.destscale = 3*FRACUNIT
					end
				else
					p.mo.blackShield = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_FORCE_ORB)
					p.mo.blackShield.color = SKINCOLOR_BLACK
					p.mo.blackShield.colorized = true
				end
			elseif timer <= 30
				if p.mo.blackShield
					if p.mo.blackShield.valid then P_RemoveMobj(p.mo.blackShield) end
					p.mo.blackShield = nil
				end

				p.mo.state = S_PLAY_CROUCH
			else
				if P_IsObjectOnGround(p.mo)
					p.mo.state = S_PLAY_STND
				else
					p.mo.state = S_PLAY_ROLL
				end

				return true
			end
		end,
		strikeFunc = function(mo, inf)
			if not mo.shieldHp then mo.shieldHp = 3 end
			mo.shieldHp = $-1
		end,
	},
	
	["upblast"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer <= 15
				p.mo.state = S_PLAY_CROUCH
			else
				p.mo.state = S_PLAY_SPRING
			end

			if timer == 17
				local hitbox = s.drawHitBox(p, 0, 0, (p.mo.height/3)*2, p.mo.radius*3,
				p.mo.height, 16, 3, 4*FRACUNIT, 10*FRACUNIT, true, sfx_elec2,
				"punch", EFF_ELECTRICSTUN)
				hitbox.hitlag = 15
				hitbox.hitcool = 1
				hitbox.fuse = 2
				
				local thok = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
				thok.sprite = SPR_ENRG
				thok.scale = FRACUNIT/3
				thok.destscale = 4*FRACUNIT
				thok.tics = 20
				thok.fuse = 35
			end

			if timer >= 33
				p.mo.state = S_PLAY_STND
				return true
			end
		end
	},

	["downblast"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer == 11 then S_StartSound(p.mo, sfx_pstop) end
			if timer <= 10 then p.mo.state = S_PLAY_SPRING else p.mo.state = S_PLAY_CROUCH end

			if timer <= 12 and timer >= 8
				for i = -1, 1
					local elec = P_SpawnMobj(p.mo.x+(p.mo.radius*i), p.mo.y, p.mo.z, MT_THOK)
					elec.flags = $ & ~MF_NOGRAVITY
					elec.sprite = SPR_ENRG
					elec.fuse = TICRATE
					elec.scale = FRACUNIT/2
					elec.momz = 10*FRACUNIT
				end
			end

			if timer == 12
				local hitbox = s.drawHitBox(p, p.mo.radius, 0, 0, (p.mo.radius*3)/2,
				p.mo.height, 14, 3, 2*FRACUNIT, 10*FRACUNIT, true, sfx_elec2, "punch",
				EFF_ELECTRICSTUN)
				hitbox.hitlag = 15
				hitbox.fuse = 7

				local hitbox2 = s.drawHitBox(p, -p.mo.radius, 0, 0, (p.mo.radius*3)/2,
				p.mo.height, 14, 3, -2*FRACUNIT, 10*FRACUNIT, true, sfx_elec2, "punch",
				EFF_ELECTRICSTUN)
				hitbox2.hitlag = 15
				hitbox2.fuse = 7
			end

			if timer >= 25
				p.mo.state = S_PLAY_STND
				return true
			end
		end
	},

	["blast"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer == 10
				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 30*sin(p.mo.angle),
				0, p.mo.radius*4, (p.mo.height*3)/2, 17, 3, 14*FRACUNIT, 5*FRACUNIT,
				true, sfx_elec2, "punch", EFF_ELECTRICSTUN)
				hitbox.hitlag = 20
				hitbox.fuse = 7

				local thok = P_SpawnMobj(p.mo.x + 70*cos(p.mo.angle), p.mo.y + 70*sin(p.mo.angle), p.mo.z, MT_THOK)
				thok.sprite = SPR_ENRG
				thok.scale = FRACUNIT/3
				thok.destscale = 4*FRACUNIT
				thok.tics = 20
				thok.fuse = 35

				P_Thrust(p.mo, p.mo.angle, 6*FRACUNIT)
			end

			if timer < 20 then
				p.mo.state = S_PLAY_SPRING
			else
				p.mo.state = S_PLAY_STND
				return true
			end
		end
	},
	
	["finalsmash"] = {
		nomove = true,
		noringbuff = true,
		superarmor = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer == 1
				p.mo.flags = $|MF_NOGRAVITY
				p.mo.state = S_PLAY_SUPER_TRANS1

				p.mo.emeralds = {}
				p.mo.emeraldang = 0
				for i = 1, 7
					local em = P_SpawnMobj(p.mo.y, p.mo.x, p.mo.z, MT_THOK)
					em.sprite = SPR_CEMG
					em.frame = FF_FULLBRIGHT|i
					em.flags = MF_NOGRAVITY|MF_FLOAT|MF_SCENERY
					em.scale = $*3/2
					em.dist = 1024
					em.fuse = 80
					em.tics = 80
					
					p.mo.emeralds[i] = em
				end
			end

			if timer > 10
				p.mo.color = SKINCOLOR_SUPERTAN1 + abs(((leveltime >> 1) % 9) - 4)
			end
			
			if timer > 1 and timer < 60
				local ang = p.mo.emeraldang
				for k,v in ipairs(p.mo.emeralds)
					if v and v.valid
						local x = p.mo.x + v.dist*cos(ang)
						local y = p.mo.y + v.dist*sin(ang)
						local z = p.mo.z + 32*cos(leveltime*ANG1*2 + (360/7)*ANG1*i)

						P_TeleportMove(v, x, y, z)
						ang = $+(360/7)*ANG1
						
						v.dist = max(64, $-24)
					end
				end

				p.mo.emeraldang = $+ANG30
			elseif timer >= 60 and timer < 90
				local ang = p.mo.emeraldang
				for k,v in ipairs(p.mo.emeralds)
					if v and v.valid
						local x = p.mo.x + v.dist*cos(ang)
						local y = p.mo.y + v.dist*sin(ang)
						local z = p.mo.z + 32*cos(leveltime*ANG1*2 + (360/7)*ANG1*i)

						P_TeleportMove(v, x, y, z)
						ang = $+(360/7)*ANG1
						
						v.dist = max(1, $-8)
					end
				end

				p.mo.emeraldang = $+ANG20
			elseif timer == 90
				for i = 1, 7
					if p.mo.emeralds[i] and p.mo.emeralds[i].valid
						P_RemoveMobj(p.mo.emeralds[i])
						table.remove(p.mo.emeralds, i)
					end
				end
			end

			p.mo.momz = 0
			
			for i = 1, 5
				local thok = P_SpawnMobj(p.mo.x + P_RandomRange(-5000, 5000)*FRACUNIT, p.mo.y + P_RandomRange(-5000, 5000)*FRACUNIT, p.mo.z - 300*FRACUNIT, MT_THOK)
				thok.tics = 3*TICRATE
				thok.fuse = -1
				thok.color = SKINCOLOR_BLUE
				
				thok.momz = 3*FRACUNIT
			end

			if timer > 20
				p.mo.state = S_PLAY_SUPER_TRANS6

				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius,
				p.mo.height, 9, 3, nil, nil, true, sfx_magic3, "punch")
				hitbox.hitcool = 2
				hitbox.fuse = 2

				if timer > 35
					if not p.mo.shootAng then p.mo.shootAng = 0 end
					P_StartQuake(30*FRACUNIT, 10)

					if p.mo.button.up and p.mo.shootAng < 10
						p.mo.shootAng = $+1
					elseif p.mo.button.down and p.mo.shootAng > -10
						p.mo.shootAng = $-1
					end

					if not (leveltime%2)
						local laser = P_SPMAngle(p.mo, MT_METALFS, p.mo.angle)
						if laser and laser.valid
							laser.scale = 2*FRACUNIT
							laser.momz = p.mo.shootAng*FRACUNIT
						end
					end
				end
			end
			
			if timer >= 350
				p.rings = 0
				p.powers[pw_super] = 0
				p.mo.color = p.skincolor
				p.mo.emeralds = nil
				p.mo.emeraldang = nil
				
				return true
			end
		end,
	},
	
	["thinker"] = function(mo)
		if not (leveltime%100)
			if mo.shieldHp
				mo.shieldHp = $+1
				if mo.shieldHp > 3 then mo.shieldHp = 3 end
			else
				mo.shieldHp = 1
			end
		end

		if mo.blackShield and mo.attacktype ~= "downspecial"
			if mo.blackShield.valid then P_RemoveMobj(mo.blackShield) end
			mo.blackShield = nil
		end
	end
}