local s = SRB2Smash

s.mobjDefs[MT_SONICSLASH] = {
	hitstun = 9,
	hitlag = 5,
	hitcool = 7,
	hitsound = sfx_sword2,
	nokill = true,
	dmg = 5,
	dynamicknockback = function(mo, targ)
		if mo.state == S_SONICSLASH1 or mo.state == S_SONICSLASH1
			return 6*FRACUNIT, -6*FRACUNIT, true
		else
			return 6*FRACUNIT, 3*FRACUNIT, false
		end
	end,
}

s.mobjDefs[MT_SONICWAVE] = {
	hitstun = 9,
	hitlag = 5,
	hitcool = 7,
	hitsound = sfx_sword2,
	nokill = true,
	dmg = 5,
	x = 1,
	y = 8*FRACUNIT
}

s.mobjDefs[MT_TAILSTORNADO] = {
	hitlag = 2,
	hitcool = 4,
	hitstun = 35,
	dmg = 12,
	nokill = true,
	x = 2*FRACUNIT,
	y = 5*FRACUNIT,
	mod = false,
	norepel = true,
	hitsound = sfx_pstop,
}

s.mobjDefs[MT_HEARTTYPHOON] = {
	hitstun = 10,
	hitlag = 3,
	hitcool = 3,
	hitsound = sfx_magic1,
	nokill = true,
	dmg = 4,
	mod = false,
	dynamicknockback = function(mo, targ)
		if mo.state == S_TYPHOON_REMAIN and mo.tics < 5
			return 1, 8*FRACUNIT, true
		else
			return 1, 4*FRACUNIT, false
		end
	end,
}

s.mobjDefs[MT_AIRSLASH] = {
	hitstun = 15,
	hitlag = 3,
	hitcool = 2,
	hitsound = sfx_sword2,
	nokill = true,
	dmg = 3,
	mod = false,
	dynamicknockback = function(mo, targ)
		if mo.state == S_AIRSLASH_SPIN and mo.tics < 5
			return 3*FRACUNIT, 6*FRACUNIT, true
		else
			return 1, 3*FRACUNIT, false
		end
	end,
}

s.mobjDefs[MT_ROCKET] = {
	x = 8*FRACUNIT,
	y = 6*FRACUNIT,
	mod = false,
	dmg = 4,
	hitsound = sfx_fire2,
	hiteffect = "fire"
}

s.mobjDefs[MT_ENERGYBALL] = {
	hitstun = 10,
	hitlag = 10,
	hitcool = 10,
--	hiteffect = "elec",
	hitsound = sfx_elec2,
	status = EFF_ELECTRICSTUN,
	dynamicdmg = function(mo, targ)
		if mo.scale >= FRACUNIT+(FRACUNIT/4)-40 --safecheck
			return 28, false
		elseif mo.scale >= FRACUNIT
			return 24, false
		elseif mo.scale >= 3*FRACUNIT/4
			return 19, false
		elseif mo.scale >= FRACUNIT/2
			return 15, false
		else
			return 10, true
		end
	end,
	dynamicknockback = function(mo, targ)
		if mo.scale >= FRACUNIT+(FRACUNIT/4)-40 --safecheck
			return 12*FRACUNIT, 5*FRACUNIT, true
		elseif mo.scale >= FRACUNIT
			return 10*FRACUNIT, 4*FRACUNIT, true
		elseif mo.scale >= 3*FRACUNIT/4
			return 7*FRACUNIT, 3*FRACUNIT, true
		elseif mo.scale >= FRACUNIT/2
			return 5*FRACUNIT, 3*FRACUNIT, true
		else
			return 3*FRACUNIT, 1, false
		end
	end,
}

s.mobjDefs[MT_CORK] = {
	hitstun = 3,
	hitlag = 10,
	hitcool = 1,
	hitsound = sfx_kick2,
	x = 3*FRACUNIT,
	y = FRACUNIT,
	mod = false,
	dmg = 3,
}

s.mobjDefs[MT_GROUNDCORK] = {
	hitstun = 15,
	hitlag = 10,
	hitcool = 1,
	hitsound = sfx_kick3,
	x = 9*FRACUNIT,
	y = 3*FRACUNIT,
	mod = true,
	dmg = 10,
}

s.mobjDefs[MT_NAPALMBOMB] = {
	hiteffect = "fire",
	hitsound = sfx_fire3,
	dynamicdmg = function(missile, mo)
		if not P_IsObjectOnGround(missile)
			return 3, false
		else
			return 20, true
		end
	end
}

s.mobjDefs[MT_FBOMB] = {
	hitstun = 5,
	hitlag = 5,
	hiteffect = "fire",
	hitsound = sfx_fire3,
	x = 10*FRACUNIT,
	y = 5*FRACUNIT,
	mod = true,
	dmg = 5,
	status = EFF_BURN
}

/*
s.mobjDefs[MT_SMOKEBOMB] = {
	x = FRACUNIT,
	y = FRACUNIT,
	hiteffect = "fire",
	hitsound = sfx_pstop,
	hitstun = 2,
	hitcool = 2,
	dynamicdmg = function(missile, mo)
		if missile.state == S_SMOKEBOMB_DISPERSE
			return 1, false
		else
			return 8, false
		end
	end
}
*/

s.mobjDefs[MT_METALFS] = {
	hitlag = 1,
	hitcool = 2,
	hitstun = 35,
	dmg = 3,
	nokill = true,
	x = 5*FRACUNIT,
	y = 5*FRACUNIT,
	mod = false,
	norepel = true,
	hitsound = sfx_elec2,
}

s.mobjDefs[MT_SMASH_HEART] = {
	hitsound = sfx_magic2,
	hitcool = 0,
	hitlag = 1,
	nostun = true,
	mod = false,
	dmg = 3,
}

s.mobjDefs[MT_AMYFS_OBJ] = {
	hitsound = sfx_kick2,
	hitstun = 10,
	hitcool = 5,
	hitlag = 5,
	nokill = true,
	x = 7*FRACUNIT,
	y = 4*FRACUNIT,
	mod = true,
	dmg = 10,
}

s.mobjDefs[MT_FALLINGROCK] = {
	hitsound = sfx_punch3,
	hitstun = 13,
	hitlag = 3,
	hitcool = 5,
	x = 1,
	y = -15*FRACUNIT,
	mod = true,
	dmg = 22,
}