local s = SRB2Smash
if not s.chars then s.chars = {} end

// States
freeslot("S_PLAY_SONIC_UPAIR", "SPR2_UPAR", "S_PLAY_SONIC_DAIR", "SPR2_DAIR")
states[S_PLAY_SONIC_UPAIR] = {SPR_PLAY, SPR2_UPAR, 35, nil, 0, 0, S_PLAY_FALL}
states[S_PLAY_SONIC_DAIR] = {SPR_PLAY, SPR2_DAIR, 35, nil, 0, 0, S_PLAY_FALL}

// Mobjs
freeslot("MT_INSTASHIELD", "S_INSTASHIELD", "SPR_INSH", "MT_SONICSLASH", "MT_SONICWAVE", "S_SONICSLASH1", "S_SONICSLASH2", "S_SONICSLASH3", "S_SONICSLASH4", "S_SONICSLASH5", "S_SONICWAVE", "SPR_SSLA")

mobjinfo[MT_INSTASHIELD] = {
    spawnstate = S_INSTASHIELD,
    radius = 1*FRACUNIT,
    height = 1*FRACUNIT,
	flags = MF_NOGRAVITY|MF_FLOAT|MF_SCENERY|MF_NOCLIPHEIGHT
}

states[S_INSTASHIELD] = {SPR_INSH, FF_ANIMATE|A, 14, nil, 7, 2, S_NULL}

mobjinfo[MT_SONICSLASH] = {
    spawnstate = S_SONICSLASH1,
	speed = 7*FRACUNIT,
    radius = 30*FRACUNIT,
    height = 30*FRACUNIT,
	flags = MF_NOGRAVITY|MF_MISSILE
}

states[S_SONICSLASH1] = {SPR_SSLA, FF_PAPERSPRITE|FF_TRANS70|A, 4, nil, 0, 0, S_SONICSLASH2}
states[S_SONICSLASH2] = {SPR_SSLA, FF_PAPERSPRITE|FF_TRANS30|B, 4, nil, 0, 0, S_SONICSLASH3}
states[S_SONICSLASH3] = {SPR_SSLA, FF_PAPERSPRITE|A, 20, nil, 0, 0, S_SONICSLASH4}
states[S_SONICSLASH4] = {SPR_SSLA, FF_PAPERSPRITE|FF_TRANS30|B, 4, nil, 0, 0, S_SONICSLASH5}
states[S_SONICSLASH5] = {SPR_SSLA, FF_PAPERSPRITE|FF_TRANS70|A, 4, nil, 0, 0, S_NULL}

mobjinfo[MT_SONICWAVE] = {
    spawnstate = S_SONICWAVE,
	speed = 7*FRACUNIT,
    radius = 25*FRACUNIT,
    height = 15*FRACUNIT,
	flags = MF_NOCLIPHEIGHT|MF_MISSILE
}

states[S_SONICWAVE] = {SPR_NULL, A, 36, nil, 0, 0, S_NULL}

addHook("MobjThinker", function(mo)
	P_SpawnGhostMobj(mo)
	if mo.state == S_SONICSLASH3 then mo.frame = FF_PAPERSPRITE|(leveltime%2) end
end, MT_SONICSLASH)

addHook("MobjThinker", function(mo)
	P_InstaThrust(mo, mo.angle, 10*FRACUNIT)

	if not (leveltime%4)
		local wave = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SMASH_DUMMY)
		wave.scale = FRACUNIT
		wave.destscale = 4*FRACUNIT
		wave.color = mo.color
		wave.fuse = 10

		wave.sprite = SPR_SSLA
		wave.frame = FF_PAPERSPRITE|FF_TRANS20|(3 + (leveltime%2))
	end
end, MT_SONICWAVE)

s.chars["sonic"] = {
	-- General Stats
	["speed"] = 9,
	["weight"] = 4,
	["hud"] = "SONIC",
	["win"] = "SONICWIN",
	["winbg"] = {0, -80, "SKY2"},
	
	-- Attacks
	["jab1"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 30*sin(p.mo.angle), 0, 15*FRACUNIT,
				20*FRACUNIT, 3, 1, FRACUNIT/5, FRACUNIT/3, false, sfx_punch1, "punch")
				
				hitbox.fuse = 5
			elseif timer == 10
				return true
			end
			
			p.mo.state = S_PLAY_STND
			p.drawangle = p.mo.angle+ANGLE_45
		end
	},

	["jab2"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 30*sin(p.mo.angle), 0, 15*FRACUNIT,
				32*FRACUNIT, 3, 1, FRACUNIT/5, FRACUNIT/3, nil, sfx_punch1, "punch")
				
				hitbox.fuse = 5
			elseif timer == 10
				return true
			end
			
			p.mo.state = S_PLAY_STND
			p.drawangle = p.mo.angle-ANGLE_45
		end,
	},

	["jab3"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 30*sin(p.mo.angle), 0, 15*FRACUNIT,
				p.mo.height, 5, 2, 7*FRACUNIT, 5*FRACUNIT, nil, sfx_punch1, "punch")
				
				hitbox.fuse = 5
			elseif timer == 15
				p.mo.state = S_PLAY_STND
				return true
			end
			
			p.mo.state = S_PLAY_NIGHTS_DRILL
		end,
	},
	
	["dash"] = {
		nomove = true,
		superarmor = true,
		anim = function(p, timer)
			if timer < 15
				P_InstaThrust(p.mo, p.mo.angle, 19*FRACUNIT)
				
				p.mo.state = S_PLAY_ROLL
				local orb = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SMASH_DUMMY)
				orb.fuse = 2
				orb.sprite = SPR_FIRS
				orb.frame = FF_FULLBRIGHT|S
				orb.angle = p.mo.angle

				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius, p.mo.height,
				2, 3, p.speed, 2*FRACUNIT, false, sfx_fire1, "fire")
				hitbox.hitcool = 1
				hitbox.hitlag = 4
				hitbox.fuse = 2
			else
				local hitbox = s.drawHitBox(p, p.mo.radius, 0, 0, p.mo.radius*2,
				p.mo.height, 2, 3, 10*FRACUNIT, 4*FRACUNIT, true, sfx_fire3, "fire-sweet")
				hitbox.hitcool = 1
				hitbox.hitlag = 4
				hitbox.fuse = 2

				p.mo.hitcool = 4
				p.mo.state = S_PLAY_RUN
				if timer >= 19 then return true end
			end
		end
	},

	["uptilt"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius,
				p.mo.height + 10*FRACUNIT, 4, 2, P_RandomRange(-3, 3)*FRACUNIT, 10*FRACUNIT, true,
				sfx_punch2, "punch")
				hitbox.fuse = 8
				
				local sweet = s.drawHitBox(p, 0, 0, 0, 10*FRACUNIT, p.mo.height + 10*FRACUNIT,
				8, 3, P_RandomRange(-1, 1)*FRACUNIT, 12*FRACUNIT, true, sfx_punch2, "sweet")
				sweet.fuse = 5
				P_SetObjectMomZ(p.mo, 3*FRACUNIT)
			elseif timer == 16
				p.mo.state = S_PLAY_STND
				return true
			end
			
			if P_IsObjectOnGround(p.mo)
				p.mo.state = S_PLAY_CROUCH
			else
				p.mo.state = S_PLAY_SPRING
				p.drawangle = timer*ANGLE_45
			end
		end,
	},

	["sidetilt"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 20*cos(p.mo.angle), 20*sin(p.mo.angle), 0, 20*FRACUNIT,
				p.mo.height, 4, 2, 10*FRACUNIT, 3*FRACUNIT, nil, sfx_punch2, "punch")
				
				hitbox.fuse = 5
			elseif timer == 15
				p.mo.state = S_PLAY_STND
				return true
			end
			
			p.mo.state = S_PLAY_NIGHTS_DRILL
		end,
	},
	
	["neutralair"] = {
		anim = function(p, timer)
			p.mo.state = S_PLAY_ROLL

			if timer == 2
				local hitbox = s.drawHitBox(p, 0, 0, -p.mo.height/2, (p.mo.radius*5)/2,
				(p.mo.height*3)/2, 4, 2, nil, nil, true, sfx_kick1, "punch")
				hitbox.fuse = 8

				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius/3, p.mo.height/4,
				6, 3, 8*FRACUNIT, FRACUNIT, true, sfx_kick1, "sweet")
				hitbox.fuse = 8
			end

			if not p.mo.instaShield or not p.mo.instaShield.valid then
				p.mo.instaShield = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_INSTASHIELD)				
				S_StartSound(p.mo, sfx_s3k42)
			else
				P_TeleportMove(p.mo.instaShield, p.mo.x, p.mo.y, p.mo.z)
			end

			if timer >= 13 then
				if P_IsObjectOnGround(p.mo)
					p.mo.state = S_PLAY_STND
				else
					p.mo.state = S_PLAY_FALL
				end
				
				return true
			end				
		end
	},

	["upair"] = {
		anim = function(p, timer)
			if timer == 1 or timer == 3 or timer == 5 or timer == 7 or timer == 10 or timer == 14 then p.mo.state = S_PLAY_SONIC_UPAIR end

			if timer == 4 then
				local hitbox = s.drawHitBox(p, 0, 0, p.mo.height/2,
				p.mo.radius*2, p.mo.height, 5, 2, P_RandomRange(-1, 1)*FRACUNIT,
				12*FRACUNIT, true, sfx_punch2, "punch")
				hitbox.fuse = 9
			elseif timer == 10 then
				local hitbox = s.drawHitBox(p, -p.mo.radius/2, 0, -20*FRACUNIT,
				16*FRACUNIT, 16*FRACUNIT, 9, 3, 1, -10*FRACUNIT, true, sfx_punch3, "sweet")
				hitbox.hitlag = 15
				hitbox.fuse = 4
			elseif timer >= 16 then
				p.mo.state = S_PLAY_FALL
				return true
			end
		end,
	},
	
	["downair"] = {
		anim = function(p, timer)
			if timer == 1 then P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z-26*FRACUNIT, MT_SUPERSPARK) end

			if timer < 5
				p.mo.frame = A
				p.mo.state = S_PLAY_RIDE
				p.mo.sprite2 = SPR2_RIDE
			elseif timer == 5
				p.mo.state = S_PLAY_FALL

				local hitbox = s.drawHitBox(p, 0, 0, -25*FRACUNIT, p.mo.radius,
				25*FRACUNIT, 6, 2, 5*FRACUNIT, FRACUNIT, true, sfx_kick2, "punch")
				hitbox.fuse = 8

				local spike = s.drawHitBox(p, 0, 0, -35*FRACUNIT, p.mo.radius-20*FRACUNIT,
				15*FRACUNIT, 9, 3, 5*FRACUNIT, -15*FRACUNIT, true, sfx_kick3, "spike")
				spike.fuse = 5
			elseif timer == 15
				p.mo.state = S_PLAY_JUMP
				return true
			end
		end,
	},
	
	["sideair"] = {
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 20*cos(p.mo.angle), 20*sin(p.mo.angle),
				0, 20*FRACUNIT, p.mo.height, 7, 2, 10*FRACUNIT, 2*FRACUNIT, true, sfx_kick2, "punch")
				hitbox.fuse = 8
			elseif timer == 16
				p.mo.state = S_PLAY_FALL
				return true
			end

			if timer < 10 then p.mo.state = S_PLAY_NIGHTS_DRILL end
		end,
	},

	["neutralspecial"] = {
		nomove = true,
		noreuse = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer <= 20
				p.mo.state = S_PLAY_ROLL
				P_SpawnGhostMobj(p.mo)	
				P_InstaThrust(p.mo, 0, 0)
				P_SetObjectMomZ(p.mo, FRACUNIT/2)

				p.mo.targPlayer = s.closestMobj(p.mo)
				if p.mo.targPlayer and p.mo.targPlayer.valid
					if not p.mo.lockOn or not p.mo.lockOn.valid
						p.mo.lockOn = P_SpawnMobj(p.mo.targPlayer.x, p.mo.targPlayer.y, p.mo.targPlayer.z, MT_THOK)
						p.mo.lockOn.sprite = SPR_TARG
						p.mo.lockOn.color = p.skincolor
						p.mo.lockOn.colorized = true
						p.mo.lockOn.tics = 55-timer
					else
						P_TeleportMove(p.mo.lockOn, p.mo.targPlayer.x, p.mo.targPlayer.y, p.mo.targPlayer.z)
					end
				end

				if not (leveltime%10)
					local orb = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
					orb.sprite = SPR_WITS
					orb.scalespeed = FRACUNIT/69 -- nice
					orb.destscale = 2*FRACUNIT
					orb.color = SKINCOLOR_WHITE
					orb.fuse = 35
					orb.tics = 35

					orb = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
					orb.sprite = SPR_WITS
					orb.scale = FRACUNIT/2
					orb.scalespeed = FRACUNIT/69 -- nice
					orb.destscale = FRACUNIT+(FRACUNIT/2)
					orb.color = SKINCOLOR_GREY
					orb.fuse = 35
					orb.tics = 35
				end
			elseif timer <= 55
				if P_IsObjectOnGround(p.mo)
					p.mo.hitstun = 20
					return true
				end

				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius, p.mo.height,
				10, 2, 7*FRACUNIT, 5*FRACUNIT, true, sfx_kick3, "punch")
				hitbox.hitcool = 2
				hitbox.hitstun = 13
				hitbox.hitlag = 0
				hitbox.fuse = 2

				p.mo.state = S_PLAY_ROLL
				p.mo.flags = $|MF_NOGRAVITY
				P_SpawnGhostMobj(p.mo)

				if p.mo.targPlayer and p.mo.targPlayer.valid
					local tmo = p.mo.targPlayer
					if not p.mo.lockOn or not p.mo.lockOn.valid
						p.mo.lockOn = P_SpawnMobj(p.mo.targPlayer.x, p.mo.targPlayer.y, p.mo.targPlayer.z, MT_THOK)
						p.mo.lockOn.sprite = SPR_TARG
						p.mo.lockOn.color = p.skincolor
						p.mo.lockOn.colorized = true
						p.mo.lockOn.tics = 35-timer
					else
						P_TeleportMove(p.mo.lockOn, p.mo.targPlayer.x, p.mo.targPlayer.y, p.mo.targPlayer.z)
					end

					if timer <= 25
						local coords = {p.mo.targPlayer.x, p.mo.targPlayer.y, p.mo.targPlayer.z}

						local dist = P_AproxDistance(P_AproxDistance(coords[1] - p.mo.x, coords[2] - p.mo.y), coords[3] - p.mo.z)
						p.mo.momx = FixedMul(FixedDiv(coords[1] - p.mo.x, dist), 20<<FRACBITS)
						p.mo.momy = FixedMul(FixedDiv(coords[2] - p.mo.y, dist), 20<<FRACBITS)
						p.mo.momz = FixedMul(FixedDiv(coords[3] - p.mo.z, dist), 20<<FRACBITS)
					end
				else
					P_InstaThrust(p.mo, p.mo.angle, 10*FRACUNIT)
					P_SetObjectMomZ(p.mo, -FRACUNIT)
				end
			end

			if timer >= 55 or p.mo.endAtk
				if p.mo.lockOn
					if p.mo.lockOn.valid then P_RemoveMobj(p.mo.lockOn) end
					p.mo.lockOn = nil
				end

				p.mo.state = S_PLAY_FALL
				p.mo.endAtk = nil
				return true
			end

			if timer == 1 then S_StartSound(p.mo, sfx_spndsh) end
			if timer == 20 then S_StartSound(p.mo, sfx_zoom) end
		end,
		strikeFunc = function(mo, inf)
			if mo.lockOn
				if mo.lockOn.valid then P_RemoveMobj(mo.lockOn) end
				mo.lockOn = nil
			end
		end,
		hitFunc = function(mo, targ)
			if mo.lockOn
				if mo.lockOn.valid then P_RemoveMobj(mo.lockOn) end
				mo.lockOn = nil
			end

			P_InstaThrust(mo, mo.angle, -10*FRACUNIT)
			P_SetObjectMomZ(mo, 4*FRACUNIT, false)
			mo.state = S_PLAY_ROLL
			mo.doublejumped = nil
			
			mo.endAtk = true
		end,
		desc = {
			name = "Neutral Special",
			txt = "A quick homing attack to homes into your closest foes! Be careful as rash usage can get you flying into the blast zone!"
		}
	},

	["sidespecial"] = {
		nomove = true,
		noreuse = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer < 7
				if p.mo.sonicSlash
					if p.mo.sonicSlash.valid then return true end
				end

				p.mo.state = S_PLAY_RUN
				p.drawangle = timer*ANGLE_45
			else
				p.mo.state = S_PLAY_ROLL
				p.drawangle = timer*ANGLE_45
			end

			if timer == 7
				if P_IsObjectOnGround(p.mo)
					p.mo.sonicSlash = s.fireMissile(p.mo, MT_SONICWAVE, 3)
					if p.mo.sonicSlash and p.mo.sonicSlash.valid
						p.mo.sonicSlash.color = p.skincolor
					end
				else
					p.mo.sonicSlash = s.fireMissile(p.mo, MT_SONICSLASH, 3)
					if p.mo.sonicSlash and p.mo.sonicSlash.valid
						p.mo.sonicSlash.color = p.skincolor
						p.mo.sonicSlash.scale = FRACUNIT+FRACUNIT/2

						P_Thrust(p.mo.sonicSlash, p.mo.angle, 7*FRACUNIT)
						p.mo.sonicSlash.momz = -11*FRACUNIT
					end
				end

				S_StartSound(p.mo, sfx_tslash)
			end

			if timer >= 10
				p.mo.state = S_PLAY_STND
				return true
			end
		end,
		desc = {
			name = "Side Special",
			txt = "Fire a tornado with your speed! This needs time to charge up and to finish, so it is advised you do NOT use this offstage! Trapped foes are knocked back in your direction for an easy combo."
		}
	},

	["upspecial"] = {
		nomove = true,
		noreuse = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer == 1
				for i = 1, 36
					local dust = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SPINDUST)
					P_InstaThrust(dust, i*10*ANG1, 20*FRACUNIT)
				end
			end

			if timer < 12
				local hitbox = s.drawHitBox(p, 20*cos(p.mo.angle), 
				20*sin(p.mo.angle), -10*FRACUNIT, p.mo.radius, p.mo.height+20*FRACUNIT, 
				2, 2, 9*FRACUNIT, 19*FRACUNIT, false, sfx_punch2, "punch")
				hitbox.hitcool = 2
				hitbox.hitlag = 4
				hitbox.fuse = 2
			else
				local hitbox = s.drawHitBox(p, 20*cos(p.mo.angle), 
				20*sin(p.mo.angle), -10*FRACUNIT, p.mo.radius*2, p.mo.height*2, 
				7, 3, 3*FRACUNIT, 8*FRACUNIT, true, sfx_punch3, "punch")
				hitbox.hitcool = 2
				hitbox.hitlag = 10
				hitbox.fuse = 2
			end

			if timer <= 14
				P_InstaThrust(p.mo, p.mo.angle, 9*FRACUNIT)
				P_SetObjectMomZ(p.mo, 19*FRACUNIT)
				P_SpawnGhostMobj(p.mo)
				p.mo.state = S_PLAY_ROLL
			elseif timer > 14 and timer <= 15
				p.mo.momx = ($/6)*5
				p.mo.momy = ($/6)*5
				p.mo.momz = ($/6)*5
				p.mo.state = S_PLAY_ROLL
			elseif timer > 15
				p.mo.state = S_PLAY_FALL
				return true
			end
		end,
		priorityCheck = function(mo)
			if mo.state == S_PLAY_ROLL then return 2 end
			return 0
		end,
		desc = {
			name = "Up Special",
			txt = "Zoom upwards to recover from offstage. This moves combos into itself easilly."
		}
	},

	["downspecial"] = {
		superarmor = true,
		nogroundreset = true,
		repelprojectiles = true,
		anim = function(p, timer)
			if timer < 40
				if P_IsObjectOnGround(p.mo)
					local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius, p.mo.height,
					1, 2, 1, 1, false, sfx_kick1, "punch")
					hitbox.hitstun = 7
					hitbox.hitcool = 5
					hitbox.hitlag = 1
					hitbox.fuse = 2
				end

				p.mo.state = S_PLAY_SPINDASH
				P_SpawnGhostMobj(p.mo)

				p.mo.friction = FRACUNIT
				p.powers[pw_nocontrol] = 40-timer
				
				if not S_SoundPlaying(p.mo, sfx_spndsh) then S_StartSound(p.mo, sfx_spndsh) end
			elseif timer >= 40
				local hitbox = s.drawHitBox(p, x, y, 0, p.mo.radius+10*FRACUNIT,
				p.mo.height, 10, 2, 10*FRACUNIT, 5*FRACUNIT, true, sfx_kick3, "punch")
				hitbox.hitlag = 3
				hitbox.fuse = 2

				if P_IsObjectOnGround(p.mo)
					P_Thrust(p.mo, p.mo.angle, 2*FRACUNIT)
					if p.mo.momx > 40*FRACUNIT then p.mo.momx = 40*FRACUNIT end
					if p.mo.momy > 40*FRACUNIT then p.mo.momy = 40*FRACUNIT end
				else
					p.powers[pw_nocontrol] = 1
				end

				p.mo.state = S_PLAY_ROLL
				P_SpawnGhostMobj(p.mo)
			end

			if timer == 40 
				P_TeleportMove(p.mo, p.mo.x, p.mo.y, p.mo.z+FRACUNIT)
				P_InstaThrust(p.mo, p.mo.angle, 40*FRACUNIT)
				S_StartSound(p.mo, sfx_zoom)
			end

			if (timer < 40) or (timer > 80 and timer < 90)
				p.mo.momx = ($/10)*9
				p.mo.momy = ($/10)*9
			elseif timer >= 90
				P_SetObjectMomZ(p.mo, FRACUNIT)
				p.mo.state = S_PLAY_FALL

				p.mo.friction = 29*FRACUNIT/32
				return true
			end
		end,
		desc = {
			name = "Down Special",
			txt = "A spindash that you are able to move around with! Sonic needs to charge this attack, but even this state can damage foes."
		}
	},
	
	["upblast"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer == 1
				p.mo.state = S_PLAY_SONIC_UPAIR
			elseif timer == 4
				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius*2, p.mo.height*2,
				15, 2, 2*FRACUNIT, 13*FRACUNIT, true, sfx_punch2, "punch")
				hitbox.fuse = 9
				hitbox.blast = 2
			elseif timer == 13
				p.mo.state = S_PLAY_STND
			elseif timer >= 16
				return true
			end
		end
	},

	["downblast"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer < 16
				p.mo.friction = FRACUNIT
				
				if timer == 1
					P_TeleportMove(p.mo, p.mo.x, p.mo.y, p.mo.z+FRACUNIT)
					P_InstaThrust(p.mo, p.mo.angle, 10*FRACUNIT)
				elseif timer > 2
					P_Thrust(p.mo, p.mo.angle, 2*FRACUNIT)
				end
			end

			if timer < 18
				p.mo.state = S_PLAY_ROLL

				local hitbox = s.drawHitBox(p, 0, 0, -p.mo.height, p.mo.radius*2,
				(p.mo.height*3)/2, 15, 3, 12*FRACUNIT, FRACUNIT, true, sfx_pstop, "punch")
				hitbox.blast = 2
				hitbox.fuse = 2
				
				if timer == 9 then p.mo.angle = $+ANGLE_180 end
			end
			
			if timer >= 19
				p.mo.state = S_PLAY_WALK
				p.mo.friction = 29*FRACUNIT/32

				return true
			end
		end
	},

	["blast"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer < 3
				p.mo.friction = FRACUNIT				

				if timer == 1
					P_TeleportMove(p.mo, p.mo.x, p.mo.y, p.mo.z+FRACUNIT)
					P_InstaThrust(p.mo, p.mo.angle, 4*FRACUNIT)
				else
					P_InstaThrust(p.mo, p.mo.angle, 10*FRACUNIT)
				end
			end

			if timer < 10
				p.mo.state = S_PLAY_ROLL

				if timer > 7
					local hitbox = s.drawHitBox(p, 0, 0, -p.mo.height, p.mo.radius*2,
					(p.mo.height*3)/2, 4, 3, 10*FRACUNIT, FRACUNIT, true, sfx_pstop, "punch")
					hitbox.hitlag = 5
					hitbox.blast = 2
					hitbox.fuse = 2
					hitbox.hitcool = 2
				elseif timer > 2
					local hitbox = s.drawHitBox(p, 0, 0, -p.mo.height, p.mo.radius*2,
					(p.mo.height*3)/2, 8, 3, FRACUNIT, FRACUNIT/4, false, sfx_pstop, "punch")
					hitbox.hitlag = 10
					hitbox.blast = 2
					hitbox.fuse = 2
					hitbox.hitcool = 2
				end
			end

			if timer >= 12
				p.mo.state = S_PLAY_WALK
				p.mo.friction = 29*FRACUNIT/32

				return true
			end
		end
	},
	
	["finalsmash"] = {
		noringbuff = true,
		superarmor = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer == 1
				p.mo.flags = $|MF_NOGRAVITY
				p.mo.state = S_PLAY_SUPER_TRANS1
				
				p.mo.emeralds = {}
				p.mo.emeraldang = 0
				for i = 1, 7
					local em = P_SpawnMobj(p.mo.y, p.mo.x, p.mo.z, MT_THOK)
					em.sprite = SPR_CEMG
					em.frame = FF_FULLBRIGHT|i
					em.flags = MF_NOGRAVITY|MF_FLOAT|MF_SCENERY
					em.scale = $*3/2
					em.dist = 1024
					em.fuse = 80
					em.tics = 80
					
					p.mo.emeralds[i] = em
				end
			end

			if timer > 10
				p.mo.color = SKINCOLOR_SUPERGOLD1 + abs(((leveltime >> 1) % 9) - 4)
			end
			
			if timer > 1 and timer < 60
				local ang = p.mo.emeraldang
				for k,v in ipairs(p.mo.emeralds)
					if v and v.valid
						local x = p.mo.x + v.dist*cos(ang)
						local y = p.mo.y + v.dist*sin(ang)
						local z = p.mo.z + 32*cos(leveltime*ANG1*2 + (360/7)*ANG1*i)

						P_TeleportMove(v, x, y, z)
						ang = $+(360/7)*ANG1
						
						v.dist = max(64, $-24)
					end
				end

				p.mo.emeraldang = $+ANG30
			elseif timer >= 60 and timer < 90
				local ang = p.mo.emeraldang
				for k,v in ipairs(p.mo.emeralds)
					if v and v.valid
						local x = p.mo.x + v.dist*cos(ang)
						local y = p.mo.y + v.dist*sin(ang)
						local z = p.mo.z + 32*cos(leveltime*ANG1*2 + (360/7)*ANG1*i)

						P_TeleportMove(v, x, y, z)
						ang = $+(360/7)*ANG1
						
						v.dist = max(1, $-8)
					end
				end

				p.mo.emeraldang = $+ANG20
			elseif timer == 90
				for i = 1, 7
					if p.mo.emeralds[i] and p.mo.emeralds[i].valid
						P_RemoveMobj(p.mo.emeralds[i])
						table.remove(p.mo.emeralds, i)
					end
				end
			end

			if timer > 20
				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius, p.mo.height,
				25, 3, 10*FRACUNIT, 10*FRACUNIT, true, sfx_magic3, "punch")
				hitbox.hitcool = 2
				hitbox.fuse = 2

				if p.mo and p.mo.button
					p.mo.state = S_PLAY_NIGHTS_DRILL
					P_SpawnGhostMobj(p.mo)

					if p.mo.button.up >= 1 then p.mo.momz = $+FRACUNIT end
					if p.mo.button.down >= 1 then p.mo.momz = $-FRACUNIT end

					if twodlevel
						if p.mo.button.left >= 1 then p.mo.momx = $-FRACUNIT end
						if p.mo.button.right >= 1 then p.mo.momx = $+FRACUNIT end
					end
				end
			end

			if timer >= 525
				p.rings = 0
				p.powers[pw_super] = 0
				p.mo.color = p.skincolor
				p.mo.emeralds = nil
				p.mo.emeraldang = nil
				
				return true
			end
		end,
	}
}