local s = SRB2Smash
if not s.chars then s.chars = {} end

freeslot("S_PLAY_TAILS_FAIR", "SPR2_FAIR")
states[S_PLAY_TAILS_FAIR] = {SPR_PLAY, SPR2_FAIR, 35, nil, 0, 0, S_PLAY_FALL}

// Mobjs
freeslot("MT_TAILSTORNADO", "S_TAILSTORNADO", "MT_TTORNADOPARTICLE", "S_TTORNADOPARTICLE", 
"MT_NAPALMBOMB", "S_NAPALMBOMB_FALL", "S_NAPALMBOMB_STICK", "S_NAPALMBOMB_EXPLD",
"S_NAPALMBOMB_EXPLD2", "S_NAPALMBOMB_EXPLD3", "SPR_NAPM",
"MT_AIRSLASH", "S_AIRSLASH1", "S_AIRSLASH2", "S_AIRSLASH3", "S_AIRSLASH_SPIN",
"S_AIRSLASHDIE1", "S_AIRSLASHDIE2", "SPR_TSLA")

/*
	Tails final smash moment
*/

mobjinfo[MT_TAILSTORNADO] = {
    spawnstate = S_TAILSTORNADO,
    radius = 200*FRACUNIT,
    height = 400*FRACUNIT,
	speed = 12*FRACUNIT,
	flags = MF_NOGRAVITY|MF_PAIN
}

states[S_TAILSTORNADO] = {SPR_NULL, A, 105, nil, 0, 0, S_NULL}

addHook("MobjThinker", function(mo)
	P_InstaThrust(mo, mo.angle, 10*FRACUNIT)

	if not (leveltime%2)
		local x, y = 30*cos(P_RandomRange(1, 360)*ANG1), 30*sin(P_RandomRange(1, 360)*ANG1)
		local tornado = P_SpawnMobj(mo.x+x, mo.y+y, mo.z, MT_TTORNADOPARTICLE)
		tornado.angle = P_RandomRange(0, 360)*ANG1
		tornado.tracer = mo
		tornado.fuse = 2*TICRATE
		tornado.momz = $+4*FRACUNIT
		tornado.scale = 4*FRACUNIT
		tornado.frame = FF_PAPERSPRITE|FF_TRANS20|A
	end

	if not (leveltime%4)
		local x, y = 65*cos(P_RandomRange(1, 360)*ANG1), 65*sin(P_RandomRange(1, 360)*ANG1)
		local tornado = P_SpawnMobj(mo.x+x, mo.y+y, mo.z, MT_TTORNADOPARTICLE)
		tornado.angle = P_RandomRange(0, 360)*ANG1
		tornado.tracer = mo
		tornado.fuse = 2*TICRATE
		tornado.momz = $+3*FRACUNIT
		tornado.scale = 2*FRACUNIT
		tornado.frame = FF_PAPERSPRITE|FF_TRANS60|B
	end
	
	if not (leveltime%10)
		for i = 1, 8
			local x, y = 200*cos(ANGLE_45*i), 200*sin(ANGLE_45*i)
			local dust = P_SpawnMobj(mo.x+x, mo.y+y, mo.z, MT_SPINDUST)
			dust.scale = 3*FRACUNIT
		end
	end

	if not S_SoundPlaying(mo, sfx_s3kcel) then S_StartSound(mo, sfx_s3kcel) end
end, MT_TAILSTORNADO)

mobjinfo[MT_TTORNADOPARTICLE] = {
    spawnstate = S_TTORNADOPARTICLE,
    radius = 1*FRACUNIT,
    height = 1*FRACUNIT,
	flags = MF_NOGRAVITY|MF_FLOAT|MF_SCENERY|MF_NOCLIPHEIGHT
}

states[S_TTORNADOPARTICLE] = {SPR_TAZD, FF_PAPERSPRITE|B, TICRATE, nil, 0, 0, S_NULL}

addHook("MobjThinker", function(mo)
	mo.angle = $1 + 5*ANG2
	P_InstaThrust(mo, mo.angle+ANGLE_90, 4*FRACUNIT)
	if not (leveltime%4) then P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST) end
end, MT_TTORNADOPARTICLE)

/* 
	TAILS NEUTRAL SPECIAL
	a napalm bomb that explodes on contact
*/

local function A_ExplodeNapalmBombSmash(mo)
	P_StartQuake(30*FRACUNIT, 5)
	
	mo.radius = 200*FRACUNIT
	mo.height = 180*FRACUNIT
	mo.state = S_BOMB_EXPLD
end

mobjinfo[MT_NAPALMBOMB] = {
    spawnstate = S_NAPALMBOMB_FALL,
	deathstate = S_NAPALMBOMB_EXPLD,
	deathsound = sfx_pop,
    radius = 30*FRACUNIT,
    height = 12*FRACUNIT,
	speed = 7*FRACUNIT,
	flags = MF_BOUNCE|MF_MISSILE|MF_GRENADEBOUNCE
}

states[S_NAPALMBOMB_FALL] = {SPR_NAPM, FF_FULLBRIGHT|A, -1, nil, 0, 0, S_NAPALMBOMB_STICK}
states[S_NAPALMBOMB_STICK] = {SPR_NAPM, FF_FULLBRIGHT|A, 350, nil, 0, 0, S_NAPALMBOMB_EXPLD}
states[S_NAPALMBOMB_EXPLD] = {SPR_NAPM, FF_FULLBRIGHT|E, 3, A_PlaySound, sfx_s3k5b, 0, S_NAPALMBOMB_EXPLD2}
states[S_NAPALMBOMB_EXPLD2] = {SPR_NAPM, FF_FULLBRIGHT|F, 2, nil, 0, 0, S_NAPALMBOMB_EXPLD3}
states[S_NAPALMBOMB_EXPLD3] = {SPR_NULL, A, 35, A_ExplodeNapalmBombSmash, 0, 0, S_NULL}

addHook("MobjThinker", function(mo)
	if mo and mo.valid
		local user = mo.user or mo.target
		if not user or not user.valid then return end

		if not user.player then return end
		local p = user.player

		if mo.state == S_NAPALMBOMB_FALL
			if P_IsObjectOnGround(mo) then mo.state = S_NAPALMBOMB_STICK end
		elseif mo.state == S_NAPALMBOMB_STICK
			mo.momx = 0
			mo.momy = 0
			mo.momz = -FRACUNIT/2

			if not (leveltime%2)
				local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SMOKE)
				dust.momx = P_RandomRange(-1, 1)*mo.scale
				dust.momy = P_RandomRange(-1, 1)*mo.scale
				dust.momz = P_RandomRange(1, 4)*mo.scale*P_MobjFlip(mo)
				dust.fuse = 35
			end
		end
	end
end, MT_NAPALMBOMB)

addHook("MobjCollide", function(thing, tmthing)
	if not thing or not thing.valid then return false end
	if not tmthing or not tmthing.valid or not tmthing.player then return false end

	if thing.state == S_NAPALMBOMB_STICK
		S_StartSound(thing, sfx_kick3)
		thing.state = S_NAPALMBOMB_EXPLD
	end
end, MT_NAPALMBOMB)

// side special moment

mobjinfo[MT_AIRSLASH] = {
    spawnstate = S_AIRSLASH1,
	deathstate = S_AIRSLASH_SPIN,
    radius = 90*FRACUNIT,
    height = 100*FRACUNIT,
	speed = 8*FRACUNIT,
	flags = MF_NOGRAVITY|MF_NOCLIP
}

function A_addMissile(mo)
	mo.flags = MF_NOGRAVITY|MF_MISSILE
end

function A_removeMissile(mo)
	mo.flags = MF_SCENERY|MF_NOGRAVITY|MF_NOCLIPHEIGHT
end

states[S_AIRSLASH1] = {SPR_TSLA, FF_PAPERSPRITE|FF_TRANS80|A, 2, nil, 0, 0, S_AIRSLASH2}
states[S_AIRSLASH2] = {SPR_TSLA, FF_PAPERSPRITE|FF_TRANS60|B, 3, nil, 0, 0, S_AIRSLASH3}
states[S_AIRSLASH3] = {SPR_TSLA, FF_PAPERSPRITE|FF_TRANS40|C, 3, nil, 0, 0, S_AIRSLASH_SPIN}
states[S_AIRSLASH_SPIN] = {SPR_TSLA, FF_PAPERSPRITE|FF_TRANS20|C, 15, A_addMissile, 0, 0, S_AIRSLASHDIE1}
states[S_AIRSLASHDIE1] = {SPR_TSLA, FF_PAPERSPRITE|FF_TRANS50|B, 5, A_removeMissile, 0, 0, S_AIRSLASHDIE2}
states[S_AIRSLASHDIE2] = {SPR_TSLA, FF_PAPERSPRITE|FF_TRANS80|A, 8, nil, 0, 0, S_NULL}

addHook("MobjThinker", function(mo)
	if mo.state == S_AIRSLASH_SPIN
		mo.momx, mo.momy, mo.momz = 0, 0, 0

		mo.rollangle = $+ANG20
		P_SpawnGhostMobj(mo)
	end
end, MT_AIRSLASH)

s.chars["tails"] = {
	-- General Stats
	["speed"] = 6,
	["weight"] = 2,
	["hud"] = "TAILS",
	["win"] = "TAILSWIN",
	["winbg"] = {0, -200, "SKY5"},
	
	-- Attacks
	["jab1"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 30*sin(p.mo.angle), 0, 15*FRACUNIT,
				20*FRACUNIT, 3, 1, FRACUNIT/5, FRACUNIT/3, nil, sfx_kick1, "punch")
				
				hitbox.fuse = 5
			elseif timer == 10
				return true
			end
			
			p.mo.state = S_PLAY_STND
			p.drawangle = p.mo.angle+ANGLE_45
		end
	},

	["jab2"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 30*sin(p.mo.angle), 0, 15*FRACUNIT,
				32*FRACUNIT, 3, 1, FRACUNIT/5, FRACUNIT/3, nil, sfx_kick1, "punch")
				
				hitbox.fuse = 5
			elseif timer == 10
				return true
			end
			
			p.mo.state = S_PLAY_STND
			p.drawangle = p.mo.angle-ANGLE_45
		end,
	},

	["jab3"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 30*cos(p.mo.angle), 30*sin(p.mo.angle), 0, 15*FRACUNIT,
				p.mo.height, 5, 2, 7*FRACUNIT, 5*FRACUNIT, true, sfx_kick2, "punch")
				
				hitbox.fuse = 5
			elseif timer == 15
				p.mo.state = S_PLAY_STND
				return true
			end
			
			p.mo.state = S_PLAY_WALK
			p.drawangle = timer*ANG15
		end,
	},

	["dash"] = {
		nomove = true,
		superarmor = true,
		anim = function(p, timer)
			if timer < 15
				P_InstaThrust(p.mo, p.mo.angle, 19*FRACUNIT)
				
				p.mo.state = S_PLAY_FLY
				P_SpawnGhostMobj(p.mo)

				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius, p.mo.height,
				3, 3, 6*FRACUNIT, 10*FRACUNIT, false, sfx_kick3, "punch")
				hitbox.hitcool = 5
				hitbox.hitlag = 1
				hitbox.fuse = 2
			else
				p.mo.state = S_PLAY_WALK
				if timer >= 19 then return true end
			end
		end
	},

	["uptilt"] = {
		nomove = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 0, 0, p.mo.height, p.mo.radius*2,
				15*FRACUNIT, 5, 2, P_RandomRange(-3, 3)*FRACUNIT, 10*FRACUNIT, true,
				sfx_punch2, "punch")
				
				hitbox.fuse = 10
				P_SetObjectMomZ(p.mo, 4*FRACUNIT)
			end

			if timer == 8 then return true end
			
			p.mo.state = S_PLAY_FLY
			p.drawangle = timer*ANGLE_45
		end,
	},
	
	["sidetilt"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 20*cos(p.mo.angle), 20*sin(p.mo.angle),
				0, 20*FRACUNIT, p.mo.height, 8, 2, 14*FRACUNIT, 0, true, sfx_kick2, "punch")
				hitbox.fuse = 8
			elseif timer == 14
				p.mo.state = S_PLAY_FALL
				return true
			end
			
			p.mo.state = S_PLAY_WALK
			p.drawangle = timer*ANG15
		end,
	},

	["neutralair"] = {
		nogroundreset = true,
		anim = function(p, timer)
			if timer == 4
				local hitbox = s.drawHitBox(p, 0, 0, -p.mo.height/2, p.mo.radius*2,
				(p.mo.height*3)/2, 8, 2, nil, nil, true, sfx_kick3, "punch")
				hitbox.fuse = 7
			end

			if timer < 10
				p.mo.state = S_PLAY_RUN
				p.drawangle = ANGLE_90
			elseif timer == 10
				p.mo.state = S_PLAY_FALL
				p.drawangle = p.mo.angle
			end

			if timer >= 13 then return true end				
		end
	},
	
	["upair"] = {
		anim = function(p, timer)
			if timer < 7 then p.mo.state = S_PLAY_SONIC_UPAIR end

			if timer == 3 then
				local hitbox = s.drawHitBox(p, 0, 0, p.mo.height/2, p.mo.radius*2, 13*FRACUNIT+p.mo.height, 3, 2, 1, 8*FRACUNIT, true, sfx_punch2, "punch")
				hitbox.hitlag = 10
				hitbox.hitcool = 1
				hitbox.fuse = 6
			end

			if timer == 8 then p.mo.state = S_PLAY_ROLL end
			
			if timer >= 10 then
				p.mo.state = S_PLAY_FALL
				return true
			end
		end,
	},
	
	["downair"] = {
		anim = function(p, timer)
			if timer == 1 then P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z-26*FRACUNIT, MT_SUPERSPARK) end

			if timer < 5
				p.mo.state = S_PLAY_ROLL
			elseif timer == 5
				local hitbox = s.drawHitBox(p, 0, 0, -25*FRACUNIT, p.mo.radius,
				25*FRACUNIT, 6, 2, 5*FRACUNIT, FRACUNIT, true, sfx_kick2, "punch")
				hitbox.fuse = 8

				local spike = s.drawHitBox(p, 0, 0, -35*FRACUNIT, p.mo.radius-20*FRACUNIT,
				15*FRACUNIT, 9, 3, 5*FRACUNIT, -15*FRACUNIT, true, sfx_kick3, "spike")
				spike.fuse = 5
			elseif timer == 15
				p.mo.state = S_PLAY_FALL
				return true
			end
			
			if timer > 5 and timer < 14
				p.mo.frame = A
				p.mo.state = S_PLAY_RIDE
				p.mo.sprite2 = SPR2_RIDE
				p.drawangle = timer*ANGLE_45
			end
		end,
	},

	["sideair"] = {
		anim = function(p, timer)
			if timer < 9 then p.mo.state = S_PLAY_TAILS_FAIR end

			if timer == 7 then
				local hitbox = s.drawHitBox(p, 20*cos(p.mo.angle), 20*sin(p.mo.angle),
				0, 20*FRACUNIT, p.mo.height, 11, 2, 10*FRACUNIT, 1, true, sfx_kick2, "punch")
				hitbox.fuse = 8
			end

			if timer == 9 then p.mo.state = S_PLAY_FALL end

			if timer >= 18 or P_IsObjectOnGround(p.mo) then
				p.mo.state = S_PLAY_FALL
				return true
			end
		end,
	},

	["neutralspecial"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer == 1
				p.mo.continueFly = p.mo.flying
			end

			if timer < 8
				p.mo.state = S_PLAY_ROLL
			elseif timer == 8
				if not p.mo.bomb
					p.mo.state = S_PLAY_FALL
					local bomb = s.fireMissile(p.mo, MT_NAPALMBOMB, 2)
					
					if bomb and bomb.valid
						if P_IsObjectOnGround(p.mo)
							P_SetObjectMomZ(bomb, 8*FRACUNIT)
						else
							bomb.momx, bomb.momy, bomb.momz = 0, 0, 0
						end

						bomb.color = p.mo.color
						p.mo.bomb = bomb
					end
				else
					p.mo.state = S_PLAY_EDGE
				end
			elseif timer == 30
				p.mo.state = S_PLAY_STND
				p.mo.flying = p.mo.continueFly
				return true
			end
		end,
		desc = {
			name = "Neutral Special",
			txt = "Tails throws a napalm bomb that stays on the ground for 30 seconds before exploding. If anyone walks into it, they'll be blown up!"
		}
	},

	["upspecial"] = {
		noreuse = true,
		anim = function(p, timer)
			if timer == 1
				for i = 1, 36
					local dust = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SPINDUST)
					P_InstaThrust(dust, i*10*ANG1, 20*FRACUNIT)
				end
			end

			p.mo.momx = ($/8)*7
			p.mo.momy = ($/8)*7

			if not p.mo.hitboxshit or not p.mo.hitboxshit.valid
				p.mo.hitboxshit = s.drawHitBox(p, 0, 0, p.mo.height, 3*p.mo.radius,
				20*FRACUNIT, 2, 3, 1, p.mo.momz, false, sfx_sword1, "slash")

				p.mo.hitboxshit.fuse = 2
				p.mo.hitboxshit.hitcool = 1
				p.mo.hitboxshit.hitlag = 2
				p.mo.hitboxshit.hitstun = 20
			end

			P_SetObjectMomZ(p.mo, FRACUNIT, true)
			P_SpawnGhostMobj(p.mo)

			p.mo.state = S_PLAY_FLY
			if p.mo.momz < 0 then p.mo.momz = $+3*FRACUNIT end
			if not S_SoundPlaying(p.mo, sfx_putput) then S_StartSound(p.mo, sfx_putput) end

			if timer == 70 or p.mo.momz > 18*FRACUNIT	
				p.mo.state = S_PLAY_SPRING

				local hitbox = s.drawHitBox(p, 5*FRACUNIT, 0, (p.mo.height/2),
				p.mo.radius + (5*FRACUNIT), p.mo.height, 5, 2, 1, 10*FRACUNIT,
				true, sfx_kick2, "punch")
				hitbox.fuse = 4
				
				if p.mo.hitboxshit and p.mo.hitboxshit.valid
					P_RemoveMobj(p.mo.hitboxshit)
					p.mo.hitboxshit = nil
				end

				return true
			end
		end,
		desc = {
			name = "Up Special",
			txt = "Fly upwards to strike your foes or recover from falling off the stage! If any foes are trapped, tails' tails will hit them, and he will finish with a headbutt!"
		}
	},

	["sidespecial"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer <= 8
				p.mo.state = S_PLAY_WALK
				p.drawangle = timer*ANGLE_22h
			elseif timer > 8
				p.mo.state = S_PLAY_FALL
			end

			if timer == 5 and not p.mo.slash
				local slash = s.fireMissile(p.mo, MT_AIRSLASH, 2)
				if slash and slash.valid
					slash.scale = 3*FRACUNIT/5
					slash.color = p.mo.color
					P_Thrust(slash, p.mo.angle, 6*FRACUNIT)

					if not P_IsObjectOnGround(p.mo)
						P_TeleportMove(slash, slash.x, slash.y, slash.z-(slash.height/2))
					end
				end

				p.mo.slash = slash
				S_StartSound(p.mo, sfx_tslash)
			elseif timer == 12
				p.mo.state = S_PLAY_STND
				return true
			end
		end,
		desc = {
			name = "Side Special",
			txt = "A small air slash is sent to trap foes. Easy to combo into by striking them while they're being hit!"
		}
	},

	["downspecial"] = {
		superarmor = true,
		nogroundreset = true,
		repelprojectiles = true,
		anim = function(p, timer)
			if timer < 40
				if P_IsObjectOnGround(p.mo)
					local hitbox = s.drawHitBox(p, x, y, 0, p.mo.radius+10*FRACUNIT,
					p.mo.height, 1, 2, 1, 1, true, sfx_kick3, "punch")
					hitbox.hitstun = 20
					hitbox.hitcool = 4
					hitbox.hitlag = 1
					hitbox.fuse = 2
				end

				p.mo.state = S_PLAY_SPINDASH
				P_SpawnGhostMobj(p.mo)

				p.mo.friction = FRACUNIT
				p.powers[pw_nocontrol] = 40-timer
				
				if not S_SoundPlaying(p.mo, sfx_spndsh) then S_StartSound(p.mo, sfx_spndsh) end
			elseif timer >= 40
				local x = p.mo.x-10*cos(p.mo.angle)
				local x = p.mo.y-10*sin(p.mo.angle)
				local hitbox = s.drawHitBox(p, x, y, 0, p.mo.radius+10*FRACUNIT,
				p.mo.height, 10, 2, 10*FRACUNIT, 5*FRACUNIT, true, sfx_kick3, "punch")
				hitbox.fuse = 2

				if P_IsObjectOnGround(p.mo)
					P_Thrust(p.mo, p.mo.angle, FRACUNIT+(FRACUNIT/2))
					if p.mo.momx > 25*FRACUNIT then p.mo.momx = 25*FRACUNIT end
					if p.mo.momy > 25*FRACUNIT then p.mo.momy = 25*FRACUNIT end
				else
					p.powers[pw_nocontrol] = 1
				end

				p.mo.state = S_PLAY_ROLL
				P_SpawnGhostMobj(p.mo)
			end

			if timer == 40 
				P_TeleportMove(p.mo, p.mo.x, p.mo.y, p.mo.z+FRACUNIT)
				P_InstaThrust(p.mo, p.mo.angle, 25*FRACUNIT)
				S_StartSound(p.mo, sfx_zoom)
			end

			if (timer < 40) or (timer > 80 and timer < 90)
				p.mo.momx = ($/10)*9
				p.mo.momy = ($/10)*9
			elseif timer >= 90
				P_SetObjectMomZ(p.mo, FRACUNIT)
				p.mo.state = S_PLAY_FALL

				p.mo.friction = 29*FRACUNIT/32
				return true
			end
		end,
		desc = {
			name = "Down Special",
			txt = "A spindash that is just like Sonic's! Seems like he learnt it from someone. Tails needs to charge this up, and even in this state, the spindash will deal damage!"
		}
	},
	
	["upblast"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer == 2 or timer == 4 or timer == 6 or timer == 8
				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius*3, 2*p.mo.height, 3, 2, p.speed, FRACUNIT, false, sfx_sword2, "punch")
				hitbox.hitlag = 3
				hitbox.hitcool = 1
				hitbox.fuse = 2
			elseif timer == 10
				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius*2, 2*p.mo.height, 5, 3, P_RandomRange(-1, 1)*FRACUNIT, 10*FRACUNIT, true, sfx_sword3, "punch")
				hitbox.hitlag = 10
				hitbox.hitcool = 1
				hitbox.fuse = 2
			end
			
			if timer > 15
				p.mo.state = S_PLAY_STND
				return true
			end

			p.mo.state = S_PLAY_FLY
			if not S_SoundPlaying(p.mo, sfx_putput) then S_StartSound(p.mo, sfx_putput) end
		end
	},

	["downblast"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer <= 5
				p.mo.state = S_PLAY_SPRING
			else
				p.mo.state = S_PLAY_CROUCH
			end

			if timer == 5
				local hitbox = s.drawHitBox(p, 0, 0, p.mo.height, p.mo.radius*4,
				13*FRACUNIT, 15, 3, 13*FRACUNIT, FRACUNIT, true, sfx_magic2, "punch")
				hitbox.hitlag = 10
				hitbox.hitcool = 1
				hitbox.fuse = 2

				for i = 1, 6
					local dust = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SPINDUST)
					P_InstaThrust(dust, p.mo.angle, 4*FRACUNIT*i)
					
					dust.destscale = 2*FRACUNIT
					dust.momz = 2*FRACUNIT
				end
			end
			
			if timer >= 12
				p.mo.state = S_PLAY_STND
				return true
			end
		end
	},

	["blast"] = {
		nomove = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer == 1
				local hitbox = s.drawHitBox(p, 0, 0, 0, p.mo.radius*3, p.mo.height,
				15, 3, 14*FRACUNIT, 2*FRACUNIT, true, sfx_kick2, "punch")
				hitbox.hitlag = 10
				hitbox.fuse = 7
			elseif timer == 14
				p.mo.state = S_PLAY_FALL
				return true
			end
			
			p.mo.state = S_PLAY_RUN
			p.drawangle = timer*ANG30
		end
	},

	["finalsmash"] = {
		nomove = true,
		noringbuff = true,
		superarmor = true,
		nogroundreset = true,
		anim = function(p, timer)
			if timer == 1
				p.mo.flags = $|MF_NOGRAVITY
				p.mo.state = S_PLAY_SUPER_TRANS1
				
				p.mo.emeralds = {}
				p.mo.emeraldang = 0
				for i = 1, 7
					local em = P_SpawnMobj(p.mo.y, p.mo.x, p.mo.z, MT_THOK)
					em.sprite = SPR_CEMG
					em.frame = FF_FULLBRIGHT|i
					em.flags = MF_NOGRAVITY|MF_FLOAT|MF_SCENERY
					em.scale = $*3/2
					em.dist = 1024
					em.fuse = 80
					em.tics = 80
					
					p.mo.emeralds[i] = em
				end
			end
			
			if timer < 30
				p.mo.momx = 0
				p.mo.momy = 0
				p.mo.momz = 0
			end
			
			if timer > 1 and timer < 40
				local ang = p.mo.emeraldang
				for k,v in ipairs(p.mo.emeralds)
					if v and v.valid
						local x = p.mo.x + v.dist*cos(ang)
						local y = p.mo.y + v.dist*sin(ang)
						local z = p.mo.z + 32*cos(leveltime*ANG1*2 + (360/7)*ANG1*i)

						P_TeleportMove(v, x, y, z)
						ang = $+(360/7)*ANG1
						
						v.dist = max(64, $-24)
					end
				end

				p.mo.emeraldang = $+ANG30
			elseif timer >= 40 and timer < 70
				local ang = p.mo.emeraldang
				for k,v in ipairs(p.mo.emeralds)
					if v and v.valid
						local x = p.mo.x + v.dist*cos(ang)
						local y = p.mo.y + v.dist*sin(ang)
						local z = p.mo.z + 32*cos(leveltime*ANG1*2 + (360/7)*ANG1*i)

						P_TeleportMove(v, x, y, z)
						ang = $+(360/7)*ANG1
						
						v.dist = max(1, $-8)
					end
				end

				p.mo.emeraldang = $+ANG20
			elseif timer == 70
				for i = 1, 7
					if p.mo.emeralds[i] and p.mo.emeralds[i].valid
						P_RemoveMobj(p.mo.emeralds[i])
						table.remove(p.mo.emeralds, i)
					end
				end
			end

			if timer > 10 then p.mo.color = SKINCOLOR_SUPERORANGE1 + abs(((leveltime >> 1) % 9) - 4) end

			if timer == 20
				p.mo.state = S_PLAY_NIGHTS_DRILL

				local tornado = s.fireMissile(p.mo, MT_TAILSTORNADO, 3)
				if tornado and tornado.valid
					tornado.angle = p.mo.angle
					tornado.fuse = 280
				end
			end
			
			if timer > 40 then p.mo.state = S_PLAY_FALL end
			
			if timer >= 140
				p.rings = 0
				p.powers[pw_super] = 0
				p.mo.color = p.skincolor
				
				return true
			end
		end,
	},
	
	["thinker"] = function(mo)
		if mo.bomb and not mo.bomb.valid then mo.bomb = nil end
		if mo.slash and not mo.slash.valid then mo.slash = nil end
	end,
}