freeslot("SKINCOLOR_SMASHBALL")

skincolors[SKINCOLOR_SMASHBALL] = {
	name = "smashball",
	ramp = {32,219,84,83,89,96,121,121,130,130,147,147,162,179,202,32},
	invcolor = SKINCOLOR_WHITE,
	invshade = 9,
	chatcolor = V_BLUEMAP
}

// co de
local flashColor = skincolors[SKINCOLOR_SMASHBALL]
local flashDelay = 2
local rampPos = 1
local rampDir = true
local ramps = {}

//convert the ramp to a table
ramps[1] = {}
for i = 0, 15, 1
	ramps[1][i+1] = flashColor.ramp[i]
end

//create the offset versions of the ramp
for i = 2, 16,1
	ramps[i] = {}

	for pos,val in ipairs(ramps[i-1]) do
		if not (pos == 16) then
			ramps[i][pos+1] = val
		else
			ramps[i][1] = val
		end
	end
end

local function RampChange()
	if (rampDir) then
		rampPos = $1+1
	else
		rampPos = $1-1
	end
end

local function RampLoop()
	if not (leveltime % flashDelay) then

		RampChange()
		
		//position is too high/low, reverse your direction
		if not (ramps[rampPos])
			rampDir = not rampDir
			RampChange()
		end

		flashColor.ramp = ramps[rampPos]
	end
end

addHook("ThinkFrame", RampLoop)