local s = SRB2Smash

s.attackThinker = function(p)
	if server.endGame then return end

	local attacks = {
		"jab1",
		"dash",
		"sidetilt",
		"uptilt",
		"downtilt",
		"neutralair",
		"upair",
		"downair",
		"sideair",
		"neutralspecial",
		"sidespecial",
		"upspecial",
		"downspecial",
		"blast",
		"sideblast",
		"upblast",
		"finalsmash"
	}

	if p.mo.attacktype
		p.pflags = $ & ~PF_SPINNING
		if not p.mo.atktimer
			p.mo.atktimer = 1
		else
			if s.chars[p.mo.skin][p.mo.attacktype]
				if s.chars[p.mo.skin][p.mo.attacktype].nomove then p.powers[pw_nocontrol] = 2 end

				if p.mo.notgrounded and P_IsObjectOnGround(p.mo)
				and not s.chars[p.mo.skin][p.mo.attacktype].nogroundreset
				and p.mo.attacktype ~= "finalsmash"
					p.mo.notgrounded = nil
					p.mo.attacktype = nil
					p.mo.atktimer = nil
					return
				end

				if not p.mo.atkstop
					-- Jab Chains
					for i = 1, 5
						if p.mo.attacktype == "jab"..i and p.mo.atktimer > 3
							if p.mo.button.spin == 1 and s.chars[p.mo.skin]["jab"..i+1]
								p.mo.attacktype = "jab"..i+1
								p.mo.atktimer = 0
							end
						end
					end

					-- Upon animation finish.
					if s.chars[p.mo.skin][p.mo.attacktype].anim(p, p.mo.atktimer or 0)
						if s.chars[p.mo.skin][p.mo.attacktype] and s.chars[p.mo.skin][p.mo.attacktype].noreuse
							p.mo.noReuse[p.mo.attacktype] = true
						end

						p.mo.flags = $ & ~MF_NOGRAVITY & ~MF_FLOAT

						if p.mo.attacktype == "finalsmash"
							p.mo.fsMeter = 0
							p.mo.finalsmash = nil
						end

						if p.finalScoreStuff
							if not p.finalScoreStuff.attacksdone 
								p.finalScoreStuff.attacksdone = FRACUNIT
							else
								p.finalScoreStuff.attacksdone = $+FRACUNIT
							end

							if p.mo.didHitFoe 
								if not p.finalScoreStuff.attackshit
									p.finalScoreStuff.attackshit = FRACUNIT
								else
									p.finalScoreStuff.attackshit = $+FRACUNIT
								end
							end
						end

						p.mo.didHitFoe = nil
						p.mo.attacktype = nil
						p.mo.atktimer = nil
						return
					end
				end

				if p.mo.atktimer and not p.mo.atkstop then p.mo.atktimer = $+1 end
			else
				p.mo.attacktype = nil
				p.mo.atktimer = nil
			end
		end
	end

	if P_IsObjectOnGround(p.mo)
		if p.mo.noReuse
			if p.mo.noReuse["upspecial"]
				p.mo.colorized = false
				p.mo.color = p.skincolor
			end
		end

		p.mo.noReuse = {}
	end
end

s.staleCheck = function(p, move)
	if not p.mo then return end
	
	if not p.mo.staleMove
		p.mo.staleMove = {move, 1}
		return
	end

	if p.mo.staleMove[1] == move:lower()
		p.mo.staleMove[2] = $+1
	else
		p.mo.staleMove = {move, 1}
	end
end

s.spinInputs = function(p)
	if server.endGame then return nil end
	if p.mo.attacktype then return nil end
	if p.mo.hitstun then return nil end
	if p.mo.flingWait then return nil end
	if p.mo.atkstop then return nil end
	if p.mo.dodge then return nil end
	if p.mo.fsTimer then return nil end
	if p.mo.parry then return nil end
	if p.mo.doneParry then return nil end
	if p.mo.airDodge then return nil end
	if p.mo.screenKO then return nil end
	if p.mo.starKO then return nil end

	if p.mo.button.spin == 1 then
		p.mo.tumble = nil

		if P_IsObjectOnGround(p.mo)
			if p.mo.state == S_PLAY_RUN or p.mo.state == S_PLAY_DASH then
				s.staleCheck(p, "dash")
				p.mo.attacktype = "dash"
				p.fastfalling = false
			else
				if p.mo.button.up >= 1
					s.staleCheck(p, "uptilt")
					p.mo.attacktype = "uptilt"
					p.fastfalling = false
					p.mo.momx = $/3
					p.mo.momy = $/2
				elseif p.mo.button.down >= 1
					s.staleCheck(p, "downtilt")
					p.mo.attacktype = "downtilt"
					p.fastfalling = false
					p.mo.momx = $/3
					p.mo.momy = $/2
				elseif p.mo.button.left >= 1 or p.mo.button.right >= 1
					s.staleCheck(p, "sidetilt")
					p.mo.attacktype = "sidetilt"
					p.fastfalling = false
					p.mo.momx = $/2
					p.mo.momy = $/2
				end
			end
		else
			if p.mo.button.up >= 1 and not p.mo.noReuse["upair"]
				s.staleCheck(p, "upair")
				p.mo.attacktype = "upair"
				p.mo.notgrounded = true
				p.fastfalling = false
			elseif p.mo.button.down >= 1 and not p.mo.noReuse["downair"]
				s.staleCheck(p, "downair")
				p.mo.attacktype = "downair"
				p.mo.notgrounded = true
				p.fastfalling = false
			elseif (p.mo.button.left >= 1 or p.mo.button.right >= 1) and not p.mo.noReuse["sideair"]
				s.staleCheck(p, "sideair")
				p.mo.attacktype = "sideair"
				p.mo.notgrounded = true
				p.fastfalling = false
			elseif not p.mo.noReuse["neutralair"]
				s.staleCheck(p, "neutralair")
				p.mo.attacktype = "neutralair"
				p.mo.notgrounded = true
				p.fastfalling = false
			end
		end
	end

	-- Jab thinker
	if (p.mo.tap.spin) and P_IsObjectOnGround(p.mo) and not p.mo.attacktype and p.mo.state ~= S_PLAY_CROUCH and p.speed < 5*FRACUNIT
		if p.mo.curItem and s.items[p.mo.curItem]
			s.items[p.mo.curItem].usefunc(p.mo)
		else
			s.staleCheck(p, "jab1")
			p.mo.attacktype = "jab1"
		end

		p.mo.curItem = "none"
	end
end

s.fireInputs = function(p)
	if server.endGame then return nil end
	if not p.mo then return nil end
	if p.mo.attacktype then return nil end
	if p.mo.hitstun then return nil end
	if p.mo.flingWait then return nil end
	if p.mo.atkstop then return nil end
	if p.mo.dodge then return nil end
	if p.mo.fsTimer then return nil end
	if p.mo.airDodge then return nil end
	if p.mo.screenKO then return nil end
	if p.mo.starKO then return nil end
	
	-- up specials cant be combod into other specials
	if p.mo.noReuse
		if p.mo.noReuse["upspecial"] then return nil end
	end

	-- activate with fire or custom 1
	if (p.specialBtn == "fire" and p.mo.button.attack == 1) or (p.specialBtn == "custom1" and p.mo.button.custom1 == 1)
		p.mo.tumble = nil
		if not P_IsObjectOnGround(p.mo) then p.mo.notgrounded = true end

		if p.mo.button.up >= 1
			if not p.mo.noReuse["upspecial"] 
				s.staleCheck(p, "upspecial")
				p.mo.attacktype = "upspecial"
				p.fastfalling = false
			end
		elseif p.mo.button.down >= 1
			if not p.mo.noReuse["downspecial"]
				s.staleCheck(p, "downspecial") 
				p.mo.attacktype = "downspecial" 
				p.fastfalling = false
			end
		elseif (p.mo.button.left >= 1 or p.mo.button.right >= 1)
			if not p.mo.noReuse["sidespecial"] 
				s.staleCheck(p, "sidespecial")
				p.mo.attacktype = "sidespecial"
				p.fastfalling = false
			end
		else
			if p.mo.finalsmash and not p.mo.fsTimer
				s.doFinalSmash(p.mo)
			else
				s.staleCheck(p, "neutralspecial")
				p.mo.attacktype = "neutralspecial"
				p.fastfalling = false
			end
		end
	end
end

s.curAttack = function(mo)
	if not mo or not mo.valid then return {} end
	if not mo.attacktype then return {} end

	if s.chars[mo.skin] and s.chars[mo.skin][mo.attacktype]
		return s.chars[mo.skin][mo.attacktype]
	end

	return {}
end

// Final Smashes
s.getFinalSmash = function(mo)
	if not mo.finalsmash
		mo.finalsmash = true
		S_StartSound(mo, sfx_sbget)
		if cv_fsmeter.value then mo.fsMeter = 100 end
	end
end

s.doFinalSmash = function(mo)
	if mo and mo.valid
		if mo.doBlast then return end
		if mo.airDodge then return end
		if mo.fsTimer then return end

		for p in players.iterate do S_StartSound(nil, sfx_fsuse, p) end

		mo.fsTimer = 15
		s.forceCamPos(35, mo)
		if cv_fsmeter.value then mo.fsMeter = 0 end
	end
end

s.parryEff = function(mo)
	P_StartQuake(26*FRACUNIT, 8, {mo.x, mo.y, mo.z}, 300*FRACUNIT)
	S_StartSound(mo, sfx_forcsg)
	mo.doneParry = 20
	mo.hitcool = 40

	mo.colorized = false
	
	if mo and mo.player then mo.player.finalScoreStuff.parries = $+1 end

	local orb = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
	orb.sprite = SPR_WITS
	orb.destscale = 4*FRACUNIT
	orb.color = mo.color
	orb.fuse = 35
	orb.tics = 35
end

s.parryStun = function(mo, inf, priority)
	if mo and mo.valid and inf and inf.valid
		if mo == inf then return end
		s.parryEff(inf)

		mo.colorized = false
		mo.color = mo.player and mo.player.skincolor or SKINCOLOR_GREEN

		inf.colorized = false
		inf.color = inf.player and inf.player.skincolor or SKINCOLOR_GREEN

		mo.attacktype = nil
		mo.atktimer = nil
		mo.state = S_PLAY_FALL
		mo.hitByParry = 21
		mo.parried = 10*TICRATE

		mo.flags = $ & ~MF_NOGRAVITY & ~MF_FLOAT
	end
end

s.resetSpring = function(mo, spring)
	if not (spring.flags & MF_SPRING) return end

	if mo.z + mo.height >= spring.z and mo.z <= spring.z + spring.height
		mo.flags = $ & ~MF_NOGRAVITY & ~MF_FLOAT
		mo.attacktype = nil
		mo.airDodged = nil
		mo.atktimer = nil

		if p.mo.attacktype == "finalsmash" then
			p.mo.fsMeter = 0
			p.mo.finalsmash = nil
		end

		mo.doublejumped = nil
		mo.noReuse = {}
	end
end