local s = SRB2Smash

// Flare's Smash Cam, adapted for one mobj
s.getMobjForType = function(type)
	for i_mo in mobjs.iterate() -- i_mo is "iterating mo"
		if (i_mo.type != type)
			continue -- Ignore it
		end

		return i_mo
	end

	return nil
end

s.forceCamPos = function(time, ...)
	if not server.forceCamMobjs then server.forceCamMobjs = {} end
	local args = {...}
	local x, z = 0, 0
	local farthestPoint = 0
	for i, mo in ipairs(args)
		if mo and mo.valid
			x = $+(mo.x/FRACUNIT)
			z = $+(mo.z/FRACUNIT)
			
			if mo.x > farthestPoint then farthestPoint = mo.x end
			if mo.x < -farthestPoint farthestPoint = -mo.x end
			
			server.forceCamMobjs[#server.forceCamMobjs+1] = mo
		end
	end
	
	x = ($/#args)*FRACUNIT
	z = ($/#args)*FRACUNIT

	local y = -30*FRACUNIT
	for i, mo in ipairs(args)
		y = abs(mo.x - x)
		if (y > x) then y = x end
	end
	y = $-165*FRACUNIT

	for p in players.iterate
		if p.smashcam and p.smashcam.valid
			P_TeleportMove(p.smashcam, x, args[1].y + y, z)
			p.smashcam.momx = 0
			p.smashcam.momy = 0
			p.smashcam.momz = 0

			server.forceCamTime = time
		end
	end
end

s.cameraThinker = function(p)
	local smashFighters = {}
	for player in players.iterate
		if not player.spectator and not player.smashSpectate and not player.mo.tempSpectate and player.lives > 0 and player.playerstate ~= PST_DEAD
			table.insert(smashFighters, player.mo)
		end
	end

	if #smashFighters -- and twodlevel
		if s.getMobjForType(MT_CAMMIN) and s.getMobjForType(MT_CAMMAX)
			if not p.smashcam
				local fighterCount = 0
				local x, y, z = 0, 0, 0
				for k,v in ipairs(smashFighters)
					if v and v.valid
						x = $+v.x/FRACUNIT
						y = $+v.y/FRACUNIT
						z = $+v.z/FRACUNIT
						fighterCount = $+1
					end
				end
				
				x, y, z = ($/fighterCount)*FRACUNIT, ($/fighterCount)*FRACUNIT, ($/fighterCount)*FRACUNIT

				p.smashcam = P_SpawnMobj(x, y, z, MT_PLAYCAM)
				p.smashcam.angle = ANGLE_90
			elseif not p.smashcam.valid
				p.smashcam = nil
				return
			else
				for p in players.iterate
					if p.mo and p.mo.valid
						if not p.spectator and not p.smashSpectate and not p.mo.tempSpectate and p.lives > 0 and cv_smashcam.value
							-- spawn lockon so you understand where you are
							if not p.mo.killed then P_SpawnLockOn(p, p.mo, S_LOCKON1) end
--							if s.isTeam() and not p.mo.killed then s.teamInfo(p) end

							--awayview
							if not p.awayviewmobj p.awayviewmobj = p.smashcam else p.awayviewtics = 2 end
						end
					end
				end
			end
		else
			if p.smashcam and p.smashcam.valid then P_RemoveMobj(p.smashcam) end
			p.smashcam = nil
			return
		end
	end

	-- Variable not set?
	if not p.smashcam then return end
	
	-- Invalid smash camera?
	if not p.smashcam.valid
		p.smashcam = nil
		return
	end

	s.camThink(p, p.smashcam)
end

-- Now for the smash bros. camera itself.
-- I'm recoding the smash camera to optimize it's code and overall make it c ooler
-- THIS CODE IS REALLY MESSY ANYWAY LOL so i think i failed
-- I suck
s.camThink = function(p, mo)
	local smashFighters = {}
	for player in players.iterate
		if not player.spectator and not player.smashSpectate and not player.mo.tempSpectate and player.lives > 0 and player.playerstate ~= PST_DEAD
			table.insert(smashFighters, player.mo)
		end
	end

	if server.forceCamTime
		mo.momx = 0
		mo.momy = 0
		mo.momz = 0

		server.forceCamTime = $-1
		if server.forceCamTime <= 0 then server.forceCamTime = nil end
		return
	end

	-- These 2 mobjs are the furthest x and y the camera can go
	local min = s.getMobjForType(MT_CAMMIN)
	local max = s.getMobjForType(MT_CAMMAX)

	-- Get the average coords, and also get the furthest x coord
	-- also just end the script if there are no fighters
	if not #smashFighters then return end

	local x, y, z = 0, 0, 0
	local fighterCount = 0
	for k,v in ipairs(smashFighters)
		if v and v.valid
			x = $+v.x/FRACUNIT
			z = $+v.z/FRACUNIT
			fighterCount = $+1
		end
	end

	-- Calculate Average, taking min and max into account.
	x, z = ($/fighterCount)*FRACUNIT, ($/fighterCount)*FRACUNIT

	-- Prioritise player
	if fighterCount > 1
		local remain = p.mo.x-x
		x = $+remain/4

		remain = p.mo.z-z
		z = $+remain/4
	end

	-- Maximum X and Maximum Z
	if not mapheaderinfo[gamemap].dontrestrictx
		if x <= min.x then x = min.x elseif x >= max.x then x = max.x end
	end
	
	if not mapheaderinfo[gamemap].dontrestrictz
		if z <= min.z then z = min.z elseif z >= max.z then z = max.z end
	end

	-- Now calculate y
	local leastPoint = 0
	local furthestPoint = 0
	local leastZPoint = 0
	local furthestZPoint = 0
	for k,v in ipairs(smashFighters)
		if v.x < leastPoint then leastPoint = v.x end
		if v.x > furthestPoint then furthestPoint = v.x end
		if v.z < leastZPoint then leastZPoint = v.z end
		if v.z > furthestZPoint then furthestZPoint = v.z end
	end

	local diff = (furthestPoint-leastPoint)/2
	local yCheckX = p.mo.y - (diff+160*FRACUNIT)
	
	diff = (furthestZPoint-leastZPoint)/2
	local yCheckZ = p.mo.y - (diff+160*FRACUNIT)
	
	if (yCheckX <= yCheckZ)
		y = yCheckX
	else
		y = yCheckZ
	end

	-- Maximum Y
	if mapheaderinfo[gamemap].dontrestricty
		if y >= min.y then y = min.y elseif y <= max.y then y = max.y end
	end
	
	-- Gradually move camera into position
	if P_AproxDistance(P_AproxDistance(x - mo.x, y - mo.y), z - mo.z) >= 5*FRACUNIT
		mo.momx = (x-mo.x)/5
		mo.momy = (y-mo.y)/5
		mo.momz = (z-mo.z)/5
	else
		mo.momx = 0
		mo.momy = 0
		mo.momz = 0
	end
end