local s = SRB2Smash

// add damage to tmo
s.addDamage = function(tmo, imo, amount)
	if not tmo or not tmo.valid then return end
//	if not imo or not imo.valid then return end

	tmo.techInvinc = nil
	tmo.airDodge = nil

	if tmo.attacktype == "finalsmash" then return end
	if tmo.doneParry then return end
	
	if imo and imo.valid
		if tmo.player and imo.player
			if s.sameTeam(tmo.player, imo.player) then return end
		end

		tmo.attacker = imo
		if s.curAttack(imo) and s.curAttack(imo).hitFunc then s.curAttack(imo).hitFunc(imo, tmo) end
	end

	if s.curAttack(tmo) and s.curAttack(tmo).strikeFunc then s.curAttack(tmo).strikeFunc(tmo, imo or nil) end
	
	if tmo.player then tmo.player.hudshit["hit"] = 10 end
	tmo.attacktype = nil
	tmo.atktimer = nil
	tmo.flying = false
	tmo.parried = nil
	tmo.parry = nil
	tmo.doneParry = nil
	tmo.tumble = nil
	tmo.noReuse = {}
	tmo.notgrounded = nil
	tmo.flags = $ & ~MF_NOGRAVITY & ~MF_FLOAT
	
	tmo.colorized = false
	if tmo.player then tmo.color = tmo.player.skincolor end

	if cv_fsmeter.value
		tmo.fsMeter = $+amount/2
		if tmo.fsMeter > 100 then tmo.fsMeter = 100 end
	end

	if tmo.player then tmo.player.pflags = $|PF_JUMPED & ~PF_SPINNING end
	
	if tmo.smashRings and tmo.smashRings >= 25
		amount = $/2
	end

	if tmo.shield then amount = $/tmo.shield.def end
	s.loseRings(tmo, imo, amount)

	if s.usesPercent()
		if not tmo.percent then tmo.percent = 0 end
		tmo.percent = $+amount
	elseif s.usesStamina()
		tmo.stamina = $-amount
		if tmo.stamina <= 0 
			if imo and imo.valid
				s.killMobj(tmo, imo, nil, true) 
			else
				s.killMobj(tmo, nil, nil, true)
			end
		end
	end

	// Let's get the score settled
	if tmo.player
		tmo.player.finalScoreStuff.totaldmgtaken = $+amount
	end

	tmo.lastHit = 0
	if imo and imo.valid and imo.player
		imo.player.finalScoreStuff.totaldmgdealt = $+amount
		imo.didHitFoe = true

//		imo.lastHit = 0

		tmo.inCombo = true
		if tmo.inCombo and imo.curCombo
			imo.curCombo = $+1
			if imo.curCombo > imo.player.finalScoreStuff.maxcombo
				imo.player.finalScoreStuff.maxcombo = imo.curCombo
			end
		else
			imo.curCombo = 1
			tmo.inCombo = true
			if imo.player.finalScoreStuff.maxcombo <= 0 then imo.player.finalScoreStuff.maxcombo = 1 end
		end
	end
end

s.damageFromSector = function(mo, dmgType)
	mo.attacktype = nil
	mo.atktimer = nil
	s.loseRings(mo, nil, 30)

	if (dmgType == DMG_FIRE)
		mo.hitstun = 20
		s.addDamage(mo, nil, P_RandomRange(8, 25))
		P_SetObjectMomZ(mo, (mo.percent/4)*FRACUNIT)
		S_StartSound(mo, sfx_lvahit)
		
		mo.tumble = true
		mo.hitEffect = {"fire", 70}
		
		if mo.percent > 200 then SRB2Smash.killMobj(mo, mo.attacker) end
	elseif (dmgType == DMG_ELECTRIC)
		mo.hitstun = 60
		s.addDamage(mo, nil, P_RandomRange(10, 20))
		
		mo.flingWait = {
			time = 30,
			angle = mo.angle,
			thrust = P_RandomRange(-10, 10)*FRACUNIT,
			momz = (mo.percent/4)*FRACUNIT
		}

		S_StartSound(mo, sfx_elchit)
	else
		mo.hitstun = 20
		s.addDamage(mo, nil, P_RandomRange(3, 9))
		
		mo.flingWait = {
			time = 5,
			angle = mo.angle,
			thrust = P_RandomRange(-10, 10)*FRACUNIT,
			momz = (mo.percent/4)*FRACUNIT
		}
	end
end

// Damage from objects
s.damageFromObj = function(p, inf, src, knockback, launch, spike)
	if s.noHit(p.mo) then return false end

	if inf and inf.valid and inf.user and inf.user.valid
		if p.mo == inf.user then return false end
		if s.isAdventure() and inf.player then return false end
		if s.isAdventure() and inf.user.player then return false end
		
		-- tracer check for orbinaut ball
		if inf.target and inf.target.valid and inf.target.user and p.mo == inf.target.user then return end

		-- team check
		if inf and inf.valid and inf.user.player and s.isTeam() -- check again i hope
			if s.sameTeam(p, inf.user.player) then return false end
		end
	end

	-- Waht the fuck is a sourcer
	--         - Spectra
	if src and src.valid
		if p.mo == src then return false end
		if s.isTeam() and src.player and s.sameTeam(p, src.player) then return false end
		if s.isAdventure() and src.player then return false end
		
		if src.user and src.user.valid
			if p.mo == src.user then return false end
			if s.isTeam() and src.user.player and s.sameTeam(p, src.user.player) then return false end
		end
	end

	if (inf.flags & MF_MISSILE) and (inf.target == p.mo) then return false end

	local canRepel = true
	if s.mobjDefs[inf.type] and s.mobjDefs[inf.type].norepel
		canRepel = false
	end

	if p.mo.parry and p.mo.parry > 30 and canRepel == true
		s.parryEff(p.mo)
		inf.momx = -$
		inf.momy = -$
		inf.momz = -$
		inf.angle = $+ANGLE_180
		
		if (inf.flags & MF_MISSILE)
			inf.target = p.mo
			inf.user = p.mo

			inf.color = p.mo.color
			inf.colorized = true
			inf.flags = $ & ~MF_NOCLIPTHING
		end

		// Hardcode repel
		if inf.type == MT_AIRSLASH
			inf.state = mobjinfo[MT_AIRSLASH].spawnstate
		end

		p.mo.hitcool = 35
		return
	end
	
	if s.curAttack(p.mo) and s.curAttack(p.mo).repelprojectiles and canRepel == true
		inf.momx = -$
		inf.momy = -$
		inf.momz = -$
		inf.angle = $+ANGLE_180

		if (inf and inf.flags & MF_MISSILE)
			inf.target = p.mo
			inf.user = p.mo
			inf.color = p.mo.color
			inf.colorized = true
			inf.flags = $ & ~MF_NOCLIPTHING
		end

		p.mo.hitcool = 10
		return
	end

	-- allow knockback n shit
	if s.mobjDefs[inf.type]
		if s.mobjDefs[inf.type].overridehit
			if s.mobjDefs[inf.type].hitsound
				S_StartSound(p.mo, s.mobjDefs[inf.type].hitsound)
			end

			return s.mobjDefs[inf.type].overridehit(p.mo, inf, inf.target or nil)
		end

		if s.mobjDefs[inf.type].hitsound
			S_StartSound(p.mo, s.mobjDefs[inf.type].hitsound)
		else
			S_StartSound(p.mo, sfx_punch1)
		end

		if s.mobjDefs[inf.type].hiteffect
			p.mo.hitEffect = {s.mobjDefs[inf.type].hiteffect, 70}
		end			

		// Inflict Status
		if s.mobjDefs[inf.type].status then p.mo.statusEffect = {s.mobjDefs[inf.type].status, 5*TICRATE} end
	else
		S_StartSound(p.mo, sfx_turhit)
	end

	if not src and inf.attacker then src = inf.attacker end
	
	// damage based on scale or definitions
	local explode
	if s.mobjDefs[inf.type]
		if s.mobjDefs[inf.type].dynamicdmg
			local dmg = 1
			dmg, explode = s.mobjDefs[inf.type].dynamicdmg(inf, p.mo)
			if src and src.valid
				s.addDamage(p.mo, src, dmg)
			else
				s.addDamage(p.mo, nil, dmg)
				p.mo.hitcool = 10
			end
		elseif s.mobjDefs[inf.type].dmg
			if src and src.valid
				s.addDamage(p.mo, src, s.mobjDefs[inf.type].dmg)
			else
				s.addDamage(p.mo, nil, s.mobjDefs[inf.type].dmg)
				p.mo.hitcool = 10
			end
		end
	else
		if src and src.valid
			if inf.scale > FRACUNIT
				if inf.scale < 3*FRACUNIT/2
					s.addDamage(p.mo, src, P_RandomRange(7, 9))
				elseif inf.scale < 2*FRACUNIT
					s.addDamage(p.mo, src, P_RandomRange(10, 16))
				elseif inf.scale < 3*FRACUNIT
					s.addDamage(p.mo, src, P_RandomRange(13, 21))
				else
					s.addDamage(p.mo, src, P_RandomRange(22, 30))
				end
			else
				s.addDamage(p.mo, src, P_RandomRange(4, 6))
			end
		else
			s.addDamage(p.mo, nil, P_RandomRange(4, 6))
			p.mo.hitcool = 10
		end
	end
	
	if s.mobjDefs[inf.type] and s.mobjDefs[inf.type].nostun
		p.mo.atkstop = s.mobjDefs[inf.type].hitlag or 1
		p.mo.hitcool = s.mobjDefs[inf.type].hitcool or 5
		return
	end

	if launch and p.mo.percent >= 130
		if s.mobjDefs[inf.type]
			if s.mobjDefs[inf.type].mod 
				p.mo.launch = true
			else
				p.mo.launch = nil
			end
		else
			p.mo.launch = true
		end
	end

	// Inflict Status
	if s.mobjDefs[inf.type] and s.mobjDefs[inf.type].status 
		if s.mobjDefs[inf.type].status == EFF_BURN or s.mobjDefs[inf.type].status == EFF_FREEZE
			local statusTime = {
				[EFF_BURN] = 6*TICRATE,
				[EFF_FREEZE] = 3*TICRATE
			}

			p.mo.statusEffect = {s.mobjDefs[inf.type].status, statusTime[s.mobjDefs[inf.type].status]} 
		end
	end

	if not s.curAttack(p.mo).superarmor or (p.mo.attacktype and p.mo.smashRings and p.mo.smashRings >= 30)
		if s.mobjDefs[inf.type] and s.mobjDefs[inf.type].hitstun
			local stun = s.mobjDefs[inf.type].hitstun
			p.mo.hitstun = launch and stun*2 or stun
		else
			p.mo.hitstun = launch and 35 or 19
		end

		local hitlag = 5
		if s.mobjDefs[inf.type] and s.mobjDefs[inf.type].hitlag
			local stun = s.mobjDefs[inf.type].hitlag
			hitlag = launch and stun*2 or stun
		else
			hitlag = launch and 13 or 6
		end

		p.mo.flingWait = {
			time = hitlag,
			angle = inf.angle,
			thrust = 0,
			momz = 0
		}

		if knockback
			if s.mobjDefs[inf.type]	
				if s.mobjDefs[inf.type].dynamicknockback
					local x,y,mod = s.mobjDefs[inf.type].dynamicknockback(inf, p.mo)

					if (mod == true)
						x = $+(p.mo.percent/7)*(FRACUNIT/8)
						if y >= 0
							y = $+(p.mo.percent/6)*(FRACUNIT/4)
						else
							y = $-(p.mo.percent/6)*(FRACUNIT/4)
						end
					end

					p.mo.flingWait.thrust = x
					p.mo.flingWait.momz = y
				elseif (s.mobjDefs[inf.type].x or s.mobjDefs[inf.type].y)
					local x,y = 0,0
					if s.mobjDefs[inf.type].x
						x = s.mobjDefs[inf.type].x
						if s.mobjDefs[inf.type].mod
							x = $+(p.mo.percent/7)*(FRACUNIT/8)
						end
					end

					if s.mobjDefs[inf.type].y
						y = s.mobjDefs[inf.type].y
						if s.mobjDefs[inf.type].mod
							if y >= 0
								y = $+(p.mo.percent/6)*(FRACUNIT/4)
							else
								y = $-(p.mo.percent/6)*(FRACUNIT/4)
							end
						end
					end

					p.mo.flingWait.thrust = x
					p.mo.flingWait.momz = y
				else
					if spike
						p.mo.hitstun = 8
						p.mo.flingWait.thrust = 0
						p.mo.flingWait.momz = -(p.mo.percent/5)*FRACUNIT/2
						S_StartSound(p.mo, sfx_meteor)
					else
						p.mo.hitstun = 15
						if P_IsObjectOnGround(p.mo)
							p.mo.flingWait.momz = (p.mo.percent/5)*FRACUNIT/2
						else
							p.mo.flingWait.momz = ((p.mo.z-(inf.z))/7)+((p.mo.percent/6)*FRACUNIT/2)
						end

						p.mo.flingWait.angle = R_PointToAngle2(inf.x, inf.y, p.mo.x, p.mo.y)
						p.mo.flingWait.thrust = (10+s.invWeight(p.mo.skin)+(p.mo.percent/6))*(FRACUNIT/4)
					end
				end
			else
				if spike
					p.mo.hitstun = 8
					p.mo.flingWait.thrust = 0
					p.mo.flingWait.momz = -(p.mo.percent/5)*FRACUNIT/2
					S_StartSound(p.mo, sfx_meteor)
				else
					p.mo.hitstun = 15
					if P_IsObjectOnGround(p.mo)
						p.mo.flingWait.momz = (p.mo.percent/5)*FRACUNIT/2
					else
						p.mo.flingWait.momz = ((p.mo.z-(inf.z))/7)+((p.mo.percent/6)*FRACUNIT/2)
					end

					p.mo.flingWait.angle = R_PointToAngle2(inf.x, inf.y, p.mo.x, p.mo.y)
					p.mo.flingWait.thrust = (10+s.invWeight(p.mo.skin)+(p.mo.percent/6))*(FRACUNIT/4)
				end
			end
		end
	else
		p.mo.atkstop = 15
	end
	
	if p.mo.launch
		p.mo.flingWait.thrust = ($*5)/2
		p.mo.flingWait.momz = ($*5)/2
	end

	if inf and inf.valid and inf.type == MT_SMASH_SPIKEBALL
		inf.repelMovement = p.mo.flingWait and p.mo.flingWait.time or 15
	end

	// Elec Stun
	if s.mobjDefs[inf.type] and s.mobjDefs[inf.type].status == EFF_ELECTRICSTUN
		p.mo.flingWait.time = $+TICRATE

		local thok = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
		thok.sprite = SPR_ENRG
		thok.scale = FRACUNIT/3
		thok.destscale = 2*FRACUNIT
		thok.tics = 20

		for i = 1, 8
			local electric = P_SpawnMobj(p.mo.x + P_RandomRange(-20, 20)*FRACUNIT, p.mo.y + P_RandomRange(-20, 20)*FRACUNIT, p.mo.z + P_RandomRange(-20, 20)*FRACUNIT, MT_THOK)
			electric.sprite = SPR_WZAP
			electric.frame = A
			electric.tics = 35
			electric.fuse = 35
			electric.scale = P_RandomRange(FRACUNIT, 2*FRACUNIT)
			electric.momx = P_RandomRange(-15, 15)*FRACUNIT
			electric.momy = P_RandomRange(-15, 15)*FRACUNIT
			electric.momz = P_RandomRange(-15, 15)*FRACUNIT
		end
		
		p.mo.wasElec = true
	end

	p.mo.hitcool = s.mobjDefs[inf.type] and s.mobjDefs[inf.type].hitcool or 10
//	if (inf.flags & MF_MISSILE)
		if (s.mobjDefs[inf.type] and s.mobjDefs[inf.type].nokill) or not explode
			inf.flags = $ & ~MF_NOCLIPTHING
		else
			P_KillMobj(inf)
		end
//	end
	
	// Shield
	if p.mo.shield
		if p.mo.shield.knockback
			p.mo.flingWait.thrust = ($/100)*p.mo.shield.knockback
			p.mo.flingWait.momz = ($/100)*p.mo.shield.knockback
		end

		p.mo.shield.hp = $-1
		if p.mo.shield.hp <= 0
			p.mo.shield = nil
			S_StartSound(p.mo, sfx_s3k5d)
		end
	end
	
	-- check for last player
	if cv_stocks.value
		local aliveCount = 0
		for player in players.iterate
			if player.lives > 0 and not player.smashSpectate
				aliveCount = $+1
			end
		end

		if aliveCount <= 2 and p.lives <= 1 and p.mo.launch and (p.mo.flingWait.thrust >= 35*FRACUNIT or p.mo.flingWait.momz >= 20*FRACUNIT or p.mo.flingWait.momz <= -50*FRACUNIT)
			if inf and inf.valid and inf.target and inf.target.valid and inf.target.player
				s.finalHit(p.mo, inf.target)
			end
		end
	end
end

s.killMobj = function(mo, inf, blastZone, stamina)
	if not mo or not mo.valid then return end
	if mo.dieCool then return end
	if mo.killed then return end
	if mo.player and mo.player.playerstate == PST_DEAD then return end
	if (mo.player and mo.player.smashSpectate) or mo.tempSpectate then return end
	
	if mo.player
		if blastZone and blastZone.valid
			return s.blastZoneHit(mo.player, (inf and inf.valid) and inf.player or nil, blastZone, stamina)
		else
			return s.blastZoneHit(mo.player, (inf and inf.valid) and inf.player or nil, nil, stamina)
		end
	end
	
	P_KillMobj(mo, inf or nil)
end

// Final blow to end the game!
s.finalHit = function(mo, inf)
	for p in players.iterate
		S_StartSound(nil, sfx_lastht, p)
		S_FadeMusic(0, 0, p)
		p.restoreMusic = 2*TICRATE
	end

	P_TeleportMove(mo, mo.x, mo.y, mo.z + FRACUNIT)

	mo.flingWait.time = 48
	if inf and inf.atkstop then inf.atkstop = 48 end
	
	for i = 1, 10
		local spark = P_SpawnMobj(mo.x, mo.y, mo.z, MT_BOXSPARKLE)
		spark.momx = P_RandomRange(-30, 30)*FRACUNIT
		spark.momy = P_RandomRange(-30, 30)*FRACUNIT
		spark.momz = P_RandomRange(-30, 30)*FRACUNIT
	end

	for i = 1, 5
		local spark = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SUPERSPARK)
		spark.momx = P_RandomRange(-30, 30)*FRACUNIT
		spark.momy = P_RandomRange(-30, 30)*FRACUNIT
		spark.momz = P_RandomRange(-30, 30)*FRACUNIT
	end

	server.bamTime = {
		time = mo.flingWait.time + 15,
		color = inf.player and inf.player.skincolor or inf.color
	}

	s.forceCamPos(mo.flingWait.time, mo, inf)
end