local s = SRB2Smash

s.checkKO = function(mo, inf)
	if P_RandomFixed() >= FRACUNIT/2
		mo.starKO = {
			timer = 0,
			inflictor = inf
		}

		P_TeleportMove(mo, mo.x, mo.y, mo.z-450*FRACUNIT)
	else
		mo.screenKO = {
			timer = 0,
			inflictor = inf
		}
		
		P_TeleportMove(mo, mo.x, mo.y-mo.radius, mo.z)
	end
end

s.starKO = function(mo)
	if not mo.starKO then return end
	
	mo.starKO.timer = $+1
	mo.momx = 0
	mo.momy = 0
	mo.momz = 0
	
	if mo.starKO.timer <= 105
		mo.destscale = 1
		mo.scalespeed = FRACUNIT/300

		mo.momy = 3*FRACUNIT
		mo.momz = -9*FRACUNIT
		mo.state = S_PLAY_DEAD
		mo.rollangle = $+ANG20
	end

	if P_IsObjectOnGround(mo) and mo.starKO.timer < 105
		mo.starKO.timer = 105
	end

	if mo.player and mo.player.powers[pw_pushing] and mo.starKO.timer < 105
		mo.starKO.timer = 105
	end

	if mo.starKO.timer == 105
		local star = P_SpawnMobj(mo.x, mo.y, mo.z-100*FRACUNIT, MT_SUPERSPARK)
		star.scale = 8*FRACUNIT

		if mo.player
			s.losePoint(mo.player)
			if mo.starKO.inflictor and mo.starKO.inflictor.player then s.gainPoint(mo.starKO.inflictor.player) end

			mo.player.hudshit["hit"] = 35
			mo.player.pflags = $ & ~PF_JUMPED & ~PF_SPINNING
		end

		mo.attacktype = "none"
		mo.atktimer = 0
		mo.flying = false
		mo.parried = nil
		mo.parry = nil
		mo.doneParry = nil
		mo.tumble = nil
		mo.noReuse = {}
		mo.notgrounded = nil
		mo.flags = $ & ~MF_NOGRAVITY & ~MF_FLOAT
		mo.dieCool = 10
	end

	if mo.starKO.timer >= 105
		mo.state = S_INVISIBLE
	end
	
	if mo.starKO.timer >= 175
		mo.starKO = nil

		if mo.player.lives <= 1
			mo.player.playerstate = PST_DEAD
			mo.player.lives = 0
		else
			mo.player.playerstate = PST_REBORN

/*			if mo.player.lives <= 1
				P_KillMobj(mo)
			else */
				mo.player.lives = $-1
--			end
		end
	end
end

s.screenKO = function(mo)
	if not mo.screenKO then return end
	if not mo.screenKO.randAng then mo.screenKO.randAng = P_RandomRange(1, 360)*ANG1 end

	mo.screenKO.timer = ($ and $ < 105) and $+3 or $+1
	
	mo.state = S_INVISIBLE
	mo.momx = 0
	mo.momy = 0
	mo.momz = 0

	if mo.screenKO.timer < 35 then mo.screenKO.randAng = $+ANG20 end
	
	if mo.screenKO.timer == 36
		for p in players.iterate
			S_StartSound(nil, sfx_pstop, p)
		end
		
		P_StartQuake(10*FRACUNIT, 5)
	end

	if mo.screenKO.timer == 105
		local star = P_SpawnMobj(mo.x, mo.y, mo.z-100*FRACUNIT, MT_SUPERSPARK)
		star.scale = 8*FRACUNIT

		if mo.player
			s.losePoint(mo.player)
			if mo.screenKO.inflictor and mo.screenKO.inflictor.player then s.gainPoint(mo.screenKO.inflictor.player) end

			mo.player.hudshit["hit"] = 35
			mo.player.pflags = $ & ~PF_JUMPED & ~PF_SPINNING
		end

		mo.attacktype = "none"
		mo.atktimer = 0
		mo.flying = false
		mo.parried = nil
		mo.parry = nil
		mo.doneParry = nil
		mo.tumble = nil
		mo.noReuse = {}
		mo.notgrounded = nil
		mo.flags = $ & ~MF_NOGRAVITY & ~MF_FLOAT
		mo.dieCool = 10
	end
	
	if mo.screenKO.timer >= 175
		mo.screenKO = nil

		if mo.player.lives <= 1
			mo.player.playerstate = PST_DEAD
			mo.player.lives = 0
		else
			mo.player.playerstate = PST_REBORN

/*			if mo.player.lives <= 1
				P_KillMobj(mo)
			else */
				mo.player.lives = $-1
--			end
		end
	end
end