local s = SRB2Smash

s.updateHud = function(p)
	if server.endGame then return end

	if not p.hudshit
		p.hudshit = {
			["+1"] = 0,
			["-1"] = 0,
			["hit"] = 0,
			["randhudx"] = 0,
			["randhudy"] = 0
		}
	end

	local hudAff = {
		"hit",
		"+1",
		"-1",
	}
	
	for i = 1, #hudAff
		if p.hudshit[hudAff[i]] then p.hudshit[hudAff[i]] = $-1 end
	end
	
	if p.hudshit["hit"] and p.hudshit["hit"] > 0
		if p.mo.percent
			p.hudshit["randhudx"] = P_RandomRange(-5 - p.mo.percent/10, 5 + p.mo.percent/10)
			p.hudshit["randhudy"] = P_RandomRange(-5 - p.mo.percent/10, 5 + p.mo.percent/10)
		end
	end
end

s.updateValues = function(p)
	if p.supposedToBeInThisGame
		p.smashSpectate = nil
		p.mo.tempSpectate = nil
		p.supposedToBeInThisGame = nil
	
		p.mo.state = S_PLAY_STND
		p.playerstate = PST_REBORN
		return
	end

	if server.endGame then return end

	-- fucok you spinning!1 oh and godmode too ! invis to11
	if (p.pflags & PF_SPINNING) then p.pflags = $ & ~PF_SPINNING end
	if (p.pflags & PF_GODMODE) then p.pflags = $ & ~PF_GODMODE end
	if (p.pflags & PF_INVIS) then p.pflags = $ & ~PF_INVIS end

	-- cool jump gameing
	if not P_IsObjectOnGround(p.mo)
		p.pflags = $|PF_JUMPED
	end

	-- for voting screen
	if p.realmo then p.lastSkin = p.realmo.skin end

	-- movement easi e
	p.mo.movespeed = p.speed or 0

	-- stop movement
	if p.mo.hitstun and not p.mo.flingWait then p.powers[pw_nocontrol] = p.mo.hitstun or 1 end
	if p.mo.atkstop then p.powers[pw_nocontrol] = p.mo.atkstop or 1 end
	
	if p.restoreMusic
		p.restoreMusic = $-1
		if p.restoreMusic <= 0
			S_FadeMusic(100, MUSICRATE, p)
		end
	end
	
	// General Mobj 
	s.speedThinker(p)
	s.mobjThinker(p.mo)
	if p.killedBlast then s.killedBlast(p) end
end

s.mobjThinker = function(mo)
	if server.endGame then return end

	local skin = s.chars[mo.skin]

	-- priority
	mo.priority = 0
	if skin[mo.attacktype] and skin[mo.attacktype].priorityCheck
		mo.priority = $+skin[mo.attacktype].priorityCheck(mo)
	end

	-- Thinkers
	-- User Thinker
	if skin["thinker"] then skin["thinker"](mo) end

	-- All Other player thinkers
	if skin["thinkerOnTargets"]
		local smashPlayers = {}
		for player in players.iterate
			if not player.spectator and not player.smashSpectate and not player.mo.tempSpectate and player.lives > 0 and player.playerstate ~= PST_DEAD
				table.insert(smashPlayers, player.mo)
			end
		end

		for k,v in ipairs(smashPlayers)
			skin["thinkerOnTargets"](v, mo)
		end
	end

	-- shield
	if mo.shield
		if mo.shieldMobj and mo.shieldMobj.valid
			P_TeleportMove(mo.shieldMobj, mo.x, mo.y, mo.z)
		else
			mo.shieldMobj = P_SpawnMobj(mo.x, mo.y, mo.z, mo.shield.mobj)
			mo.shieldMobj.color = mo.color
		end
	else
		if mo.shieldMobj and mo.shieldMobj.valid then P_RemoveMobj(mo.shieldMobj) end
		mo.shieldMobj = nil
	end

	// Star KOs
	if mo.starKO then return s.starKO(mo) end
	if mo.screenKO return s.screenKO(mo) end

	// Timers
	// Hit Cooldown
	if mo.hitcool and not mo.flingWait
		mo.hitcool = $-1
		if mo.hitcool <= 0 then mo.hitcool = nil end
	end
	
	// Ground Resets
	if P_IsObjectOnGround(mo)
		-- something was gonna go here 
		-- but not anymore
		-- so now we have
		-- me the idiotic human
		-- typing here
		if not mo.hitstun
			if mo.inCombo
				mo.inCombo = nil
				if mo.attacker and mo.attacker.valid then mo.attacker.curCombo = 0 end
			end

			mo.attacker = nil
			mo.airDodged = nil
			mo.doublejumped = nil
			mo.player.fastfalling = false
		end
	end

	// Gravity and weight
	if not P_IsObjectOnGround(mo) and mo.momz <= 0 and not mo.airDodge and mo.attacktype ~= "finalsmash"
		local momzPull = (-10 - (max(min(skin.weight, 9), 1))) * (gravity / 6)
		
		if momzPull and mo and mo.valid
			if (mo.eflags & MFE_UNDERWATER)
				P_SetObjectMomZ(mo, momzPull/2, true)
			else
				P_SetObjectMomZ(mo, momzPull, true)
			end
		end

		if mo.player.fastfalling then
			P_SetObjectMomZ(mo, momzPull*2, true)
		end
	end

	// Final Smash Intro Timer
	if mo.fsTimer
		for p in players.iterate
			if not p.mo then return end

			if p.mo ~= mo and not p.spectator and not p.smashSpectate and not p.mo.tempSpectate and p.lives > 0 and p.playerstate ~= PST_DEAD
				s.removeMovement(p)
				p.mo.atkstop = mo.fsTimer
			end
		end

		mo.momx = 0
		mo.momy = 0
		mo.momz = 0
		mo.fsTimer = $-1

		mo.state = S_PLAY_SUPER_TRANS1
		if mo.fsTimer <= 0
			mo.fsTimer = nil
			mo.attacktype = "finalsmash"
			mo.atktimer = 0
		else
			return false
		end
	end
	
	// Final Smash invincibility
	if mo.attacktype and mo.attacktype == "finalsmash" then mo.hitcool = 3*TICRATE end

	// cant be bothered to fix it lol
	if mo.stun 
		mo.hitstun = mo.stun or 0
		mo.stun = nil
	end

	// Hit Stun
	if mo.hitstun 
		// Tech Inputs
		if mo.button.firenormal == 1 then mo.teched = 10 end
		
		if mo.teched
			mo.teched = $-1 
			if mo.teched <= 0 then mo.teched = nil end
		end
		
		if not mo.flingWait
			mo.hitstun = $-1
			
			if mo.justfling
				mo.justfling = $-1
				if mo.justfling <= 0 then mo.justfling = nil end
			end

			if not P_IsObjectOnGround(mo)
				mo.state = S_PLAY_PAIN
				mo.flags2 = $ & ~MF2_DONTDRAW

				if mo.launch
					local a = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SMOKE)
					a.scale = 2*FRACUNIT
					a.destscale = 5*FRACUNIT
					a.frame = FF_FULLBRIGHT|FF_TRANS30|A
				end
				
				if mo.player and mo.player.powers[pw_pushing]
					if mo.teched
						mo.hitstun = nil
						mo.tumble = nil
						mo.launch = nil
						mo.teched = nil
						mo.state = S_PLAY_FALL
						if mo.lastmomx then mo.momx = -(mo.lastmomx/10) end
						if mo.lastmomy then mo.momy = -(mo.lastmomy/10) end
					else
						if mo.lastmomx then mo.momx = -(mo.lastmomx/2) end
						if mo.lastmomy then mo.momy = -(mo.lastmomy/2) end
					end
				end

				if not (leveltime%4)
					mo.lastmomz = mo.momz
					mo.lastmomx = mo.momx
					mo.lastmomy = mo.momy
				end
			else
				-- Hitstun is way shorter on the floor (by 4 times)
				if mo.hitstun then mo.hitstun = $-4 end

				if mo.gotParried then
					if mo.state ~= S_PLAY_PARRIED then mo.state = S_PLAY_PARRIED end

					local ang, x, y, z, dizzy, ghoss
					for i = -1, 1 do
						ang = (leveltime%9)*ANG20
						x = mo.x + FixedMul(mo.radius, cos(ang))*i
						y = mo.y + FixedMul(mo.radius, sin(ang))*i
						z = mo.z + mo.height
						dizzy = P_SpawnMobj(x, y, z, MT_SMASH_DUMMY)
						if dizzy and dizzy.valid then
							dizzy.scale = FRACUNIT/3
							dizzy.sprite = SPR_NSTR
							dizzy.angle = ang
							dizzy.fuse = 2

							ghoss = P_SpawnGhostMobj(dizzy)
							ghoss.scale = FRACUNIT/6
						end
					end
				else
					mo.friction = FRACUNIT
	//				mo.flags = $|MF_BOUNCE
					mo.flags2 = $|MF2_DONTDRAW

					mo.dummy = P_SpawnMobj(mo.x, mo.y, mo.z + P_RandomRange(-20, 20)*FRACUNIT, MT_SMASH_DUMMY)
					mo.dummy.skin = mo.skin
					mo.dummy.angle = mo.angle
					mo.dummy.scale = mo.scale
					mo.dummy.color = mo.color
					mo.dummy.sprite = SPR_PLAY
					mo.dummy.sprite2 = SPR2_WALK
					mo.dummy.frame = FF_FULLBRIGHT|C
					mo.dummy.state = S_PLAY_WALK
					mo.dummy.fuse = 2

					if not S_SoundPlaying(mo, sfx_s3k7e) then S_StartSound(mo, sfx_s3k7e) end

					if not (leveltime%10)
						local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
						dust.destscale = 3*FRACUNIT
					end

					-- Tech
					if mo.lastmomz and mo.lastmomz < 10*FRACUNIT and mo.justfling
						P_TeleportMove(mo, mo.x, mo.y, mo.z+FRACUNIT)
						mo.momz = -(mo.lastmomz/2)

						if mo.teched
							mo.techInvinc = 20

							mo.tumble = nil
							mo.launch = nil
							mo.hitstun = nil
							mo.teched = nil

							mo.momz = 0
							mo.momx = 0
							mo.momy = 0
							return
						end
					end
				end
			end

			if mo.hitstun <= 0
				if mo.dummy and mo.dummy.valid
					P_RemoveMobj(mo.dummy)
					mo.dummy = nil
				end

				if not P_IsObjectOnGround(mo) and mo.launch then
					mo.tumble = true
					mo.launch = nil
				else
					mo.state = S_PLAY_STND
				end

				mo.friction = 29*FRACUNIT/32
//				mo.flags = $ & ~MF_BOUNCE
				mo.flags2 = $ & ~MF2_DONTDRAW
				mo.hitstun = nil
				mo.gotParried = nil
			end
		end
	end
	
	if mo.tumble
		mo.state = S_PLAY_PAIN

		if mo.player and mo.player.valid
			mo.player.drawangle = (leveltime%8)*ANGLE_45
			mo.player.pflags = $|PF_JUMPED & ~PF_SPINNING
			mo.noReuse = {}
		else
			mo.angle = (leveltime%8)*ANGLE_45
		end
		
		if P_IsObjectOnGround(mo)
			P_StartQuake(5*FRACUNIT, 5, {mo.x, mo.y, mo.z}, 200*FRACUNIT)
			for i = 1, 8
				local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPINDUST)
				P_InstaThrust(dust, i*ANG20, 10*FRACUNIT)
				
				dust.destscale = 2*FRACUNIT
			end
			
			mo.tumble = nil
			mo.state = S_PLAY_STND
			if mo.player and mo.player.valid
				mo.player.pflags = $ & ~PF_JUMPED & ~PF_SPINNING
			end
		end
	end

	// Growth
	if mo.growth
		mo.destscale = 2*FRACUNIT

		mo.growth = $-1
		if mo.growth <= 0
			mo.destscale = FRACUNIT
			mo.growth = nil
		end
	end
	
	// Fling
	if mo.atkstop then
		if mo.player.cmd.forwardmove < 0 and not mo.nofastfall then
			mo.player.fastfalling = true

			local star = P_SpawnMobj(mo.x, mo.y, mo.z-mo.height, MT_SUPERSPARK)
			star.color = mo.color
			star.colorized = true
		end

		if not mo.spdresume then
			mo.spdresume = {
				x = mo.momx,
				y = mo.momy,
				z = mo.momz,
				state = mo.state,
				sprite = mo.sprite,
				sprite2 = mo.sprite2 or nil,
				frame = mo.frame,
				tics = mo.tics,
				time = mo.atktimer
			}
		end

		mo.momx = 0
		mo.momy = 0
		mo.momz = 0
		mo.state = mo.spdresume.state
		mo.sprite = mo.spdresume.sprite
		if mo.spdresume.sprite2 then mo.sprite2 = mo.spdresume.sprite2 end
		mo.frame = mo.spdresume.frame
		mo.atktimer = mo.spdresume.time

		mo.atkstop = $-1
		if mo.atkstop <= 0 then
			mo.momx = mo.spdresume.x or 0
			mo.momy = mo.spdresume.y or 0
			mo.momz = mo.player.fastfalling and -10*FRACUNIT or (mo.spdresume.z or 0)
			mo.state = mo.spdresume.state or S_PLAY_FALL
			mo.tics = mo.spdresume.tics or 0
			mo.atktimer = mo.spdresume.time or 0

			mo.spdresume = nil
			mo.atkstop = nil
		end
	end

	if mo.flingWait then
		mo.state = S_PLAY_PAIN

		mo.momx = 0
		mo.momy = 0
		mo.momz = 0
		if mo.flingWait.time then mo.flingWait.time = $-1 end
		
		if mo.flingWait.hitbox and mo.flingWait.hitbox.valid
			if not mo.flingWait.hitbox.forceFuse then mo.flingWait.hitbox.forceFuse = mo.flingWait.hitbox.fuse end
			mo.flingWait.hitbox.fuse = mo.flingWait.hitbox.forceFuse
		end
		
		if mo.wasElec
			local electric = P_SpawnMobj(mo.x + P_RandomRange(-20, 20)*FRACUNIT, mo.y + P_RandomRange(-20, 20)*FRACUNIT, mo.z + P_RandomRange(-20, 20)*FRACUNIT, MT_THOK)
			electric.sprite = SPR_WZAP
			electric.frame = A
			electric.tics = 35
			electric.fuse = 35
			electric.scale = P_RandomRange(FRACUNIT, 2*FRACUNIT)
			electric.momx = P_RandomRange(-15, 15)*FRACUNIT
			electric.momy = P_RandomRange(-15, 15)*FRACUNIT
			electric.momz = P_RandomRange(-15, 15)*FRACUNIT
		end

		if not mo.flingWait.time or mo.flingWait.time <= 0			
			local ang = mo.flingWait.angle
			if mo.flingWait.hitbox and mo.flingWait.hitbox.valid
				ang = mo.flingWait.hitbox.angle
			end

			// DI - Maybe Later
			if ang < ANGLE_90 or ang < -ANGLE_90
				if mo.button.right > 0
					mo.flingWait.thrust = $+2*FRACUNIT
				elseif mo.button.left > 0
					mo.flingWait.thrust = $-2*FRACUNIT
				end
			else
				if mo.button.right > 0
					mo.flingWait.thrust = $-2*FRACUNIT
				elseif mo.button.left > 0
					mo.flingWait.thrust = $+2*FRACUNIT
				end
			end

			if mo.button.up > 0
				mo.flingWait.momz = $+2*FRACUNIT
			elseif mo.button.down > 0
				mo.flingWait.momz = $-2*FRACUNIT
			end

			// Fling
			P_TeleportMove(mo, mo.x, mo.y, mo.z + FRACUNIT)

			P_InstaThrust(mo, ang, mo.flingWait.thrust)
			P_SetObjectMomZ(mo, mo.flingWait.momz)
			
			mo.justfling = 15
			mo.flingWait = nil
			mo.wasElec = nil

			if mo.launch
				S_StartSound(mo, sfx_whoosh)
			end
		end
	end

	// FS Meter
	if cv_fsmeter.value
		mo.fsMeter = $ or 0
		if mo.fsMeter < 100 and not (leveltime%320)
			mo.fsMeter = $+1
			if mo.fsMeter > 100 then mo.fsMeter = 100 end
		end

		if mo.fsMeter >= 100 then s.getFinalSmash(mo) end
	end

	// Crouching and Parrying
	if mo.movespeed < 5*FRACUNIT and not mo.dodge and not mo.parry and P_IsObjectOnGround(mo) and not mo.doBlast and mo.attacktype ~= "finalsmash" and not mo.airDodge and not mo.parried and not mo.hitstun and not mo.flingWait
		mo.doBlast = nil
		if mo.button.firenormal == 1
			S_StartSound(mo, sfx_wirlsg)

			mo.parry = 35
			mo.shielding = nil
		elseif mo.button.down > 0
			mo.shielding = true
			mo.state = S_PLAY_CROUCH

			-- I WANT MY SWITCH CA SE
			if mo.button.left == 1
				S_StartSound(mo, sfx_s3ka6)
				s.dodgeRoll(mo, "left")
				mo.shielding = nil
			elseif mo.button.right == 1
				S_StartSound(mo, sfx_s3ka6)
				s.dodgeRoll(mo, "right")
				mo.shielding = nil
			elseif mo.button.jump == 1
				S_StartSound(mo, sfx_wirlsg)

				mo.parry = 35
				mo.shielding = nil
			end
		else
			mo.shielding = nil
		end
	else
		mo.shielding = nil
	end

	if mo.parry
		mo.parry = $-1
		if mo.doneParry
			mo.parry = nil
			return
		end

		if mo.player then mo.player.powers[pw_nocontrol] = mo.parry or 0 end

		mo.state = S_PLAY_CROUCH
		if mo.parry > 30
			mo.color = SKINCOLOR_GREY
			mo.colorized = true

			local ghost = P_SpawnGhostMobj(mo)
			ghost.color = SKINCOLOR_BLACK
			ghost.colorized = true
			ghost.destscale = 2*FRACUNIT
		else
			mo.color = mo.player and mo.player.skincolor or SKINCOLOR_GREEN
			mo.colorized = false
		end

		if mo.parry <= 0
			mo.parry = nil
			mo.state = S_PLAY_STND
		end
	end

	if mo.doneParry
		mo.state = S_PLAY_FALL
		mo.colorized = true
		mo.doneParry = $-1
		
		if mo.player then mo.player.powers[pw_nocontrol] = mo.doneParry end

		if mo.doneParry <= 0
			mo.doneParry = nil
			mo.colorized = false
			mo.state = S_PLAY_STND
		end
	end
	
	if mo.parried
		mo.atktimer = nil
		mo.attacktype = nil
		mo.state = S_PLAY_PAIN

		if mo.player then mo.player.powers[pw_nocontrol] = 20 end
		
		if mo.hitByParry
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
			mo.colorized = true

			mo.hitByParry = $-1
			if not mo.hitByParry
				mo.hitByParry = nil
				mo.colorized = false
			end
		else
			if P_IsObjectOnGround(mo)
				mo.hitstun = mo.parried
				mo.gotParried = true
				mo.parried = nil
				mo.parry = nil
			end
		end
	end

	// Air Dodging
	if mo.button.firenormal == 1 and not P_IsObjectOnGround(mo) and not mo.hitstun and not mo.parried and not mo.doneParry and not mo.attacktype and not mo.airDodged and not mo.airDodge
		mo.airDodge = 23
		mo.airDodged = true
		mo.player.fastfalling = false
		mo.tumble = nil
	end

	if mo.airDodge
		mo.airDodge = $-1
		if mo.airDodge == 15 then S_StartSound(mo, sfx_s3ka6) end

		if mo.airDodge > 15
			mo.state = S_PLAY_FALL
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
		elseif mo.airDodge > 5
			mo.colorized = true
			if not mo.airDodgeSpeed then mo.airDodgeSpeed = 14*FRACUNIT end
			
			if mo.airDodge <= 12
				if mo.airDodgeSpeed > FRACUNIT then mo.airDodgeSpeed = $-FRACUNIT end
			end
			
			if mo.button.left <= 0 and mo.button.right <= 0 and mo.button.up <= 0 and mo.button.down <= 0
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
			else
				if mo.button.left > 0
					P_InstaThrust(mo, ANGLE_180, mo.airDodgeSpeed)
					mo.momz = 0
				end
				if mo.button.right > 0
					P_InstaThrust(mo, 0, mo.airDodgeSpeed)
					mo.momz = 0
				end
				if mo.button.up > 0
					mo.momz = mo.airDodgeSpeed
				end
				if mo.button.down > 0
					mo.momz = -mo.airDodgeSpeed
				end
			end
		else
			mo.state = S_PLAY_FALL
			mo.colorized = false
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
			
			mo.airDodgeSpeed = nil
		end
		
		if mo.airDodge <= 0 or P_IsObjectOnGround(mo) 
			mo.colorized = false
			mo.airDodge = nil 
		end
	end
	
	// Blast Attacks
	-- boy do i love my if statements
	if mo.movespeed < 10*FRACUNIT and P_IsObjectOnGround(mo) and mo.button.spin > 0 and not mo.doBlast and not mo.shielding and not mo.dodge and not mo.parry and not mo.hitstun and not mo.parried and not mo.doneParry and not mo.attacktype and not mo.airDodge
		if not mo.blastTime then mo.blastTime = 8 end

		mo.blastTime = $-1
		if mo.blastTime <= 0
			mo.blastTime = nil
			mo.doBlast = true
		end
	else
		mo.blastTime = nil
	end

	if mo.doBlast
		mo.dodge = nil
		mo.parry = nil
		mo.shielding = nil

		mo.momx = 0
		mo.momy = 0
		mo.momz = 0
		mo.state = S_PLAY_EDGE
		mo.colorized = (leveltime%2) and true or false

		if mo.dodge or mo.parry or mo.hitstun or mo.parried or mo.doneParry
			mo.doBlast = nil
			mo.colorized = false
			return
		end

		if mo.button.spin <= 0
			mo.dodge = nil
			mo.parry = nil
			mo.doBlast = nil
			mo.shielding = nil
			mo.blastTime = nil
			mo.colorized = false

			if mo.button.up > 0
				if mo.player then s.staleCheck(mo.player, "upblast") end
				mo.attacktype = "upblast"
			elseif mo.button.down > 0
				if mo.player then s.staleCheck(mo.player, "downblast") end
				mo.attacktype = "downblast"
			else
				if mo.player then s.staleCheck(mo.player, "blast") end
				mo.attacktype = "blast"
			end

			mo.atktimer = 0
		end
	end

	// Dodging
	if mo.dodge
		if mo.player then mo.player.powers[pw_nocontrol] = mo.dodge.time+9 end

		mo.dodge.time = $-1
		P_InstaThrust(mo, mo.dodge.angle, 16*FRACUNIT)

		if mo.state ~= S_PLAY_ROLL
			mo.state = S_PLAY_ROLL
			if mo.dodge.time < 7 and mo.dodge.time > 3
				mo.colorized = true
			else
				mo.colorized = false
			end
		end

		if mo.dodge.time <= 0
			mo.state = S_PLAY_RUN
			mo.dodge = nil
			mo.colorized = false
		end
	end
	
	-- Fast Falling.
	if mo.fastfallcool then
		mo.fastfallcool = $-1
		if mo.fastfallcool <= 0 then mo.fastfallcool = nil end
	end

	if mo.player and not mo.fastfallcool and not mo.tumble and mo.button.down == 1 and mo.momz < 0 and not mo.player.fastfalling then
		mo.player.fastfalling = true

		local star = P_SpawnMobj(mo.x, mo.y, mo.z-mo.height, MT_SUPERSPARK)
		star.color = mo.color
		star.colorized = true
	end

	-- up special flashing
	if mo.noReuse and mo.noReuse["upspecial"]
		mo.colorized = (leveltime%2) and true or false
		if mo.player
			mo.color = (leveltime%2) and SKINCOLOR_GREY or mo.player.skincolor
		end
	end
	
	-- Tech invincibility
	if mo.techInvinc
		mo.techInvinc = $-1
		if mo.player then mo.player.powers[pw_nocontrol] = mo.techInvinc end
		
		if mo.techInvinc <= 15 and mo.techInvinc >= 5
			mo.state = S_PLAY_PAIN
			mo.angle = $+ANGLE_45

			mo.colorized = (leveltime%2) and true or false
			if mo.player
				mo.color = (leveltime%2) and SKINCOLOR_GREY or mo.player.skincolor
			end
		end
		
		if mo.techInvinc < 5
			mo.state = S_PLAY_STND
			mo.colorized = false
			if mo.player then mo.color = mo.player.skincolor end
		end
		
		if mo.techInvinc <= 0 then mo.techInvinc = nil end
	end
	
	// Penalties for Camping
	if not mo.lastHit then mo.lastHit = 0 end

	if mo.attacktype == "finalsmash"
		mo.lastHit = 0
	else
		mo.lastHit = $+1
	end

	if mo.lastHit >= 20*TICRATE
		mo.shield = nil

		if not (leveltime%30)
			if mo.smashRings > 0 then mo.smashRings = $-1 end
		end
	end
	
	// Status Effects
	if mo.statusEffect then s.statusEffects(mo) end

	-- Hit Effects
	if not mo.killed then s.hitEffects(mo) end
end

s.noHit = function(mo)
	if mo.techInvinc and mo.techInvinc >= 5 and mo.techInvinc <= 15 then return true end
	if mo.dodge and mo.dodge.time <= 8 and mo.dodge.time >= 3 then return true end
	if mo.airDodge and mo.airDodge <= 15 and mo.airDodge > 5 then return true end
	if mo.attacktype == "finalsmash" then return true end
	if mo.doneParry then return true end
	if mo.hitcool then return true end
	if mo.flingWait then return true end
	if mo.starKO then return true end
	if mo.screenKO then return true end
	
	if mo.player and mo.player.powers[pw_flashing] then return true end
	
	return false
end

s.noSpin = function(p)
	if s.chars[p.mo.skin]["jab1"]
		p.charability2 = CA2_NONE
		return true
	end
	
	return false
end

s.speedStats = {
	{18*FRACUNIT, 9*FRACUNIT, 28},
	{20*FRACUNIT, 10*FRACUNIT, 29},
	{22*FRACUNIT, 12*FRACUNIT, 30},
	{24*FRACUNIT, 14*FRACUNIT, 31},
	{26*FRACUNIT, 16*FRACUNIT, 32},
	{28*FRACUNIT, 18*FRACUNIT, 33},
	{30*FRACUNIT, 18*FRACUNIT, 34},
	{32*FRACUNIT, 19*FRACUNIT, 35},
	{34*FRACUNIT, 20*FRACUNIT, 36},
}

s.speedThinker = function(p)
	local speed = s.chars[p.mo.skin]["speed"] or 5

	local normalSpd = s.speedStats[speed][1]
	local jumpFactor = FRACUNIT+(FRACUNIT/10)
	if s.doRingBuff(p.mo) and p.mo.smashRings
		normalSpd = $+p.mo.smashRings*(FRACUNIT/6)
		jumpFactor = $+p.mo.smashRings*(FRACUNIT/100)
	end

	p.jumpfactor = jumpFactor
	p.normalspeed = normalSpd
	p.runspeed = s.speedStats[speed][2]
	p.acceleration = s.speedStats[speed][3]
end

s.doubleJump = function(p)
	if p.mo and p.mo.valid and not p.mo.doublejumped and not p.mo.noReuse["upspecial"]
		p.mo.tumble = nil

		if p.charability == CA_FLY
			s.flyAbility(p)
			return true
		end

		S_StartSound(p.mo, sfx_ngjump)
		P_SetObjectMomZ(p.mo, 9*FRACUNIT)

		p.mo.doublejumped = true
		p.mo.state = S_PLAY_SPRING

		return true
	end
end

s.flyFuck = function(p)
	if p.charability == CA_FLY and p.mo and p.mo.valid and not p.mo.noReuse["upspecial"]
		p.flyjumps = $ or 0
		p.mo.flying = $ or false
		if P_IsObjectOnGround(p.mo)
			if p.flyjumps < 2 then p.flyjumps = 2 end
			p.mo.flying = false
		else
			if p.mo.flying == true
				if p.flyjumps <= 0
					p.mo.state = S_PLAY_FLY_TIRED
				else
					p.mo.state = S_PLAY_FLY
				end

				p.pflags = $ & ~PF_SPINNING
				P_SetObjectMomZ(p.mo, -5*(gravity/6), true)
				if not S_SoundPlaying(p.mo, sfx_putput) then S_StartSound(p.mo, sfx_putput) end
			end
		end
		
		p.pflags = $ & ~PF_CANCARRY
		
		if (p.mo.state == S_PLAY_FLY or p.mo.state == S_PLAY_FLY_TIRED) 
		and not p.mo.flying and not p.mo.attacktype
			p.mo.flying = true
			p.flyjumps = p.mo.state == S_PLAY_FLY_TIRED and 0 or 2
		end

		if p.mo.attacktype// and s.chars[p.mo.skin]
		or p.mo.hitstun 
			p.mo.flying = false
		end
	end
end

s.flyAbility = function (p)
	if p.flyjumps > 0
		p.pflags = $ & ~PF_SPINNING
		p.mo.flying = true
		P_SetObjectMomZ(p.mo, 10*FRACUNIT)
		p.flyjumps = $-1
	end
	
	return true
end

s.dodgeRoll = function(mo, roll)
	local ang = {
		["left"] = ANGLE_180,
		["right"] = 0
	}

	mo.dodge = {
		time = 10,
		angle = ang[roll] or 0
	}
end