local s = SRB2Smash

s.hitEffectTable = {
	["punch"] = function(mo, flingx, flingy)
		for i = 1, 8
			local fire = P_SpawnMobj(mo.x + P_RandomRange(-20, 20)*FRACUNIT, mo.y + P_RandomRange(-20, 20)*FRACUNIT, mo.z + P_RandomRange(-20, 20)*FRACUNIT, MT_SPINDUST)
			fire.scale = P_RandomRange(FRACUNIT, 2*FRACUNIT)

			fire.momx = flingx + P_RandomRange(-10, 10)*FRACUNIT
			fire.momz = flingy + P_RandomRange(-10, 10)*FRACUNIT
		end
	end,

	["sweet"] = function(mo, flingx, flingy)
		for i = 1, 5
			local sparkle = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
			sparkle.sprite = SPR_HITS
			sparkle.color = mo.color
			sparkle.frame = FF_TRANS50|A
			sparkle.scale = 2*FRACUNIT
			sparkle.destscale = P_RandomRange(3, 7)*FRACUNIT
			sparkle.tics = 15
			sparkle.fuse = 40
		end

		for i = 1, 15
			local fire = P_SpawnMobj(mo.x + P_RandomRange(-20, 20)*FRACUNIT, mo.y + P_RandomRange(-20, 20)*FRACUNIT, mo.z + P_RandomRange(-20, 20)*FRACUNIT, MT_SPINDUST)
			fire.scale = P_RandomRange(FRACUNIT, 2*FRACUNIT)

			fire.momx = flingx + P_RandomRange(-10, 10)*FRACUNIT
			fire.momz = flingy + P_RandomRange(-10, 10)*FRACUNIT
		end
	end,

	["slash"] = function(mo, flingx, flingy)
		local possibleAngles = {mo.angle, mo.angle+ANGLE_180}
		local ang = possibleAngles[P_RandomRange(1, #possibleAngles)]
		local slash = P_SpawnMobj(mo.x - 15*cos(ang), mo.y - 15*sin(ang), mo.z, MT_SMASH_DUMMY)
		slash.scale = 2*FRACUNIT + (FRACUNIT/2)
		slash.angle = ang
		slash.state = S_SLASH_EFFECT1
	end,

	["sweet-slash"] = function(mo, flingx, flingy)
		for i = 1, 5
			local sparkle = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
			sparkle.sprite = SPR_HITS
			sparkle.color = mo.color
			sparkle.frame = FF_TRANS50|A
			sparkle.scale = 2*FRACUNIT
			sparkle.destscale = P_RandomRange(3, 7)*FRACUNIT
			sparkle.tics = 15
			sparkle.fuse = 40
		end

		local possibleAngles = {mo.angle, mo.angle+ANGLE_180}
		local ang = possibleAngles[P_RandomRange(1, #possibleAngles)]
		local slash = P_SpawnMobj(mo.x - 15*cos(ang), mo.y - 15*sin(ang), mo.z, MT_SMASH_DUMMY)
		slash.scale = 2*FRACUNIT + (FRACUNIT/2)
		slash.angle = ang
		slash.state = S_SLASH_EFFECT1
	end,
	
	["slash-sweet"] = function(mo, flingx, flingy)
		for i = 1, 5
			local sparkle = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
			sparkle.sprite = SPR_HITS
			sparkle.color = mo.color
			sparkle.frame = FF_TRANS50|A
			sparkle.scale = 2*FRACUNIT
			sparkle.destscale = P_RandomRange(3, 7)*FRACUNIT
		end

		local possibleAngles = {mo.angle, mo.angle+ANGLE_180}
		local ang = possibleAngles[P_RandomRange(1, #possibleAngles)]
		local slash = P_SpawnMobj(mo.x - 15*cos(ang), mo.y - 15*sin(ang), mo.z, MT_SMASH_DUMMY)
		slash.scale = 2*FRACUNIT + (FRACUNIT/2)
		slash.angle = ang
		slash.state = S_SLASH_EFFECT1
	end,

	["fire"] = function(mo, flingx, flingy)
		for i = 1, 8
			local fire = P_SpawnMobj(mo.x + P_RandomRange(-20, 20)*FRACUNIT, mo.y + P_RandomRange(-20, 20)*FRACUNIT, mo.z + P_RandomRange(-20, 20)*FRACUNIT, MT_THOK)
			fire.sprite = SPR_FPRT
			fire.frame = A
			fire.tics = 35
			fire.fuse = 35
			fire.scale = P_RandomRange(FRACUNIT, 2*FRACUNIT)
		
			fire.momx = flingx + P_RandomRange(-10, 10)*FRACUNIT
			fire.momz = flingy + P_RandomRange(-10, 10)*FRACUNIT
		end
	end,

	["sweet-fire"] = function(mo, flingx, flingy)
		for i = 1, 5
			local sparkle = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
			sparkle.sprite = SPR_HITS
			sparkle.color = mo.color
			sparkle.frame = FF_TRANS50|A
			sparkle.scale = 2*FRACUNIT
			sparkle.destscale = P_RandomRange(3, 7)*FRACUNIT
			sparkle.tics = 15
			sparkle.fuse = 40
		end
		
		for i = 1, 15
			local fire = P_SpawnMobj(mo.x + P_RandomRange(-20, 20)*FRACUNIT, mo.y + P_RandomRange(-20, 20)*FRACUNIT, mo.z + P_RandomRange(-20, 20)*FRACUNIT, MT_THOK)
			fire.sprite = SPR_FPRT
			fire.frame = A
			fire.tics = 35
			fire.fuse = 35
			fire.scale = P_RandomRange(FRACUNIT, 2*FRACUNIT)
		
			fire.momx = flingx + P_RandomRange(-10, 10)*FRACUNIT
			fire.momz = flingy + P_RandomRange(-10, 10)*FRACUNIT
		end
	end,

	["fire-sweet"] = function(mo, flingx, flingy)
		for i = 1, 5
			local sparkle = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
			sparkle.sprite = SPR_HITS
			sparkle.color = mo.color
			sparkle.frame = FF_TRANS50|A
			sparkle.scale = 2*FRACUNIT
			sparkle.destscale = P_RandomRange(3, 7)*FRACUNIT
			sparkle.tics = 15
			sparkle.fuse = 40
		end
		
		for i = 1, 15
			local fire = P_SpawnMobj(mo.x + P_RandomRange(-20, 20)*FRACUNIT, mo.y + P_RandomRange(-20, 20)*FRACUNIT, mo.z + P_RandomRange(-20, 20)*FRACUNIT, MT_THOK)
			fire.sprite = SPR_FPRT
			fire.frame = A
			fire.tics = 35
			fire.fuse = 35
			fire.scale = P_RandomRange(FRACUNIT, 2*FRACUNIT)
		
			fire.momx = flingx + P_RandomRange(-10, 10)*FRACUNIT
			fire.momz = flingy + P_RandomRange(-10, 10)*FRACUNIT
		end
	end,

	["elec"] = function(mo, flingx, flingy)
		for i = 1, 8
			local fire = P_SpawnMobj(mo.x + P_RandomRange(-20, 20)*FRACUNIT, mo.y + P_RandomRange(-20, 20)*FRACUNIT, mo.z + P_RandomRange(-20, 20)*FRACUNIT, MT_THOK)
			fire.sprite = SPR_WZAP
			fire.frame = A
			fire.tics = 35
			fire.fuse = 35
			fire.scale = P_RandomRange(FRACUNIT, 2*FRACUNIT)
		
			fire.momx = flingx + P_RandomRange(-10, 10)*FRACUNIT
			fire.momz = flingy + P_RandomRange(-10, 10)*FRACUNIT
		end
	end,

	["sweet-elec"] = function(mo, flingx, flingy)
		for i = 1, 5
			local sparkle = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
			sparkle.sprite = SPR_HITS
			sparkle.color = mo.color
			sparkle.frame = FF_TRANS50|A
			sparkle.scale = 2*FRACUNIT
			sparkle.destscale = P_RandomRange(3, 7)*FRACUNIT
			sparkle.tics = 15
			sparkle.fuse = 40
		end
		
		for i = 1, 15
			local fire = P_SpawnMobj(mo.x + P_RandomRange(-20, 20)*FRACUNIT, mo.y + P_RandomRange(-20, 20)*FRACUNIT, mo.z + P_RandomRange(-20, 20)*FRACUNIT, MT_THOK)
			fire.sprite = SPR_WZAP
			fire.frame = A
			fire.tics = 35
			fire.fuse = 35
			fire.scale = P_RandomRange(FRACUNIT, 2*FRACUNIT)
		
			fire.momx = flingx + P_RandomRange(-10, 10)*FRACUNIT
			fire.momz = flingy + P_RandomRange(-10, 10)*FRACUNIT
		end
	end,

	["elec-sweet"] = function(mo, flingx, flingy)
		for i = 1, 5
			local sparkle = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
			sparkle.sprite = SPR_HITS
			sparkle.color = mo.color
			sparkle.frame = FF_TRANS50|A
			sparkle.scale = 2*FRACUNIT
			sparkle.destscale = P_RandomRange(3, 7)*FRACUNIT
			sparkle.tics = 15
			sparkle.fuse = 40
		end
		
		for i = 1, 15
			local fire = P_SpawnMobj(mo.x + P_RandomRange(-20, 20)*FRACUNIT, mo.y + P_RandomRange(-20, 20)*FRACUNIT, mo.z + P_RandomRange(-20, 20)*FRACUNIT, MT_THOK)
			fire.sprite = SPR_WZAP
			fire.frame = A
			fire.tics = 35
			fire.fuse = 35
			fire.scale = P_RandomRange(FRACUNIT, 2*FRACUNIT)
		
			fire.momx = flingx + P_RandomRange(-10, 10)*FRACUNIT
			fire.momz = flingy + P_RandomRange(-10, 10)*FRACUNIT
		end
	end,
}

s.statusEffects = function(mo)
	if not mo.statusEffect then return end
	
	if mo.statusEffect[1] == EFF_BURN
		for i = 1, 2
			local steam = P_SpawnMobj(mo.x+P_RandomRange(-45, 45)*FRACUNIT, mo.y+P_RandomRange(-45, 45)*FRACUNIT, mo.z+P_RandomRange(0, 30)*FRACUNIT, MT_SMOKE)
			P_SetObjectMomZ(steam, P_RandomRange(1, 3)*FRACUNIT)
		end
		
		local fire = P_SpawnMobj(mo.x+P_RandomRange(-45, 45)*FRACUNIT, mo.y+P_RandomRange(-45, 45)*FRACUNIT, mo.z+P_RandomRange(0, 30)*FRACUNIT, MT_THOK)
		fire.scale = P_RandomRange(2, 7)*P_RandomRange(FRACUNIT/2, FRACUNIT)
		fire.sprite = SPR_FPRT

		P_SetObjectMomZ(fire, P_RandomRange(1, 3)*FRACUNIT)

		if s.usesPercent()
			if not (leveltime%13)
				mo.percent = $+1
			end
		else
			if not (leveltime%35)
				mo.stamina = $-1
				if mo.stamina <= 0 then s.killMobj(mo) end
			end
		end
	elseif mo.statusEffect[1] == EFF_FREEZE
		mo.colorized = true
		if mo.player then mo.player.powers[pw_nocontrol] = mo.statusEffect[2] end
	end
	
	mo.statusEffect[2] = $-1
	if mo.statusEffect[2] <= 0 
		mo.colorized = false
		mo.statusEffect = nil 
	end
end

s.hitEffects = function(mo)
	if not mo.hitEffect then return end

	if mo.hitEffect[1] == "fire"
		for i = 1, 2
			local steam = P_SpawnMobj(mo.x+P_RandomRange(-45, 45)*FRACUNIT, mo.y+P_RandomRange(-45, 45)*FRACUNIT, mo.z+P_RandomRange(0, 30)*FRACUNIT, MT_SMOKE)
			P_SetObjectMomZ(steam, P_RandomRange(1, 3)*FRACUNIT)
		end
	end

	mo.hitEffect[2] = $-1
	if mo.hitEffect[2] <= 0
		mo.hitEffect = nil
		return true
	end
end