local s = SRB2Smash

///////////////////
// Player Inputs //
///////////////////

s.initPlayer = function(p)
	if p.smashSpectate then return end
	if p.mo.tempSpectate then return end

	if p and p.valid
		p.hitbox = $ or {}

		p.specialBtn = $ or "fire"
		p.smashPoints = $ or 0
		p.smashStocks = $ or 3
		
		p.hudshit = $ or {
			["+1"] = 0,
			["-1"] = 0,
			["hit"] = 0,
			["randhudx"] = 0,
			["randhudy"] = 0
		}
		
		p.finalScoreStuff = $ or {
			maxcombo = 0,
			ringtotal = 0,
			totaldmgdealt = 0,
			totaldmgtaken = 0,
			parries = 0,
			attackshit = 0,
			attacksdone = 0
		}

		if p.mo and p.mo.valid
			p.mo.color = s.isTeam() and _G["SKINCOLOR_"..p.team:upper()] or p.skincolor

			p.mo.button = $ or {
				jump = 0,
				spin = 0,
				down = 0,
				up = 0,
				left = 0,
				right = 0,
				attack = 0,
				custom1 = 0,
				custom2 = 0,
				custom3 = 0,
				tossflag = 0,
			}

			p.mo.weight = s.chars[p.mo.skin]["weight"] or 5
			p.mo.priority = $ or 0
			p.mo.percent = $ or cv_startpercent.value
			p.mo.stamina = $ or cv_starthp.value
			p.mo.smashRings = $ or cv_startrings.value
			p.mo.hitcool = $ or 0
			p.mo.itemdata = $ or {}
			p.mo.notgrounded = $ or nil
			p.mo.noReuse = $ or {}
			p.mo.staleMove = $ or {"jab", 0}
			p.mo.fsMeter = $ or 0
			p.mo.finalsmash = $ or false
			p.mo.curItem = $ or "none"
			p.mo.lastHit = $ or 0
		end
	end
end

-- Register Button Inputs: Taps & Holds
local function doTap(p, input)
	if not _G["BT_"..input:upper()] then return end

	if p.mo.tap[input] == true then p.mo.tap[input] = false end

	if not (p.cmd.buttons & _G["BT_"..input:upper()]) 
	and (p.mo.button[input] > 0 and p.mo.button[input] <= 5)
		p.mo.tap[input] = true
	end
end

local function doHold(p, input)
	if not _G["BT_"..input:upper()] then return end

	if (p.cmd.buttons & _G["BT_"..input:upper()])
		p.mo.button[input] = $+1
	else
		p.mo.button[input] = 0
	end
end

local function inputReg(p, input)
	if not p.mo.button then p.mo.button = {} end
	if not p.mo.tap then p.mo.tap = {} end
	if not p.mo.button[input] then p.mo.button[input] = 0 end
	if not p.mo.tap[input] then p.mo.tap[input] = false end
	
	doTap(p, input)
	doHold(p, input)
end

local function CalcMovement(p, direction, check1, check2)
	if p.mo.tap[direction] == true then p.mo.tap[direction] = false end
	if check1 and (p.mo.button[direction] > 0 and p.mo.button[direction] <= 5)
		p.mo.tap[direction] = true
	end
	p.mo.button[direction] = (check2 and $ + 1) or 0
end

s.inputRegister = function(p)
	if p and p.valid and p.mo and p.mo.valid
		p.mo.button = $ or {
			jump = 0,
			spin = 0,
			down = 0,
			up = 0,
			left = 0,
			right = 0,
			attack = 0,
			firenormal = 0,
			custom1 = 0,
			custom2 = 0,
			custom3 = 0,
			tossflag = 0,
		}

		p.mo.tap = $ or {
			jump = false,
			spin = false,
			down = false,
			up = false,
			left = false,
			right = false,
			attack = false,
			firenormal = false,
			custom1 = false,
			custom2 = false,
			custom3 = false,
			tossflag = false,
		}

		inputReg(p, "jump")
		inputReg(p, "spin")
		inputReg(p, "tossflag")
		inputReg(p, "attack")
		inputReg(p, "firenormal")
		for i = 1, 3 do inputReg(p, "custom"..i) end
		CalcMovement(p, "down", p.cmd.forwardmove >= 0, p.cmd.forwardmove < 0)
		CalcMovement(p, "up", p.cmd.forwardmove <= 0, p.cmd.forwardmove > 0)
		CalcMovement(p, "left", (p.cmd.buttons & BT_CAMLEFT) or (p.cmd.sidemove < 0), (p.cmd.buttons & BT_CAMLEFT) or (p.cmd.sidemove < 0))
		CalcMovement(p, "right", (p.cmd.buttons & BT_CAMRIGHT) or (p.cmd.sidemove > 0), (p.cmd.buttons & BT_CAMRIGHT) or (p.cmd.sidemove > 0))
	end
end

-- fuck y ouR MOVEMENT YOU LITTE!111
s.fuckYourMovement = function(p)
	p.cmd.forwardmove = 0
	p.cmd.sidemove = 0

	p.cmd.buttons = $ & ~BT_JUMP
end

s.removeMovement = function (p)
	p.mo.button = {
		jump = 0,
		spin = 0,
		down = 0,
		up = 0,
		left = 0,
		right = 0,
		custom1 = 0,
		custom2 = 0,
		custom3 = 0,
		tossflag = 0,
	}

	p.powers[pw_nocontrol] = 1
	s.fuckYourMovement(p)
end

////////////////
// Bot Inputs //
////////////////

s.botButtons = function(mo)
	mo.button = $ or {
		jump = 0,
		spin = 0,
		down = 0,
		up = 0,
		left = 0,
		right = 0,
		custom1 = 0,
		custom2 = 0,
		custom3 = 0,
		tossflag = 0,
	}

	mo.tap = $ or {
		jump = false,
		spin = false,
		down = false,
		up = false,
		left = false,
		right = false,
		custom1 = false,
		custom2 = false,
		custom3 = false,
		tossflag = false,
	}

	mo.taprelease = $ or {
		jump = 0,
		spin = 0,
		down = 0,
		up = 0,
		left = 0,
		right = 0,
		custom1 = 0,
		custom2 = 0,
		custom3 = 0,
		tossflag = 0,
	}

	for i in pairs(mo.button)
		if mo.button[i] and mo.button[i] > 0
			mo.button[i] = $-1
		end
	end

	for i in pairs(mo.tap)
		if mo.tap[i]
			if mo.taprelease[i] > 0
				mo.taprelease[i] = $-1
			else
				mo.tap[i] = false
			end
		end
	end
end

s.pressButton = function(mo, buttonString)
	if mo.button[buttonString]
		mo.button[buttonString] = 10
	end
end

s.tapButton = function(mo, tapString)
	if mo.tap[buttonString]
		mo.tap[buttonString] = true
		mo.taprelease[buttonString] = 5
	end
end

///////////
// Stats //
///////////

s.invWeight = function(mo)
	return 10 - (mo.weight or 1)
end

////////////////
// Spectating //
///////////////
s.spectate = function(mo)
	if mo and mo.player
		mo.player.smashSpectate = true
	else
		mo.tempSpectate = true
	end
end

s.isSpectator = function(p)
	if p and p.valid and p.smashSpectate then return true end
	if p.mo and p.mo.valid and p.mo.tempSpectate then return true end
	return false
end

////////////
// Points //
////////////
s.gainPoint = function(p)
	if s.isTeam()
		if s.teamData[p.team]
			for k,v in ipairs(s.teamData[p.team])
				if not v.smashPoints
					v.smashPoints = 1
				else
					v.smashPoints = $+1
				end

				v.hudshit["-1"] = 0
				v.hudshit["+1"] = 60
			end
		end
		
		if not s.pointData[p.team]
			s.pointData[p.team] = 1
		else
			s.pointData[p.team] = $+1
		end
	else
		if not p.smashPoints
			p.smashPoints = 1
		else
			p.smashPoints = $+1
		end

		p.hudshit["-1"] = 0
		p.hudshit["+1"] = 60
	end
end

s.losePoint = function(p)
	if s.isTeam()
		if s.teamData[p.team]
			for k,v in ipairs(s.teamData[p.team])
				if not v.smashPoints
					v.smashPoints = -1
				else
					v.smashPoints = $-1
				end

				v.hudshit["-1"] = 60
				v.hudshit["+1"] = 0
			end
		end

		if not s.pointData[p.team]
			s.pointData[p.team] = -1
		else
			s.pointData[p.team] = $-1
		end
	else
		if not p.smashPoints
			p.smashPoints = -1
		else
			p.smashPoints = $-1
		end

		p.hudshit["-1"] = 60
		p.hudshit["+1"] = 0
	end
end

/*
	DEATH COOLDOWN
*/

s.handleDieCooldown = function(mo)
	if not mo.dieCool then return end
	
	mo.dieCool = $-1
	if mo.dieCool <= 0 then mo.dieCool = nil end
end