local s = SRB2Smash

s.blastZoneHit = function(p, infp, mo, staminaAnim)
	if p.mo.killed then return end
	if p.killedBlast then return end
	if p.playerstate == PST_DEAD then return end

	if p and p.mo and p.mo.valid
		s.losePoint(p)
		if infp then s.gainPoint(infp) end

		p.hudshit["hit"] = 35
		p.pflags = $ & ~PF_JUMPED & ~PF_SPINNING

		p.mo.attacktype = "none"
		p.mo.atktimer = 0
		p.mo.flying = false
		p.mo.parried = nil
		p.mo.parry = nil
		p.mo.doneParry = nil
		p.mo.tumble = nil
		p.mo.noReuse = {}
		p.mo.notgrounded = nil
		p.mo.flags = $ & ~MF_NOGRAVITY & ~MF_FLOAT
		p.mo.dieCool = 10

		P_StartQuake(50*FRACUNIT, 10)
		for p in players.iterate S_StartSound(nil, sfx_sdeath, p) end

		p.mo.killed = 2*TICRATE
		p.killedBlast = {
			x = p.mo.x,
			y = p.mo.y,
			z = p.mo.z,
			time = 35,
			type = "up",
			angle = 0,
		}

		if staminaAnim
			p.killedBlast.type = "stamina"
		else
			if mo and mo.valid
				if mo.type == MT_UPBLAST
					p.killedBlast.type = "down"
					P_TeleportMove(p.mo, p.mo.x, p.mo.y, p.mo.z-50*FRACUNIT)
				elseif mo.type == MT_SIDEBLAST
					p.killedBlast.type = "side"
					p.killedBlast.angle = mo.angle
					P_TeleportMove(p.mo, p.mo.x+100*cos(mo.angle), p.mo.y+100*sin(mo.angle), p.mo.z)
				else
					p.killedBlast.type = "up"
					P_TeleportMove(p.mo, p.mo.x, p.mo.y, p.mo.z+50*FRACUNIT)
				end
			end
		end
	end
end

s.killedBlast = function(p)
	if p.killedBlast
		local bz = p.killedBlast
		p.powers[pw_nocontrol] = bz.time

		bz.time = $-1
		if bz.type == "stamina"
			for i = 1, 2
				local thok = P_SpawnMobj(bz.x, bz.y, bz.z, MT_THOK)
				thok.color = SKINCOLOR_WHITE
				thok.scale = 2*FRACUNIT
				thok.frame = FF_FULLBRIGHT|A
				thok.fuse = -1
				thok.tics = 20
				thok.momx = P_RandomRange(-40, 40)*FRACUNIT
				thok.momy = P_RandomRange(-40, 40)*FRACUNIT
				thok.momz = P_RandomRange(-40, 40)*FRACUNIT
			end
			
			for i = 1, 5
				local thok = P_SpawnMobj(bz.x, bz.y, bz.z, MT_THOK)
				thok.sprite = SPR_HITS
				thok.color = p.skincolor
				thok.scale = 2*FRACUNIT
				thok.frame = FF_FULLBRIGHT|A
				thok.fuse = -1
				thok.tics = 40
				thok.momx = P_RandomRange(-40, 40)*FRACUNIT
				thok.momy = P_RandomRange(-40, 40)*FRACUNIT
				thok.momz = P_RandomRange(-40, 40)*FRACUNIT
			end

			if not (bz.time%2)
				local ring = P_SpawnMobj(x, bz.y, z, MT_SMASH_RING)
				ring.momx = P_RandomRange(-10, 10)*FRACUNIT
				ring.momy = P_RandomRange(-10, 10)*FRACUNIT
				ring.momz = P_RandomRange(-10, 10)*FRACUNIT
			end

			if not p.mo.deathMobj or not p.mo.deathMobj.valid
				local mo = P_SpawnMobj(bz.x, bz.y, bz.z, MT_SMASH_DUMMY)
				mo.color = p.skincolor
				mo.skin = (p.mo and p.mo.valid) and p.mo.skin or "sonic"
				mo.state = S_PLAY_DEAD
				mo.fuse = 3*TICRATE
				mo.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
				p.mo.deathMobj = mo
				
				mo.deathMomz = 10*FRACUNIT
			else
				local mo = p.mo.deathMobj
				mo.momz = mo.deathMomz
				
				mo.deathMomz = $-FRACUNIT
			end
		elseif bz.type == "side"
			local ang = bz.angle or 0
			local x, y, z = bz.x + P_RandomRange(-128, 128)*FRACUNIT, bz.y + P_RandomRange(-128, 128)*FRACUNIT, bz.z + P_RandomRange(-128, 128)*FRACUNIT

			for i = 1, 2
				local thok = P_SpawnMobj(bz.x, bz.y, bz.z, MT_THOK)
				thok.color = SKINCOLOR_WHITE
				thok.scale = 2*FRACUNIT
				thok.frame = FF_FULLBRIGHT|A
				thok.fuse = -1
				thok.tics = 20
				P_InstaThrust(thok, ang, P_RandomRange(100, 150)*FRACUNIT)
			end
			
			for i = 1, 5
				local thok = P_SpawnMobj(x, y, z, MT_THOK)
				thok.sprite = SPR_HITS
				thok.color = p.skincolor
				thok.scale = 2*FRACUNIT
				thok.frame = FF_FULLBRIGHT|A
				thok.fuse = -1
				thok.tics = 40
				P_InstaThrust(thok, ang, P_RandomRange(50, 150)*FRACUNIT)
			end

			if not (bz.time%2)
				local ring = P_SpawnMobj(x, bz.y, z, MT_SMASH_RING)
				P_InstaThrust(ring, ang, P_RandomRange(30, 60)*FRACUNIT)
			end
		elseif bz.type == "down"
			local x, y = bz.x + P_RandomRange(-128, 128)*FRACUNIT, bz.y + P_RandomRange(-128, 128)*FRACUNIT

			for i = 1, 2
				local thok = P_SpawnMobj(bz.x, bz.y, bz.z, MT_THOK)
				thok.momz = P_RandomRange(-50, -200)*FRACUNIT
				thok.color = SKINCOLOR_WHITE
				thok.scale = 2*FRACUNIT
				thok.frame = FF_FULLBRIGHT|A
				thok.fuse = -1
				thok.tics = 20
			end

			for i = 1, 5
				local thok = P_SpawnMobj(x, y, bz.z, MT_THOK)
				thok.momz = P_RandomRange(-50, -200)*FRACUNIT
				thok.sprite = SPR_HITS
				thok.color = p.skincolor
				thok.frame = FF_FULLBRIGHT|A
				thok.scale = 2*FRACUNIT
				thok.fuse = -1
				thok.tics = 40
			end

			if not (bz.time%2)
				local ring = P_SpawnMobj(x, bz.y, z, MT_SMASH_RING)
				ring.momz = P_RandomRange(-30, -70)*FRACUNIT
				ring.momx = P_RandomRange(-15, 15)*FRACUNIT
			end
		else
			local x, y = bz.x + P_RandomRange(-128, 128)*FRACUNIT, bz.y + P_RandomRange(-128, 128)*FRACUNIT
			
			for i = 1, 2
				local thok = P_SpawnMobj(bz.x, bz.y, bz.z, MT_THOK)
				thok.momz = P_RandomRange(50, 200)*FRACUNIT
				thok.color = SKINCOLOR_WHITE
				thok.scale = 2*FRACUNIT
				thok.frame = FF_FULLBRIGHT|A
				thok.fuse = -1
				thok.tics = 20
			end

			for i = 1, 5
				local thok = P_SpawnMobj(x, y, bz.z, MT_THOK)
				thok.momz = P_RandomRange(50, 200)*FRACUNIT
				thok.sprite = SPR_HITS
				thok.color = p.skincolor
				thok.frame = FF_FULLBRIGHT|A
				thok.scale = 2*FRACUNIT
				thok.fuse = -1
				thok.tics = 40
			end

			if not (bz.time%2)
				local ring = P_SpawnMobj(x, bz.y, z, MT_SMASH_RING)
				ring.momz = P_RandomRange(70, 100)*FRACUNIT
				ring.momx = P_RandomRange(-15, 15)*FRACUNIT
			end
		end

		if bz.time <= 0 then p.killedBlast = nil end
	end
end

s.blastZoneEff = function(mo)
	if mo.killed
		mo.killed = $-1
		mo.momx = 0
		mo.momy = 0
		mo.momz = 0
		mo.attacktype = nil
		mo.atktimer = nil
		mo.state = S_INVISIBLE

		if mo.killed <= 10
			if mo.player and mo.player.valid
				/*
				local centerpoint
				for mobj in mobjs.iterate()
					if mobj.type == MT_CENTERPOINT
						centerpoint = mobj
					end
				end
				*/

				if mo.player.lives <= 1
					mo.player.playerstate = PST_DEAD
					mo.player.lives = 0
				else
					mo.player.playerstate = PST_REBORN

					/*
					if mo.player.lives <= 1
						P_KillMobj(mo)
					else
					*/
						mo.player.lives = $-1
--					end
				end

				mo.player.killedBlast = nil
			end

			mo.killed = nil
		end
	end
end