local s = SRB2Smash

s.spawnSmashBall = function(type)
	if type == 1 -- just smash ball
		local possiblePlayers = {}
		for p in players.iterate
			if p.mo and p.mo.valid and not p.smashSpectate and not p.mo.tempSpectate
				table.insert(possiblePlayers, p.mo)
			end
		end

		local mo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
		local x = mo.x + P_RandomRange(-60, 60)*FRACUNIT
		local smashBall = P_SpawnMobj(x, mo.y, mo.z + 400*FRACUNIT, MT_SMASHBALL)
		smashBall.fuse = 45*TICRATE
	else -- real and fake
		local possiblePlayers = {}
		for p in players.iterate
			if p.mo and p.mo.valid and not p.smashSpectate and not p.mo.tempSpectate
				table.insert(possiblePlayers, p.mo)
			end
		end

		local mo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
		local x = mo.x + P_RandomRange(-60, 60)*FRACUNIT
		local smashBall = P_SpawnMobj(x, mo.y, mo.z + 400*FRACUNIT, MT_SMASHBALL)
		smashBall.fuse = 45*TICRATE

		mo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
		x = mo.x + P_RandomRange(-60, 60)*FRACUNIT
		smashBall = P_SpawnMobj(x, mo.y, mo.z + 400*FRACUNIT, MT_SMASHBALL_FAKE)
		smashBall.fuse = 30*TICRATE
	end
	
	return true
end

s.respawnSmashBall = function(mo)
	local possiblePlayers = {}
	for p in players.iterate
		if p.mo and p.mo.valid and not p.smashSpectate and not p.mo.tempSpectate
			table.insert(possiblePlayers, p.mo)
		end
	end

	local pmo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
	local x = pmo.x + P_RandomRange(-60, 60)*FRACUNIT
	
	P_TeleportMove(mo, x, pmo.y, mo.ceilingz - 100*FRACUNIT)
end

/* 
	Flame helped me with the funnye lighting
	it cool
*/

s.resetFsLighting = function()
	server.oldFsLighting = {}
	for sector in sectors.iterate
		if sector
			server.oldFsLighting[#sector] = sector.lightlevel
		end
	end
end

s.fsLighting = function()
	if (leveltime > 3*TICRATE)
		local smashFighters = {}
		for p in players.iterate
			if not p.spectator and not p.smashSpectate and not p.mo.tempSpectate
			and p.lives > 0 and p.playerstate ~= PST_DEAD
				table.insert(smashFighters, p.mo)
			end
		end

		if not server.oldFsLighting
			server.oldFsLighting = $ or {}
			for sector in sectors.iterate
				server.oldFsLighting[#sector] = sector.lightlevel
			end
		end

		local finalSmash = false
		for i,mo in ipairs(smashFighters)
			if mo.finalsmash
				finalSmash = true
				
				local spark = P_SpawnMobj(mo.x + P_RandomRange(-100, 100)*FRACUNIT, mo.y + P_RandomRange(-100, 100)*FRACUNIT, mo.z, MT_BOXSPARKLE)
				spark.momz = P_RandomRange(1, 10)*FRACUNIT
				spark.frame = FF_FULLBRIGHT|$
				
				mo.frame = FF_FULLBRIGHT|$
			end
		end
		
		if finalSmash == true		
			for sector in sectors.iterate
				sector.lightlevel = max(160, $-3)
			end
		else
			for sector in sectors.iterate
				if server.oldFsLighting[#sector]
					sector.lightlevel = min(server.oldFsLighting[#sector], $+3)
				end
			end
		end
	end
end

-- Smash Ball Thinkers
s.smashBallThinker = function(mo)
	if mo and mo.valid
		mo.scale = 3*FRACUNIT/2
		mo.smashHp = $ or 5

		if mo.hitCool
			mo.hitCool = $-1
			if mo.hitCool <= 0 then mo.hitCool = nil end
		end

		if mo.thrustShit
			mo.thrustShit.time = $-1
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
			
			if mo.thrustShit.time <= 0
				P_SetObjectMomZ(mo, mo.thrustShit.momz)
				P_InstaThrust(mo, mo.thrustShit.angle, mo.thrustShit.thrust)
				mo.thrustShit = nil
			end
			
			return
		end

		if mo.fakeexplode
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
			mo.fakeexplode = $-1
			if mo.fakeexplode <= 0
				local thok = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
				thok.color = mo.color
				thok.colorized = true
				thok.flags2 = $|MF2_DONTDRAW
				thok.state = S_FBOMB_EXPL2

				local hitbox = s.drawGhostHitBox(mo.x, mo.y, mo.z-(mo.height/2), mo.radius*6,
				mo.height*4, 40, 3, nil, nil, true, sfx_s3k49, "punch")
				hitbox.fuse = 15
				hitbox.usermo = mo

				P_RemoveMobj(mo)
			end
			
			return
		end

		if mo.realexplode
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
			mo.realexplode.time = $-1
			if mo.realexplode.time <= 0
				local thok = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
				thok.color = mo.color
				thok.colorized = true
				thok.flags2 = $|MF2_DONTDRAW
				thok.state = S_FBOMB_EXPL2

				s.getFinalSmash(mo.realexplode.inf)
				P_RemoveMobj(mo)
			end
			
			return
		end

		if not (leveltime%100)
			mo.targVals = nil
		end
		
		if not mo.targVals
			local smashFighters = {}
			for p in players.iterate
				if not p.spectator and not p.smashSpectate and not p.mo.tempSpectate
				and p.lives > 0 and p.playerstate ~= PST_DEAD
					table.insert(smashFighters, p.mo)
				end
			end

			local centerX, centerY, centerZ = 0, 0, 0
			for i = 1, #smashFighters
				if smashFighters[i] and smashFighters[i].valid
					centerX = $ + smashFighters[i].x/FRACUNIT
					centerY = $ + smashFighters[i].y/FRACUNIT
					centerZ = $ + smashFighters[i].z/FRACUNIT
				end
			end

			centerX = ($/#smashFighters)*FRACUNIT
			centerY = ($/#smashFighters)*FRACUNIT
			centerZ = ($/#smashFighters)*FRACUNIT
			
			mo.targVals = {
				x = centerX,
				y = centerY,
				z = centerZ
			}
		end

		if mo.x > mo.targVals.x
			if mo.momx > -10*FRACUNIT
				mo.momx = $-FRACUNIT/10
			end
		elseif mo.x < mo.targVals.x
			if mo.momx < 10*FRACUNIT
				mo.momx = $+FRACUNIT/10
			end
		end

		if mo.z > mo.targVals.z
			if mo.momz > -10*FRACUNIT
				mo.momz = $-FRACUNIT/10
			end
		elseif mo.z < mo.targVals.z
			if mo.momz < 10*FRACUNIT
				mo.momz = $+FRACUNIT/10
			end
		end

		mo.color = SKINCOLOR_SMASHBALL
	end
end

s.smashBallGrounded = function(mo)
	if mo and mo.valid
		mo.scale = 3*FRACUNIT/2
		mo.smashHp = $ or 5

		if mo.hitCool
			mo.hitCool = $-1
			if mo.hitCool <= 0
				mo.hitCool = nil
			end
		end

		if mo.thrustShit
			mo.thrustShit.time = $-1
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
			
			if mo.thrustShit.time <= 0
				P_SetObjectMomZ(mo, mo.thrustShit.momz)
				P_InstaThrust(mo, mo.thrustShit.angle, mo.thrustShit.thrust)
				mo.thrustShit = nil
			end
			
			return
		end

		if mo.fakeexplode
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
			mo.fakeexplode = $-1
			if mo.fakeexplode <= 0
				local thok = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
				thok.color = mo.color
				thok.colorized = true
				thok.flags2 = $|MF2_DONTDRAW
				thok.state = S_FBOMB_EXPL2

				local hitbox = s.drawGhostHitBox(mo.x, mo.y, mo.z-(mo.height/2), mo.radius*4,
				mo.height*3, 40, 3, nil, nil, true, sfx_fire4, "fire")
				hitbox.fuse = 15
				hitbox.usermo = mo

				P_RemoveMobj(mo)
			end
			
			return
		end

		if mo.realexplode
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
			mo.realexplode.time = $-1
			if mo.realexplode.time <= 0
				local thok = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
				thok.color = mo.color
				thok.colorized = true
				thok.flags2 = $|MF2_DONTDRAW
				thok.state = S_FBOMB_EXPL2

				s.getFinalSmash(mo.realexplode.inf)
				P_RemoveMobj(mo)
			end
			
			return
		end

		if not P_IsObjectOnGround(mo)
			mo.momz = $-2*FRACUNIT
			mo.rollangle = $+ANG2
		end
		
		if mo.momx > 0 or mo.momy > 0 then mo.rollangle = $+ANG2 end
		mo.color = SKINCOLOR_SMASHBALL
	end
end

s.smashBallDamage = function(mo, inf, hitbox)
	if mo.hitCool then return true end

	mo.smashHp = $-1
	mo.hitCool = 16
	if mo.smashHp <= 0
		inf.atkstop = 10
		S_StartSound(mo, sfx_sbhit)

		mo.hitCool = 30
		return s.smashBallKill(mo, inf)
	end

	if inf and inf.attacktype
		inf.atkstop = 10
		
		local t, z = 0
		if hitbox.hitbox
			local h = hitbox.hitbox
			
			if h.xfling then t = h.xfling else t = 10*FRACUNIT end
			if h.yfling then z = h.yfling else z = ((inf.z-mo.z)/10) end
		else
			t = 10*FRACUNIT
			z = ((inf.z-mo.z)/10)
		end

		mo.thrustShit = {
			time = 10,
			momz = ((inf.z-mo.z)/10),
			thrust = 10*FRACUNIT,
			angle = hitbox.angle
		}
	else
		mo.thrustShit = {
			time = 10,
			momz = P_RandomRange(-5, 5)*FRACUNIT,
			thrust = 8*FRACUNIT,
			angle = mo.angle
		}
	end

	S_StartSound(mo, sfx_sbhit)
	return true
end

s.smashBallMissile = function(mo, inf, src)
	if mo.hitCool then return true end

	mo.smashHp = $-1
	mo.hitCool = 16
	if mo.smashHp <= 0
		S_StartSound(mo, sfx_sbhit)

		inf.stopmove = 30
		mo.hitCool = 30
		return s.smashBallKill(mo, src)
	end

	t = 10*FRACUNIT
	z = ((inf.z-mo.z)/10)
	mo.thrustShit = {
		time = 10,
		momz = ((inf.z-mo.z)/10),
		thrust = 10*FRACUNIT,
		angle = hitbox.angle
	}

	P_KillMobj(inf)
	S_StartSound(mo, sfx_sbhit)
	return true
end

s.smashBallKill = function(mo, i)
	if mo.type == MT_SMASHBALL_FAKE
		return s.fakeSmashBall(mo, i)
	end

	if not i
		s.respawnSmashBall(mo)
		return true
	end

	mo.realexplode = {
		time = 20,
		inf = i
	}
	
	i.atkstop = 20
	
	return true
end

s.fakeSmashBall = function(mo, inf)
	if not inf
		s.respawnSmashBall(mo)
		return true
	end

	mo.fakeexplode = 20
	inf.atkstop = 20
	return true
end