local s = SRB2Smash

s.missileThinker = function(mo)
	if mo.hitcool
		mo.hitcool = $-1
		if mo.hitcool <= 0 then mo.hitcool = nil end
	end

	if mo.stopmove
		if not mo.resumeMove
			mo.resumeMove = {
				x = mo.momx,
				y = mo.momy,
				z = mo.momz,
				state = mo.state
			}
		end

		mo.state = mo.resumeMove.state
		mo.momx = 0
		mo.momy = 0
		mo.momz = 0

		mo.stopmove = $-1
		if mo.stopmove <= 0
			if mo.shouldRepel
				mo.momx = -mo.resumeMove.x
				mo.momy = -mo.resumeMove.y
				mo.momz = -mo.resumeMove.z
			else
				mo.momx = mo.resumeMove.x
				mo.momy = mo.resumeMove.y
				mo.momz = mo.resumeMove.z
			end

			mo.repelled = true
			mo.shouldRepel = nil
			mo.stopmove = nil
		end
	end
end

s.missileRepel = function(hitbox, missile)
	if not missile or not missile.valid then return end
	if not hitbox or not hitbox.valid then return end
	
	if missile.stopmove then return end
	if missile.hitcool then return end
	
	if s.mobjDefs[missile.type] and s.mobjDefs[missile.type].norepel then return end

	if hitbox.hitbox
		if hitbox.usermo and hitbox.usermo.valid
			if missile.target == hitbox.usermo then return end
		end

		local properties = hitbox.hitbox
		if missile.priority and missile.priority > properties.priority
			missile.stopmove = 3
			missile.hitcool = 10
			hitbox.usermo.atkstop = 3

			S_StartSound(missile, sfx_s259)
			return false
		end

		if properties.hitsound
			S_StartSound(hitbox, properties.hitsound)
		else
			S_StartSound(hitbox, sfx_pstop)
		end

		if hitbox.usermo
			s.makeOwner(missile, hitbox.usermo)
			missile.color = hitbox.usermo.color
			missile.colorized = true

			hitbox.usermo.atkstop = 7
			missile.stopmove = 7
			missile.hitcool = 10
			missile.shouldRepel = true

			missile.angle = $+ANGLE_180

			// Hardcode repel
			if missile.type == MT_AIRSLASH
				missile.state = mobjinfo[MT_AIRSLASH].spawnstate
			end
		else
			missile.target = nil
		end
		
		return missile
	else
		P_KillMobj(missile)
	end
end

s.makeOwner = function(mo, owner)
	if (mo.flags & MF_MISSILE) or (mo.flags & MF_PAIN)
		mo.target = owner
		mo.user = owner
	else
		assert(nil, "Object is missing MF_MISSILE or MF_PAIN.")
	end
end