local s = SRB2Smash

s.setupTeams = function()
	if not s.isTeam() then return end

	s.teamData = {
		["red"] = {},
		["blue"] = {},
		["yellow"] = {},
		["green"] = {}
	}
	
	s.pointData = {
		["red"] = 0,
		["blue"] = 0,
		["yellow"] = 0,
		["green"] = 0,
	}

	for p in players.iterate
		if p.smashSpectate then continue end

		local teamCounts = {{#s.teamData["red"], "red"}, {#s.teamData["blue"], "blue"}}
		
		if cv_teamcount.value == 3
			table.insert(teamCounts, {#s.teamData["yellow"], "yellow"})
		elseif cv_teamcount.value >= 4
			table.insert(teamCounts, {#s.teamData["green"], "green"})
			table.insert(teamCounts, {#s.teamData["green"], "green"})
		end

		table.sort(teamCounts, function(a, b) return a[1] > b[1] end)

		if teamCounts[1] == 0
			local teamColors = {"red", "blue", "green", "yellow"}
			local teamColor = teamColors[P_RandomRange(1, 4)]
			s.joinTeam(p, teamColor)
		else
			s.joinTeam(p, teamCounts[#teamCounts][2])
		end
	end
end

s.assignTeamOnLateJoin = function(p)
	if not s.isTeam() then return end

	local teamCounts = {{#s.teamData["red"], "red"}, {#s.teamData["blue"], "blue"}}

	if cv_teamcount.value == 3
		table.insert(teamCounts, {#s.teamData["yellow"], "yellow"})
	elseif cv_teamcount.value >= 4
		table.insert(teamCounts, {#s.teamData["green"], "green"})
		table.insert(teamCounts, {#s.teamData["green"], "green"})
	end

	table.sort(teamCounts, function(a, b) return a[1] > b[1] end)

	if teamCounts[1] == 0
		local teamColors = {"red", "blue", "green", "yellow"}
		local teamColor = teamColors[P_RandomRange(1, 4)]
		s.joinTeam(p, teamColor)
	else
		s.joinTeam(p, teamCounts[#teamCounts][2])
	end
end

s.clearTeams = function()	
	s.teamData = {
		["red"] = {},
		["blue"] = {},
		["yellow"] = {},
		["green"] = {}
	}
	
	for p in players.iterate
		p.team = nil
	end
end

s.joinTeam = function(p, team)
	if not team then team = P_RandomRange(1, 4) end

	if team == "red" or team == 1
		p.team = "red"
		table.insert(s.teamData["red"], p)

		p.mo.color = SKINCOLOR_RED
	elseif team == "blue" or team == 2
		p.team = "blue"
		table.insert(s.teamData["blue"], p)

		p.mo.color = SKINCOLOR_BLUE
	elseif team == "yellow" or team == 3
		p.team = "yellow"
		table.insert(s.teamData["yellow"], p)

		p.mo.color = SKINCOLOR_YELLOW
	elseif team == "green" or team == 4
		p.team = "green"
		table.insert(s.teamData["green"], p)

		p.mo.color = SKINCOLOR_GREEN
	else
		assert(nil, 'Invalid team. Try "red", "green", "blue" or "yellow".')
	end
end

s.sameTeam = function(p, p2)
	if not p.team then return false end
	if not p2.team then return false end
	if CV_FindVar("friendlyfire").value then return false end

	if p.team == p2.team then return true end
	return false
end