local s = SRB2Smash

s.resetTimer = function()
	server.blastZones = {}

	server.bamTime = nil
	server.smashTime = nil
	server.endTimer = nil
	server.forceCamMobjs = nil
	if not server.immuneSuddenDeath then server.suddenDeath = nil end

	server.voteScreen = nil
	server.endGame = nil
	server.winningPlayer = nil
	server.winningTeam = nil
	server.immuneSuddenDeath = nil
end

s.timerThinker = function()
	if server.endTimer then s.endGameThinker() end

	if server.endGame 
		s.pointsScreen()

		for p in players.iterate do p.realtime = 0 end
		return
	end

	local playersLeft = 0
	local playerCount = 0
	local lastP
	for p in players.iterate
		if (p.lives > 0 and not p.smashSpectate and not p.mo.tempSpectate)
			playersLeft = $+1
			lastP = p
		end
		
		if not p.smashSpectate and not p.mo.tempSpectate
			playerCount = $+1
		end
	end
	
	if server.bamTime
		server.bamTime.time = $-1
		if server.bamTime.time <= 0
			server.bamTime = nil
		end
	end
	
	for mo in mobjs.iterate()
		if mo.type == MT_PLAYER and not mo.player
			playersLeft = $+1
		end
	end

	if not server.suddenDeath
		server.smashTime = $ or cv_smashtime.value*TICRATE

		if (leveltime < 4*TICRATE)
			for p in players.iterate
				p.mo.lastHit = 0

				if p.mo and p.mo.valid and not p.smashSpectate
					p.mo.button = {
						jump = 0,
						spin = 0,
						down = 0,
						up = 0,
						left = 0,
						right = 0,
						custom1 = 0,
						custom2 = 0,
						custom3 = 0,
						tossflag = 0,
					}
					
					p.mo.attacktype = nil
					p.mo.attacktime = nil
					p.powers[pw_nocontrol] = 1

					if cv_stocks.value == 1
						p.lives = cv_stockcount.value
					else
						p.lives = 127
					end
				end
			end
		end
		
		for p in players.iterate
			p.realtime = server.smashTime or 0
		end
		
		if (server.smashTime == cv_smashtime.value*TICRATE/2)
			s.spawnSmashBall(P_RandomRange(1, 3))
		end
		
		if (leveltime >= TICRATE) and not server.endTimer
			if (leveltime == TICRATE)
				for p in players.iterate do S_StartSound(nil, sfx_sthree, p) end
			elseif (leveltime == 2*TICRATE)
				for p in players.iterate do S_StartSound(nil, sfx_stwo, p) end
			elseif (leveltime == 3*TICRATE)
				for p in players.iterate do S_StartSound(nil, sfx_sone, p) end
			elseif (leveltime == 4*TICRATE)
				for p in players.iterate do S_StartSound(nil, sfx_sgo, p) end
			elseif (leveltime > 4*TICRATE)
				server.smashTime = $-1
				
				if (server.smashTime) <= 0
					for p in players.iterate 
						S_StartSound(nil, sfx_sgame, p)
					end

					server.endTimer = 6*TICRATE
				end

				if playersLeft <= 1 and playerCount > 1 and not server.endTimer
					for p in players.iterate 
						S_StartSound(nil, sfx_sgame, p)
					end
	
					server.endTimer = 6*TICRATE
				end
			end
		end
	else
		if (leveltime <= 4*TICRATE)
			for p in players.iterate
				p.mo.lastHit = 0

				if p.mo and p.mo.valid and not p.smashSpectate
					p.mo.button = {
						jump = 0,
						spin = 0,
						down = 0,
						up = 0,
						left = 0,
						right = 0,
						custom1 = 0,
						custom2 = 0,
						custom3 = 0,
						tossflag = 0,
					}
					
					p.mo.attacktype = nil
					p.mo.attacktime = nil
					p.powers[pw_nocontrol] = 1
				end
			end
		end
		
		if (leveltime == 2)
			for p in players.iterate
				if not p.smashSpectate and p.mo and p.mo.valid
					p.lives = 1
					if not p.insuddendeath
						p.mo.tempSpectate = true
					else
						p.mo.percent = 300
						p.mo.stamina = 1
						
						p.mo.tempSpectate = false
						p.smashSpectate = false
					end
				end
				
				p.insuddendeath = nil
			end
		end
		
		for p in players.iterate
			p.realtime = 0
		end

		if (leveltime == 3*TICRATE)
			for p in players.iterate do S_StartSound(nil, sfx_suddth, p) end
		elseif (leveltime == 4*TICRATE)
			for p in players.iterate do S_StartSound(nil, sfx_sgo, p) end
		end
		
		if (leveltime > 4*TICRATE)
			if playersLeft <= 1 and not server.endTimer
				for p in players.iterate
					if p.lives > 0 and not p.smashSpectate and not p.mo.tempSpectate
						p.autoWin = true
					end

					S_StartSound(nil, sfx_sgame, p)
				end

				server.endTimer = 4*TICRATE
			end
		end

		if (leveltime > 20*TICRATE) and not (leveltime%20)
			P_StartQuake(8*FRACUNIT, 21)

			local possiblePlayers = {}
			for p in players.iterate
				if p.mo and p.mo.valid and not p.smashSpectate
					table.insert(possiblePlayers, p.mo)
				end
			end

			local mo = possiblePlayers[P_RandomRange(1, #possiblePlayers)]
			local x = mo.x + P_RandomRange(-300, 300)*FRACUNIT
			local bom = P_SpawnMobj(x, mo.y, mo.ceilingz-100*FRACUNIT, MT_FBOMB)
			bom.scale = P_RandomRange(1, 5)*P_RandomRange(FRACUNIT/2, FRACUNIT)
		end
	end
end

s.endGameThinker = function()
	server.endTimer = $-1
	if server.endTimer == 5*TICRATE then S_FadeMusic(0, MUSICRATE) end

	-- hacky way to remove control from players
	for p in players.iterate()
		p.tutorialShit = nil

		if p.mo and p.mo.valid and not p.smashSpectate
			s.removeMovement(p)
			
			p.mo.attacktype = nil
			p.mo.atktimer = nil

			p.powers[pw_nocontrol] = 1

			p.mo.momx = 0
			p.mo.momy = 0
			p.mo.momz = 0
			p.mo.atkstop = server.endTimer
		end
	end
	
	if server.endTimer <= 0 and not server.endGame
		local mostPoints = 0
		local mostStocks = 0
		local suddenDeathPlayers = {}
		
		if server.suddenDeath
			for p in players.iterate
				if not p.insuddendeath
					p.playerstate = PST_DEAD
					p.lives = 0
				end
			end
		end
		
		server.tallyOrder = {}
		if s.isTeam()
			s.stockData = {
				["red"] = 0,
				["blue"] = 0,
				["yellow"] = 0,
				["green"] = 0
			}

			for p in players.iterate
				if not p.smashSpectate and p.team then s.stockData[p.team] = $+p.lives end
			end

			local teamNames = {"red", "blue"}
			if cv_teamcount.value == 3
				table.insert(teamNames, "yellow")
			elseif cv_teamcount.value >= 4
				table.insert(teamNames, "yellow")
				table.insert(teamNames, "green")
			end

			for i = 1, #teamNames
				table.insert(server.tallyOrder, {
					team = teamNames[i],
					chars = s.teamData[teamNames[i]],
					score = s.pointData[teamNames[i]],
					stocks = s.stockData[teamNames[i]],
					autoWin = false
				})

				if s.pointData[teamNames[i]] > mostPoints then mostPoints = s.pointData[teamNames[i]] end
				if s.stockData[teamNames[i]] > mostStocks then mostStocks = s.stockData[teamNames[i]] end
			end

			if cv_stocks.value
				table.sort(server.tallyOrder, function(a, b) return a.stocks > b.stocks end)
			else
				table.sort(server.tallyOrder, function(a, b) return a.score > b.score end)
			end
		else
			for p in players.iterate
				if not p.smashSpectate 
					table.insert(server.tallyOrder, {
						player = p,
						name = p.name,
						skin = p.lastSkin,
						color = p.skincolor,
						score = p.smashPoints,
						autoWin = p.autoWin or false,
						stocks = p.lives
					})

					if p.smashPoints > mostPoints then mostPoints = p.smashPoints end
					if p.lives > mostStocks then mostStocks = p.lives end
				end
			end

			if server.suddenDeath
				table.sort(server.tallyOrder, function(a, b) return a.autoWin end)
			else
				if cv_stocks.value
					table.sort(server.tallyOrder, function(a, b) return a.stocks > b.stocks end)
				else
					table.sort(server.tallyOrder, function(a, b) return a.score > b.score end)
				end
			end
		end

		local suddenDeathPlayers = {}
		for p in players.iterate
			if cv_stocks.value and p.lives == mostStocks
				p.insuddendeath = true
				table.insert(suddenDeathPlayers, p)
			end

			if not cv_stocks.value and p.smashPoints == mostPoints
				p.insuddendeath = true
				table.insert(suddenDeathPlayers, p)
			end
		end

		if #suddenDeathPlayers > 1 and not server.suddenDeath and not s.isTeam()
			server.immuneSuddenDeath = true
			server.suddenDeath = true

			COM_BufInsertText(server, "map "..gamemap.." -f")
		else
			server.voteScreen = nil
			server.endGame = true
		end

		server.smashTime = nil
		server.endTimer = nil
	end
end