// Trying to emulate kart lol
local s = SRB2Smash

rawset(_G, "VOTESTATE_SCORE", 1)
rawset(_G, "VOTESTATE_VOTING", 2)
rawset(_G, "VOTESTATE_PICKING", 3)
rawset(_G, "VOTESTATE_PICKED", 4)

s.loadVars = function()
	server.voting = true
	server.voteState = VOTESTATE_SCORE

	server.mapChoices = {}
	server.mapPicks = {}

//	server.voteTime = cv_votetime.value*TICRATE
//	server.pickTime = 0
//	server.pickMap = 0
end

s.killVars = function()
	server.voting = nil
	server.voteState = VOTESTATE_SCORE

	server.mapChoices = nil
	server.mapPicks = nil
	
	server.voteTime = nil
//	server.pickTime = nil
	server.pickMap = nil
	
	for p in players.iterate
		p.screenData = nil

		p.mapSel = nil
		p.selected = nil
	end
end

s.mapTable = function()
	local possibleMaps = {}
	
	for i = 1, #mapheaderinfo
		if mapheaderinfo[i]
			local mapHeader = mapheaderinfo[i]
			
			if mapHeader and (mapHeader.typeoflevel & TOL_SMASH)
			and not mapHeader.smashhell
				table.insert(possibleMaps, i)
			end
		end
	end
	
	return possibleMaps
end

s.mapHellTable = function()
	local possibleMaps = {}

	for i = 1, #mapheaderinfo
		if mapheaderinfo[i]
			local mapHeader = mapheaderinfo[i]
			
			if mapHeader and (mapHeader.typeoflevel & TOL_SMASH)
			and mapHeader.smashhell
				table.insert(possibleMaps, i)
			end
		end
	end

	return possibleMaps
end

s.pickMaps = function()
	local possibleMaps = s.mapTable()
	
	local alreadyPicked = {}
	
	server.mapPicks = {}
	server.mapChoices = {}
	for i = 1, 4
		local map = possibleMaps[P_RandomRange(1, #possibleMaps)]
		while alreadyPicked[tostring(map)]
			map = possibleMaps[P_RandomRange(1, #possibleMaps)]
		end

		server.mapChoices[i] = map
		server.mapPicks[i] = 0
		alreadyPicked[tostring(map)] = true
	end
	
	return server.mapChoices
end

s.gotoMapVote = function(map)
	COM_BufInsertText(server, "map "..tostring(map).." -f")
	s.killVars()
end

s.setUp = function()
	s.loadVars()
	s.pickMaps()
	
	for p in players.iterate
		p.mapSel = 1

		if not p.smashspectate--and not p.spectator
			p.selected = false
		end
	end
end

s.voteButtons = function(p)	
	p.voteButtons = $ or {
		up = 0,
		down = 0,
		jump = 0,
		spin = 0
	}

	if (p.cmd.buttons & BT_JUMP)
		p.voteButtons.jump = $+1
	else
		p.voteButtons.jump = 0
	end

	if (p.cmd.buttons & BT_SPIN)
		p.voteButtons.spin = $+1
	else
		p.voteButtons.spin = 0
	end

	if (p.cmd.forwardmove < 0)
		p.voteButtons.down = $+1
	else
		p.voteButtons.down = 0
	end

	if (p.cmd.forwardmove > 0)
		p.voteButtons.up = $+1
	else
		p.voteButtons.up = 0
	end
end

s.votePlayerThinker = function(p)
	s.voteButtons(p)

	if not server.pickTime
		if not p.selected and not p.smashSpectate
			if p.voteButtons.up == 1 or p.voteButtons.up > 10
				p.mapSel = $-1
				if p.mapSel < 1 then p.mapSel = 4 end
				S_StartSound(nil, sfx_kc4a, p)
			end

			if p.voteButtons.down == 1 or p.voteButtons.down > 10
				p.mapSel = $+1
				if p.mapSel > 4 then p.mapSel = 1 end
				S_StartSound(nil, sfx_kc4a, p)
			end

			if p.voteButtons.jump == 1
				p.selected = true
				server.mapPicks[p.mapSel] = $+1

				S_StartSound(nil, sfx_kc48, p)
			end
		else
			if p.voteButtons.spin == 1
				p.selected = false
				server.mapPicks[p.mapSel] = $-1
			end
		end
	end
end

s.voteThinker = function()
	for p in players.iterate
//		s.removeMovement(p)

		p.tutorialShit = nil
		s.pointStop(p.mo)
	end

	local smashPlayers = {}
	for p in players.iterate
		if not p.smashSpectate
			table.insert(smashPlayers, p)
		end
	end
	
	-- just go to a random map lol
	if #smashPlayers <= 0
		local map = s.mapTable()
		s.gotoMapVote(map[P_RandomRange(1, #map)])

		return true
	end

	-- ok lets actually do some shit
	if not server.voting 
		s.setUp()
	else
		if not server.voteState
			server.voteState = VOTESTATE_SCORE
			COM_BufInsertText(server, "inttime "..20+cv_votetime.value)
		elseif server.voteState == VOTESTATE_SCORE
			if not server.voteTime
				server.voteTime = 1
			end

			server.voteTime = $-1

			if server.voteTime <= 0
				if string.lower(CV_FindVar("advancemap").string) == "random"
					local maps = s.mapTable()
					local map = maps[P_RandomRange(1, #maps)]
					s.gotoMapVote(map)

					return
				end

				server.voteTime = cv_votetime.value*TICRATE
				server.voteState = VOTESTATE_VOTING
			end
		elseif server.voteState == VOTESTATE_VOTING
			server.voteTime = $-1

			for i,p in ipairs(smashPlayers)
				if not p.smashspectate
					s.votePlayerThinker(p)
				end
			end
			
			-- check if all voted
			local allVoted = 0
			for i,p in ipairs(smashPlayers)
				if p.selected == true
					allVoted = $+1
				end
			end

			if (server.voteTime <= 0) or (allVoted >= #smashPlayers)
				for i,p in ipairs(smashPlayers)
					if not p.selected and not p.smashspectate
						p.mapSel = 4
						p.selected = true
					end
				end

				server.voteTime = 10*TICRATE
				server.voteState = VOTESTATE_PICKING
			end
		elseif server.voteState == VOTESTATE_PICKING
			server.voteTime = $-1
			
			-- check if all random, or all same, if so, the map will be picked
			local allRandom = 0
			local allSame = {0, 0, 0}
			for i,p in ipairs(smashPlayers)
				if p.mapSel >= 4
					allRandom = $+1
				else
					allSame[p.mapSel] = $+1
				end
			end

			if allRandom >= #smashPlayers
				server.pickMap = P_RandomRange(1, #smashPlayers)
				
				local possibleHell = s.mapHellTable()
				server.mapChoices[4] = possibleHell[P_RandomRange(1, #possibleHell)]

				server.voteTime = 5*TICRATE
				server.voteState = VOTESTATE_PICKED
				
				for p in players.iterate
					S_StartSound(nil, sfx_s3kc3s, p)
				end
			else
				for i = 1, 3
					if allSame[i] >= #smashPlayers
						server.pickMap = 1

						server.voteTime = 5*TICRATE
						server.voteState = VOTESTATE_PICKED
						
						for p in players.iterate
							S_StartSound(nil, sfx_s3kc3s, p)
						end
					end
				end
			end

			-- Otherwise...
			if not server.pickMap
				local maxP = #smashPlayers
				server.pickMap = P_RandomRange(1, #smashPlayers)
			else
				if (server.voteTime > 6*TICRATE)
				or (server.voteTime > 4*TICRATE and not (server.voteTime%2))
				or (server.voteTime > 2*TICRATE and not (server.voteTime%4))
				or (server.voteTime > TICRATE and not (server.voteTime%6))
				or not (server.voteTime%10)
					server.pickMap = $+1
					if server.pickMap > #smashPlayers
						server.pickMap = 1
					end
					
					for p in players.iterate
						S_StartSound(nil, sfx_menu1, p)
					end
				end
			end

			if server.voteTime <= 0
				server.voteTime = 5*TICRATE
				server.voteState = VOTESTATE_PICKED

				for p in players.iterate
					S_StartSound(nil, sfx_s3kc3s, p)
				end
			end
		elseif server.voteState == VOTESTATE_PICKED
			server.voteTime = $-1

			if server.voteTime <= 0
				s.gotoMapVote(server.mapChoices[smashPlayers[server.pickMap].mapSel])
			end
		end
	end

	return true
end