local s = SRB2Smash

s.blastZoneCheck = function(p)
	if not p.mo or not p.mo.valid then return end

	p.bzShit = {
		["left"] = false,
		["right"] = false,
		["down"] = false,
		["up"] = false,
	}

	for i,mo in pairs(server.blastZones)
		if mo.type == MT_SIDEBLAST
			local dist = R_PointToDist2(p.mo.x, p.mo.y, mo.x, mo.y)
			
			if dist <= 750*FRACUNIT
				if mo.x < p.mo.x
					p.bzShit["left"] = true
				else
					p.bzShit["right"] = true
				end
			end
		elseif mo.type == MT_UPBLAST
			if (mo.z-p.mo.z) <= 400*FRACUNIT
				p.bzShit["up"] = true
			end
		else
			if (p.mo.z-mo.z) <= 400*FRACUNIT
				p.bzShit["down"] = true
			end
		end
	end

	if p.mo.subsector and p.mo.subsector.sector
		local sector = p.mo.subsector.sector or nil

		if p.mo.z <= (sector.floorheight + 400*FRACUNIT) and (GetSecSpecial(sector.special, 1) >= 6 and GetSecSpecial(sector.special, 1) <= 8)
			p.bzShit["down"] = true
			
			if p.mo.z <= (sector.floorheight + 300*FRACUNIT) and p.mo.noReuse and p.mo.noReuse["upspecial"] and not p.mo.doneGasp
				for player in players.iterate do S_StartSound(nil, sfx_augasp, player) end
				p.mo.doneGasp = true
			end
		end

		if P_IsObjectOnGround(p.mo) then p.mo.doneGasp = nil end
	end

	return p.bzShit
end

s.bzDisplay = function(v, p, c)
	if p.playerstate == PST_DEAD then return end
	if not p.mo or not p.mo.valid then return end
	if p.smashSpectate or p.mo.tempSpectate then return end

	local bzShit = p.bzShit or {
		["left"] = false,
		["right"] = false,
		["down"] = false,
		["up"] = false
	}
//	local x, y, scale = s.mobjPosOnScreen(v, p, c, p.mo)

	if bzShit["left"] == true
//		v.drawScaled(0, y>>FRACBITS, FRACUNIT/2, v.cachePatch("BWARNL"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOTOP)
		v.drawScaled(0, 100*FRACUNIT, FRACUNIT/2, v.cachePatch("BWARNL"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOTOP)
	end
	
	if bzShit["right"] == true
//		v.drawScaled(287*FRACUNIT, y>>FRACBITS, FRACUNIT/2, v.cachePatch("BWARNR"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOTOP)
		v.drawScaled(287*FRACUNIT, 100*FRACUNIT, FRACUNIT/2, v.cachePatch("BWARNR"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOTOP)
	end
	
	if bzShit["up"] == true
//		v.drawScaled(x>>FRACBITS, 0, FRACUNIT/2, v.cachePatch("BWARNU"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOTOP)
		v.drawScaled(160*FRACUNIT, 0, FRACUNIT/2, v.cachePatch("BWARNU"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOTOP)
	end
	
	if bzShit["down"] == true
//		v.drawScaled(x>>FRACBITS, 167*FRACUNIT, FRACUNIT/2, v.cachePatch("BWARND"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOTOP)
		v.drawScaled(160*FRACUNIT, 167*FRACUNIT, FRACUNIT/2, v.cachePatch("BWARND"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOTOP)
	end
end