local s = SRB2Smash

s.drawWinningChar = function(v, p, x, y)
	local pic = v.cachePatch(s.chars[p.skin]["hud"].."HUD" or "SONICHUD")
	v.drawScaled((x-80)*FRACUNIT, (y+10)*FRACUNIT, FRACUNIT+(FRACUNIT/2), pic, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(p.skin, p.color))
	v.drawNameTag(x, y+125, p.name.." WINS!", V_SNAPTOLEFT|V_SNAPTOBOTTOM, SKINCOLOR_BLUE, SKINCOLOR_RED)
end

s.drawCharData = function(v, p, player, win, i)
	local x, y = server.pointHud.pointsX, 10+(i*16)-(p.screenData and p.screenData.yscore or 0)

	v.drawFill(x, y, 151, 1, 1)
	v.draw(x+5, y+9, v.getSprite2Patch(player.skin, SPR2_LIFE), V_SNAPTORIGHT|V_SNAPTOTOP, v.getColormap(player.skin, player.color))

	local str = i..": "
	if cv_stocks.value == 1
		str = $+player.stocks.." stocks, "
	else
		str = $+player.score.." points, "
	end

	local p2 = player.player
	str = $+p2.finalScoreStuff.ringtotal.." total rings, "
	str = $+p2.finalScoreStuff.maxcombo.." highest combo, "
	str = $+p2.finalScoreStuff.totaldmgtaken.."% taken,\n"
	str = $+p2.finalScoreStuff.totaldmgdealt.."% dealt, "
	str = $+p2.finalScoreStuff.parries.." parries, "

	local landedAttacks = p2.finalScoreStuff.attackshit
	local doneAttacks = p2.finalScoreStuff.attacksdone/FRACUNIT

	if (doneAttacks <= 0)
		str = $+"0% accuracy"
	else
		str = $+((landedAttacks/doneAttacks)*100)/FRACUNIT.."% accuracy"
	end

	v.drawString(x+20, y+2, str, V_SNAPTORIGHT|V_SNAPTOTOP, "small-thin")
end

s.drawWinningTeam = function(v, team, x, y)
	local teamDefs = s.teamData[team]

	for i = 1, 3
		if not teamDefs[i] or not teamDefs[i].valid then continue end

		local pic = v.cachePatch(s.chars[teamDefs[i].lastSkin]["hud"].."HUD" or "SONICHUD")
		v.drawScaled(((x-80) + i*10)*FRACUNIT, (y+10)*FRACUNIT, FRACUNIT+(FRACUNIT/2), pic, V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(teamDefs[i].lastSkin, teamDefs[i].skincolor))
		v.drawNameTag(x, y+125, "TEAM "..team:upper().." WINS!", V_SNAPTOLEFT|V_SNAPTOBOTTOM, _G["SKINCOLOR_"..team:upper()], SKINCOLOR_GOLD)
	end
end

s.drawTeamData = function(v, teamData, p, i)
	local x, y = server.pointHud.pointsX, 10+(i*16)-(p.screenData and p.screenData.yscore or 0)

	v.drawFill(x, y, 151, 1, 1)
	v.drawScaled((x+5)*FRACUNIT, (y+9)*FRACUNIT, FRACUNIT/3, v.getSpritePatch(SPR_THOK), V_SNAPTORIGHT|V_SNAPTOTOP, v.getColormap("sonic", _G["SKINCOLOR_"..teamData.team:upper()]))

	local str = ""
	if cv_stocks.value == 1
		str = i..": "..teamData.stocks.." Stocks"
	else
		str = i..": "..teamData.points.." Points"
	end

	v.drawString(x+45, y+2, str, V_SNAPTORIGHT|V_SNAPTOTOP)
end

s.pointHud = function(v, p)
//	v.draw(0, 0, v.cachePatch("POINTBG"), V_SNAPTORIGHT|V_SNAPTOTOP)

	if s.isTeam()
		v.drawScaled(0, 0, 2*FRACUNIT, v.cachePatch("SKY2"), V_SNAPTORIGHT|V_SNAPTOTOP)
		s.drawWinningTeam(v, server.tallyOrder[1].team, server.pointHud.winnerX, 20)

		for i = 1, #server.tallyOrder
			s.drawTeamData(v, server.tallyOrder[i], p, i)
		end
	else
		local pData = server.tallyOrder

		local x = s.chars[pData[1].skin]["winbg"][1]*FRACUNIT
		local y = s.chars[pData[1].skin]["winbg"][2]*FRACUNIT
		local patchData = v.cachePatch(s.chars[pData[1].skin]["winbg"][3])
		v.drawScaled(x, y, 2*FRACUNIT, patchData, V_SNAPTORIGHT|V_SNAPTOTOP)
		s.drawWinningChar(v, pData[1], server.pointHud.winnerX, 20)

		for i,player in pairs(pData)
			s.drawCharData(v, p, player, false, i)
		end
	end

	if p.screenData and p.screenData.ready then v.drawString(160, 20, "Ready for the next game!", V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER, "center") end
end