local s = SRB2Smash

local function smashPlayers()
	local smashPlayers = {}
	for player in players.iterate
		if player.mo and player.mo.valid
		and not player.smashSpectate and not player.mo.tempSpectate
			table.insert(smashPlayers, player)
		end
	end
	
	return smashPlayers
end

local function drawPlayer(v, player, position)
	local P_HUD_X, P_HUD_Y = 5 + ((position-1)*80), 160

	if player.hudshit and player.hudshit["hit"] and player.hudshit["hit"] > 0
		P_HUD_X = $+player.hudshit["randhudx"]
		P_HUD_Y = $+player.hudshit["randhudy"]
	end

	v.draw(P_HUD_X, P_HUD_Y, v.cachePatch("SMSHHUD"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(player.mo.skin, player.skincolor))
	v.drawScaled((P_HUD_X+18)*FRACUNIT, (P_HUD_Y+31)*FRACUNIT, FRACUNIT/2, v.getSprite2Patch(player.realmo.skin, SPR2_SIGN), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(player.mo.skin, player.skincolor))
	
	-- Item
	if player.mo.curItem and player.mo.curItem ~= "none"
		local itemDefs = s.items[player.mo.curItem]
		v.drawScaled((P_HUD_X+18)*FRACUNIT, (P_HUD_Y+31)*FRACUNIT, FRACUNIT/4, v.getSpritePatch(itemDefs.hud[1], itemDefs.hud[2] or A, itemDefs.hud[3] or nil), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
	end

	-- Score
	if player.smashPoints
		v.drawString(P_HUD_X+35, P_HUD_Y+3, tostring(player.smashPoints), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "small-thin")
	else
		v.drawString(P_HUD_X+35, P_HUD_Y+3, "0", V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "small-thin")
	end

	-- Rings
	if player.mo and player.mo.valid
		v.drawScaled((P_HUD_X+35)*FRACUNIT, (P_HUD_Y+8)*FRACUNIT, FRACUNIT/4, v.cachePatch("SMSHRING"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
		if player.mo.smashRings
			if player.mo.smashRings >= 30
				v.drawString(P_HUD_X+40, P_HUD_Y+8, "30", V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_GREENMAP, "small-thin")
			elseif player.mo.lastHit >= 20*TICRATE
				if (leveltime%2)
					v.drawString(P_HUD_X+40, P_HUD_Y+8, tostring(player.mo.smashRings), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_REDMAP, "small-thin")
				end
			else
				v.drawString(P_HUD_X+40, P_HUD_Y+8, tostring(player.mo.smashRings), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "small-thin")
			end
		else
			v.drawString(P_HUD_X+44, P_HUD_Y+8, "0", V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "small-thin")
		end
	end

	-- Hud Shaking
	if player.hudshit
		if player.hudshit["-1"] > 0
			v.drawString(P_HUD_X+40, P_HUD_Y-8+(player.hudshit["-1"]/3), "-1", V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_BLUEMAP)
		elseif player.hudshit["+1"] > 0
			v.drawString(P_HUD_X+40, P_HUD_Y-8+(player.hudshit["+1"]/3), "+1", V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_REDMAP)
		end
	end

	-- FS Meter
	if cv_fsmeter.value
		local fsMtr = player.mo.fsMeter*49/100+(1/2)
		v.drawFill(P_HUD_X+32, P_HUD_Y+17, 50, 2, V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM|31)
		v.drawFill(P_HUD_X+32, P_HUD_Y+16, fsMtr, 2, V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM|54)
	end

	-- Stocks
	if cv_stocks.value
		for i = 1, player.lives
			v.drawScaled((P_HUD_X+31+(i*9))*FRACUNIT, (P_HUD_Y+18)*FRACUNIT, FRACUNIT/2, v.getSprite2Patch(player.realmo.skin, SPR2_LIFE), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(player.mo.skin, player.skincolor))
		end
	end

	local percentTxt = tostring(player.mo.percent)
	local staminaTxt = tostring(player.mo.stamina)
	
	-- theres like a cool font i made for this but im too tired for this shit rn
	local showPercent = true
	if player.mo and player.mo.valid
		if player.mo.killed then showPercent = false end
	end

	if player.playerstate == PST_DEAD then showPercent = false end
	
	if showPercent
		if s.usesPercent()
			v.drawString(P_HUD_X+40, P_HUD_Y+20, percentTxt.."%", V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
		elseif s.usesStamina()
			v.drawString(P_HUD_X+40, P_HUD_Y+20, staminaTxt.."HP", V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
		end
	end
	
	-- Skin HUDs
	if player.mo and player.valid
		local skin = s.chars[player.mo.skin] or {}
		if skin["hudthinker"] then skin["hudthinker"](player.mo, P_HUD_X, P_HUD_Y) end
	end
end

local function drawSidePlayer(v, player, position)
	local P_HUD_X, P_HUD_Y = 3 + ((position-1)*38), 171

	if player.hudshit and player.hudshit["hit"] and player.hudshit["hit"] > 0
		P_HUD_X = $+(player.hudshit["randhudx"]/2)
		P_HUD_Y = $+(player.hudshit["randhudy"]/2)
	end

	v.drawScaled(P_HUD_X*FRACUNIT, P_HUD_Y*FRACUNIT, FRACUNIT/2, v.cachePatch("SMSHHUD"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(player.mo.skin, player.skincolor))
	v.drawScaled((P_HUD_X+9)*FRACUNIT, (P_HUD_Y+15)*FRACUNIT, FRACUNIT/4, v.getSprite2Patch(player.realmo.skin, SPR2_SIGN), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(player.mo.skin, player.skincolor))
	
	-- Item
	if player.mo.curItem and player.mo.curItem ~= "none"
		local itemDefs = s.items[player.mo.curItem]
		v.drawScaled((P_HUD_X+9)*FRACUNIT, (P_HUD_Y+15)*FRACUNIT, FRACUNIT/8, v.getSpritePatch(itemDefs.hud[1], itemDefs.hud[2] or A, itemDefs.hud[3] or nil), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
	end

	-- Rings
	if player.mo and player.mo.valid
		v.drawScaled((P_HUD_X+18)*FRACUNIT, (P_HUD_Y+4)*FRACUNIT, FRACUNIT/8, v.cachePatch("SMSHRING"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
		if player.mo.smashRings
			if player.mo.smashRings >= 30
				v.drawString(P_HUD_X+20, P_HUD_Y+4, "30", V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_GREENMAP, "small-thin")
			elseif player.mo.lastHit >= 20*TICRATE
				if (leveltime%2)
					v.drawString(P_HUD_X+20, P_HUD_Y+4, tostring(player.mo.smashRings), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_REDMAP, "small-thin")
				end
			else
				v.drawString(P_HUD_X+20, P_HUD_Y+4, tostring(player.mo.smashRings), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "small-thin")
			end
		else
			v.drawString(P_HUD_X+20, P_HUD_Y+4, "0", V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM, "small-thin")
		end
	end

	if player.hudshit
		if player.hudshit["-1"] > 0
			v.drawString(P_HUD_X+20, P_HUD_Y-4+(player.hudshit["-1"]/3), "-1", V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_BLUEMAP)
		elseif player.hudshit["+1"] > 0
			v.drawString(P_HUD_X+20, P_HUD_Y-4+(player.hudshit["+1"]/3), "+1", V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_REDMAP)
		end
	end

	-- FS Meter
	if cv_fsmeter.value
		local fsMtr = player.mo.fsMeter*29/100+(1/2)
		v.drawFill(P_HUD_X+16, P_HUD_Y+9, 30, 2, V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM|31)
		v.drawFill(P_HUD_X+16, P_HUD_Y+8, fsMtr, 2, V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM|54)
	end

	-- Stocks
	if cv_stocks.value
		for i = 1, player.lives
			v.drawScaled((P_HUD_X+16+(i*4))*FRACUNIT, (P_HUD_Y+9)*FRACUNIT, FRACUNIT/4, v.getSprite2Patch(player.realmo.skin, SPR2_LIFE), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM, v.getColormap(player.mo.skin, player.skincolor))
		end
	end

	local percentTxt = tostring(player.mo.percent)
	local staminaTxt = tostring(player.mo.stamina)

	-- theres like a cool font i made for this but im too tired for this shit rn
	local showPercent = true
	if player.mo and player.mo.valid
		if player.mo.killed then showPercent = false end
	end

	if player.playerstate == PST_DEAD then showPercent = false end

	if showPercent
		if s.usesPercent()
			v.drawString(P_HUD_X+20, P_HUD_Y+10, percentTxt.."%", V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
		elseif s.usesStamina()
			v.drawString(P_HUD_X+20, P_HUD_Y+10, staminaTxt.."HP", V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM)
		end
	end
end

local function drawScreenKo(v, mo)
	if not mo.screenKO then return end
	
	local time = mo.screenKO.timer
	local x, y, scale, ang = 150, 0, FRACUNIT, mo.screenKO.randAng
	if time <= 35
		y = (time*2)
		scale = ((time*FRACUNIT)/35)*4
	elseif time <= 70
		y = 70
		scale = 4*FRACUNIT
	elseif time <= 85
		y = time
		scale = 4*FRACUNIT
	else
		y = 85+((time-85)*5)
		scale = 4*FRACUNIT
	end

	local patch = mo.player and v.getSprite2Patch(mo.skin, SPR2_DRWN, nil, A, 0, ang) or v.getSpritePatch(mo.sprite, A)
	v.drawScaled(x*FRACUNIT, (y+50)*FRACUNIT, scale, patch, V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER, v.getColormap(mo.skin, mo.player and mo.player.skincolor or mo.color)) 
end

s.strongHit = function(v, p)
	local color = v.getColormap("sonic", server.bamTime.color)
	local time = server.bamTime.time

	if time > 10
		v.drawScaled(0, 0, FRACUNIT, v.cachePatch("STRONG"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM, color)
	elseif time >= 8
		v.drawScaled(0, 0, FRACUNIT, v.cachePatch("STRONG"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_20TRANS, color)
	elseif time >= 6
		v.drawScaled(0, 0, FRACUNIT, v.cachePatch("STRONG"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_40TRANS, color)
	elseif time >= 4
		v.drawScaled(0, 0, FRACUNIT, v.cachePatch("STRONG"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_60TRANS, color)
	elseif time >= 2
		v.drawScaled(0, 0, FRACUNIT, v.cachePatch("STRONG"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_80TRANS, color)
	else
		v.drawScaled(0, 0, FRACUNIT, v.cachePatch("STRONG"), V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_90TRANS, color)
	end
end

s.statHud = function(v, p, cam)
	hud.disable("rings")
	hud.disable("lives")
	
	if server.bamTime then s.strongHit(v, p) end

	if p.mo and p.mo.valid
		local fighters = smashPlayers()

		-- Screen KOs
		for k,p in ipairs(fighters)
			if p and p.valid and p.mo and p.mo.valid then drawScreenKo(v, p.mo) end
		end

		if #fighters <= 4
			for i,player in ipairs(fighters)
				drawPlayer(v, player, i)
			end
		else
			drawSidePlayer(v, p, 1)

			local fightersWithoutP = {}
			for k,v in ipairs(fighters)
				if v ~= p then table.insert(fightersWithoutP, v) end
			end

			if #fightersWithoutP
				for i = 1, #fightersWithoutP
					drawSidePlayer(v, fightersWithoutP[i], i+1)
				end
			end
		end

		-- Intro Text
		if server.suddenDeath
			if (leveltime > 3*TICRATE) and (leveltime < 4*TICRATE)
				v.drawNameTag(80, 180, "SUDDEN DEATH", V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM, SKINCOLOR_BLUE, SKINCOLOR_RED)
			elseif (leveltime >= 4*TICRATE) and (leveltime < 5*TICRATE)
				v.drawNameTag(150, 180, "GO!", V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM, SKINCOLOR_BLUE, SKINCOLOR_RED)
			end
		else
			if (leveltime > TICRATE) and (leveltime < 2*TICRATE)
				v.drawNameTag(160, 180, "3", V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM, SKINCOLOR_BLUE, SKINCOLOR_RED)
			elseif (leveltime > 2*TICRATE) and (leveltime < 3*TICRATE)
				v.drawNameTag(160, 180, "2", V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM, SKINCOLOR_BLUE, SKINCOLOR_RED)
			elseif (leveltime > 3*TICRATE) and  (leveltime < 4*TICRATE)
				v.drawNameTag(160, 180, "1", V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM, SKINCOLOR_BLUE, SKINCOLOR_RED)
			elseif (leveltime > 4*TICRATE) and  (leveltime < 7*TICRATE)
				v.drawNameTag(150, 180, "GO!", V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM, SKINCOLOR_BLUE, SKINCOLOR_RED)
			end
		end
	end
end