local s = SRB2Smash

local function smashPlayers()
	local smashPlayers = {}
	for player in players.iterate
		if not player.smashSpectate
			table.insert(smashPlayers, player)
		end
	end
	
	return smashPlayers
end

local function DrawMapPics(i, v)
	if i < 4
		local mapPic = v.cachePatch(s.getMapFromInt(tonumber(server.mapChoices[i])).."P")
		v.drawScaled(250*FRACUNIT, (i*50*FRACUNIT)-50*FRACUNIT, FRACUNIT/2, mapPic, V_SNAPTORIGHT|V_SNAPTOTOP)
		v.drawString(250*FRACUNIT, (i*50*FRACUNIT), G_BuildMapName(tonumber(server.mapChoices[i])), V_SNAPTORIGHT|V_SNAPTOTOP, "thin-fixed")
	else
		v.drawScaled(250*FRACUNIT, (i*50*FRACUNIT)-50*FRACUNIT, FRACUNIT/2, v.cachePatch("BLANKLVL"), V_SNAPTORIGHT|V_SNAPTOTOP)
		v.drawString(250*FRACUNIT, 40*FRACUNIT+(i*50*FRACUNIT), "???", V_SNAPTORIGHT|V_SNAPTOTOP, "fixed")
	end
end

local function DrawPlayerSel(i, v)
	local player = smashPlayers()[server.pickMap]
	if player and player.valid and player.mapSel == i
		v.drawNum(250, (i-1)*50, i, V_SNAPTORIGHT|V_SNAPTOTOP|V_YELLOWMAP)
		v.drawScaled(250*FRACUNIT, (i*50*FRACUNIT)-50*FRACUNIT, FRACUNIT/2, v.cachePatch("SLCT1LVL"), V_SNAPTORIGHT|V_SNAPTOTOP)
		v.draw(250, (i-1)*50, v.cachePatch("EXITICON"), V_SNAPTOLEFT|V_SNAPTOTOP)
	else
		v.drawNum(250, (i-1)*50, i, V_SNAPTORIGHT|V_SNAPTOTOP)
		v.drawScaled(250*FRACUNIT, (i*50*FRACUNIT)-50*FRACUNIT, FRACUNIT/2, v.cachePatch("SLCT2LVL"), V_SNAPTORIGHT|V_SNAPTOTOP)
	end
end

s.voteHud = function(v)	
	-- Background
	for i = 0, 10
		for k = 0, 10
			v.draw(i*136, k*32, v.cachePatch("SRB2BACK"), V_SNAPTOTOP|V_SNAPTOLEFT)
		end
	end

	local x, y = -64+(leveltime%64), 136
	v.drawScaled(x*FRACUNIT, y*FRACUNIT, 2*FRACUNIT, v.cachePatch("TUTORIAL2"), V_SNAPTOBOTTOM)

	x = -(leveltime%64)
	v.drawScaled(x*FRACUNIT, 0, 2*FRACUNIT, v.cachePatch("TUTORIAL1"), V_SNAPTOTOP)

	-- Voting shit
	if server and server.valid and server.voting
		if server.voteState > 1
			local p = consoleplayer

			-- Players
			local smashPlayers = smashPlayers()

			-- Levels
			for i = 1, 4
				if server.voteState == VOTESTATE_VOTING
					DrawMapPics(i, v)
					
					v.drawNum(250, (i-1)*50, i, V_SNAPTORIGHT|V_SNAPTOTOP)
					
					if p.mapSel == i
						v.drawScaled(250*FRACUNIT, (i*50*FRACUNIT)-50*FRACUNIT, FRACUNIT/2, v.cachePatch("SLCT1LVL"), V_SNAPTORIGHT|V_SNAPTOTOP)
					else
						v.drawScaled(250*FRACUNIT, (i*50*FRACUNIT)-50*FRACUNIT, FRACUNIT/2, v.cachePatch("SLCT2LVL"), V_SNAPTORIGHT|V_SNAPTOTOP)
					end
					
					v.drawString(160, 190, G_TicsToSeconds(server.voteTime).." seconds left", V_SNAPTOBOTTOM|V_SNAPTOLEFT, "center")
				elseif server.voteState == VOTESTATE_PICKING
					DrawMapPics(i, v)
					DrawPlayerSel(i, v)
				elseif server.voteState == VOTESTATE_PICKED
					local mapPic = v.cachePatch(s.getMapFromInt(tonumber(server.mapChoices[i])).."P")
					v.drawScaled(250*FRACUNIT, (i*50*FRACUNIT)-50*FRACUNIT, FRACUNIT/2, mapPic, V_SNAPTORIGHT|V_SNAPTOTOP)

					DrawPlayerSel(i, v)
				end
			end

			for i,player in ipairs(smashPlayers)
				if player.mapSel and player.selected
					v.draw(30, i*16, v.getSprite2Patch(player.lastSkin or "sonic", SPR2_LIFE), V_SNAPTOLEFT|V_SNAPTOTOP, v.getColormap(player.lastSkin or "sonic", player.skincolor))

					if server.pickMap and i == server.pickMap
						v.drawNum(50, (i*16)-6, tonumber(player.mapSel), V_SNAPTOLEFT|V_SNAPTOTOP|V_YELLOWMAP)
						v.draw(50, (i*16)-6, v.cachePatch("EXITICON"), V_SNAPTOLEFT|V_SNAPTOTOP)
					else
						v.drawNum(50, (i*16)-6, tonumber(player.mapSel), V_SNAPTOLEFT|V_SNAPTOTOP)
					end
				end
			end
		end
	end
end