addHook("MapChange", function()
	if not SRB2Smash.isSmash() then return end
	SRB2Smash.killVars()
	SRB2Smash.resetTimer()

	SRB2Smash.resetPlayers()
end)

addHook("MapLoad", function()
	if not SRB2Smash.isSmash() then return end
	SRB2Smash.resetFsLighting()

	if SRB2Smash.isTeam()
		SRB2Smash.clearTeams()
		SRB2Smash.setupTeams()
	end
end)

addHook("PostThinkFrame", function()
	for p in players.iterate
		if p.playerstate == PST_DEAD then return end
		if not p.mo or not p.mo.valid then return end
		if p.smashSpectate or p.mo.tempSpectate then return end
		SRB2Smash.hitboxThinker(p)
	end
end)

addHook("ThinkFrame", function()
	if not SRB2Smash.isSmash() then return end

	SRB2Smash.itemThink()
	SRB2Smash.fsLighting()
	SRB2Smash.timerThinker()
end)

addHook("MobjThinker", SRB2Smash.smashBallThinker, MT_SMASHBALL)
addHook("MobjThinker", SRB2Smash.smashBallThinker, MT_SMASHBALL_FAKE)
addHook("MobjThinker", SRB2Smash.smashBallGrounded, MT_SMASHBALL_GROUNDED)

addHook("MobjThinker", SRB2Smash.ringThinker, MT_RING)
addHook("MobjThinker", SRB2Smash.ringThinker, MT_SMASH_RING)

for i = 1, #mobjinfo-1
	if mobjinfo[i].flags & MF_MISSILE
		addHook("MobjThinker", SRB2Smash.missileThinker, i)
	end
end